 OakLeaf is an implementation of robust statistical methods in Fortran

 Documentation can be found in doc/ as well as at

    http://integral.physics.muni.cz/oakleaf/




 BUILD


$ autoreconf -i
$ ./configure FCFLAGS="-std=f2008 -Wall -g -p -no-pie -fcheck=all -fimplicit-none -fbacktrace -ffpe-trap=invalid,zero,overflow" --prefix=/scratch/opt
$ make
# make install

program eparam

  use fmm
  use iromberg

  implicit none
  integer, parameter :: kind = selected_real_kind(15)
  real(kind), parameter :: pi = 4.0_kind*atan(1.0_kind)

  real(kind) :: a,b,tol,s
  integer :: flag

!  a = 0
!  b = 2*atan(1.0_kind)
!  tol = 1e-10
!  write(*,*) romberg(rtest,a,b,tol,iflag=flag),flag
!  stop 0

  a = 0.5
  b = 2
  tol = 1e-7

  s = fmin(a,b,negentropy_gauss,tol)
  write(*,'(a,2f7.4)') "Maximum of entropy for Normal distribution:",s,s**2

  s = fmin(a,b,negentropy_huber,tol)
  write(*,'(a,2f7.4)') "Maximum of entropy for Huber's minimax:",s,s**2

  s = fmin(a,b,negentropy_tukey,tol)
  write(*,'(a,2f7.4)') "Maximum of entropy for Tukey's biweight:",s,s**2

!  write(*,'(a,2f7.4)') "Effective beta for Tukey**2:",beta_tukey2()
!  write(*,'(a,2f7.4)') "Effective beta for Tukey*Normal:",beta_tukeynorm()

  a = -6
  b = 6
  tol = 1e-5
  write(*,*) "Normalisation for Tukey:", norm_tukey(), &
       romberg(fun_tukey,a,b,tol,iflag=flag)

  a = 0
  b = 7
  write(*,*) "Effective beta for Tukey**2:",beta_tukey2(), &
       romberg(sig_tukey,a,b,tol,iflag=flag)

contains

  function negentropy_gauss(x)

    use rfun

    real(kind) :: negentropy_gauss
    real(kind), intent(in) :: x

    negentropy_gauss = - x**2/2*exp(-x**2/2)

  end function negentropy_gauss

  function negentropy_huber(x)

    use rfun
    real(kind) :: negentropy_huber
    real(kind), intent(in) :: x

    negentropy_huber = - ihuber(x)*exp(-ihuber(x))

  end function negentropy_huber

  function negentropy_tukey(x)

    use rfun
    real(kind) :: negentropy_tukey
    real(kind), intent(in) :: x

    negentropy_tukey = - itukey(x)*exp(-itukey(x))

  end function negentropy_tukey


  function beta_tukey2() result(beta)

    use rfun
    real(kind) :: x, s, snorm, beta
    integer :: i

    s = 0
    snorm = 0
    do i = 0, 600000
       x = i / 1e5
       s = s + tukey(x)**2*exp(-itukey(x))
!       snorm = snorm + exp(-tukey(x)**2/2)
!       s = s + itukey(x)*exp(-itukey(x))
       snorm = snorm + exp(-itukey(x))
!       s = s + x**2*exp(-x**2/2)
!       snorm = snorm + exp(-x**2/2)

    end do
!    snorm = sqrt(2*pi)
    beta = s  / snorm !/ 1e5

  end function beta_tukey2

  function beta_tukeynorm() result(beta)

    use rfun
    real(kind) :: x, s, snorm, beta
    integer :: i

    s = 0
    snorm = 0
    do i = 0, 10*600000
       x = i / 1e6
       !s = s + 2*tukey(x)*x*exp(-itukey(x))
       !snorm = snorm + exp(-itukey(x))
       s = s + x**2*exp(-x**2/2)
!       snorm = snorm +
    end do
    beta = 2 * s / sqrt(2*pi) !/ snorm

  end function beta_tukeynorm

  function norm_tukey() result(gama)

    use rfun

    real(kind) :: x, s, gama
    integer :: i

    s = 0
    do i = 0, 600000
       x = i / 1e5
       s = s + exp(-itukey(x))
!       s = s + exp(-tukey(x)**2/2)
!       s = s + exp(-x**2/2)
    end do
    gama = 2 * s / 1e5

  end function norm_tukey

  function fun_tukey(x) result(f)

    use rfun

    real(kind) :: f
    real(kind), intent(in) :: x

    if( abs(x) <= 6 ) then
       f = exp(-itukey(x)) !/ 3.73253078 !/ 2.6496858221126
!       f = exp(-x**2/2) !/ sqrt(2*pi)
!       f = exp(-tukey(x)**2/2)
    else
       f = 0
    end if

  end function fun_tukey

  function sig_tukey(x) result(f)

    use rfun

    real(kind) :: f
    real(kind), intent(in) :: x

    if( abs(x) <= 6 ) then
!       f = itukey(x)*exp(-itukey(x)) / 3.73253078
!       f = tukey(x)**2*exp(-itukey(x)) / 3.73253078
       f = x**2*exp(-x**2/2) / sqrt(2*pi)
    else
       f = 0
    end if
    f = x**2* exp(-x**2/2) / sqrt(2*pi)

  end function sig_tukey

  function rtest(x) result(f)

    use rfun

    real(kind) :: f
    real(kind), intent(in) :: x

    f = sin(x)
    return

  end function rtest

end program eparam

program testrfactor

  use oakleaf
  use noise
  use toolbox
  use testsuite

  implicit none

  integer, parameter :: rp = selected_real_kind(15)
  character(len=15), parameter :: fmt = '(a,l3)'
  integer :: voltage

  call randomnoise

  call get_environment_variable("VOLTAGE",status=voltage)

  if( .not. (voltage == 0) ) then

     call tester(build)

  else

!     call tester(poisson3)
     call single
     call identity
     call tester(bmuma)
     call tester(poisson1)
     call tester(poisson2)

  end if


contains


  subroutine build

    real(rp), dimension(:), allocatable :: x,dx,y,dy
    type(suite) :: poi
    logical :: cond

    integer :: n,l
    real(rp) :: mean

    mean = 10**6

    n = 10**4
    allocate(x(n),dx(n),y(n),dy(n))

    do l = 1, n
       x(l) = pnoise(mean)
       y(l) = pnoise(mean)
    end do

    write(*,*) 'Po(10**6)  n=',n
    dx = sqrt(x)
    dy = sqrt(y)
    call poi%poistat(x,dx,y,dy)
    cond = abs(poi%t - 1) < 5*poi%dt
    write(*,'(a,l2)') 'TEST build PASS:',cond
    write(*,*)
    deallocate(x,dx,y,dy)

  end subroutine build


  subroutine poisson1

    real(rp), dimension(:), allocatable :: x,dx,y,dy
    type(suite) :: std, rob, qt, stdw, robw, poi
    logical :: cond

    integer :: m,n,l
    real(rp) :: mean, fac

    mean = 10**4
    fac = 4

    do m = 1,6
       n = 10**m
       allocate(x(n),dx(n),y(n),dy(n))

       do l = 1, n
          x(l) = pnoise(mean)
          y(l) = pnoise(mean/fac)
       end do

       write(*,*) 'Po(10**6)  n=',n
       call std%stdstat(x/y)
       call rob%robstat(x/y)
       call qt%qtstat(x/y)

       dx = sqrt(x)
       dy = sqrt(y)
!       dx = 1
!       dy = 1
       call stdw%stdwstat(x/y,sqrt(dx**2 + fac**2*dy**2))
       call robw%robwstat(x/y,sqrt(dx**2 + fac**2*dy**2))
       call poi%poistat(x,dx,y,dy)
       cond = abs(poi%t - fac) < 5*poi%dt
       write(*,'(a,i0,a,l2)') 'TEST poisson1(',n,') PASS:',cond
       write(*,*)
       deallocate(x,dx,y,dy)
    end do

  end subroutine poisson1

  subroutine poisson2

    real(rp), dimension(:), allocatable :: x,dx,y,dy
    type(suite) :: std, rob, qt, stdw, robw, poi
    logical :: cond

    integer :: m,n,l,k
    real(rp) :: mean, fac

    mean = 10**4
    fac = 4

    do m = 1,6
       n = 10**m
       allocate(x(n),dx(n),y(n),dy(n))

       k = int(0.9*n)
       do l = 1, k
          x(l) = pnoise(mean)
          y(l) = pnoise(mean/fac)
       end do
       do l = k+1, n
          x(l) = pnoise(mean)
          y(l) = pnoise(10*mean)
       end do

       write(*,*) '0.9*Po(10000)+0.1*Po(10**5)  n=',n
       call std%stdstat(x/y)
       call rob%robstat(x/y)
       call qt%qtstat(x/y)

       dx = sqrt(x)
       dy = sqrt(y)
       call stdw%stdwstat(x/y,sqrt(dx**2 + fac**2*dy**2))
       call robw%robwstat(x/y,sqrt(dx**2 + fac**2*dy**2))
       call poi%poistat(x,dx,y,dy)
       cond = abs(poi%t - fac) < 5*poi%dt
       write(*,'(a,i0,a,l2)') 'TEST poisson2(',n,') PASS:',cond
       write(*,*)
       deallocate(x,dx,y,dy)
    end do

  end subroutine poisson2

  subroutine poisson3

    real(rp), dimension(:), allocatable :: x,dx,y,dy
    type(suite) :: poi
    logical :: cond

    integer :: m,n,l
    real(rp) :: mean, fac

    mean = 8
    fac = 4

    do m = 1,6
       n = 10**m
       allocate(x(n),dx(n),y(n),dy(n))

       do l = 1, n
          x(l) = pnoise(mean)
          y(l) = pnoise(mean/fac)
       end do

       write(*,*) 'Po(8)  n=',n
       dx = 1
       dy = 1
       call poi%poistat(x,dx,y,dy)
       cond = abs(poi%t - fac) < 5*poi%dt
       write(*,'(a,i0,a,l2)') 'TEST poisson3(',n,') PASS:',cond
       write(*,*)
       deallocate(x,dx,y,dy)
    end do

  end subroutine poisson3

  subroutine bmuma

    real(rp), dimension(6) :: x,dx,y,dy
    type(suite) :: std, rob, qt, stdw, robw, poi
    logical :: cond

    x = [1.58682E+07, 4.53635E+05, 4.41066E+05, 4.14017E+05, &
         4.55078E+05, 3.11341E+05]
    dx = [ 3.990E+03, 712., 704., 682., 713., 608. ]
    y = [ 1.51535E+06, 44100., 42143., 39892., 42909., 30737. ]
    dy = [ 1.233E+03, 221., 216., 209., 218., 189. ]

    write(*,*) 'BM UMa'
    call std%stdstat(x/y)
    call rob%robstat(x/y)
    call qt%qtstat(x/y)

    call stdw%stdwstat(x/y,sqrt(dx**2 + dy**2))
    call robw%robwstat(x/y,sqrt(dx**2 + dy**2))
    call poi%poistat(x,dx,y,dy)
    cond = abs(poi%t - 10.463) < 5*poi%dt
    write(*,'(a,l2)') 'TEST bmuma PASS:',cond
    write(*,*)

  end subroutine bmuma

  subroutine single

    real, dimension(6) :: x,dx,y,dy
    real :: t,dt,s,c
    integer :: flag

    x = [1.58682E+07, 4.53635E+05, 4.41066E+05, 4.14017E+05, &
         4.55078E+05, 3.11341E+05]
    dx = [ 3.990E+03, 712., 704., 682., 713., 608. ]
    y = [ 1.51535E+06, 44100., 42143., 39892., 42909., 30737. ]
    dy = [ 1.233E+03, 221., 216., 209., 218., 189. ]

    call fmean(x,dx,y,dy,t,dt,s,c,flag=flag)
    write(*,*) 'Single precision: ',t,dt,s,c,flag

  end subroutine single

  subroutine identity

    real(rp), dimension(:), allocatable :: x,dx,y,dy
    type(suite) :: poi
    logical :: cond

    integer :: n,l
    real(rp) :: mean

    mean = 10**2

    n = 10
    allocate(x(n),dx(n),y(n),dy(n))

    do l = 1, n
       x(l) = max(pnoise(mean),1d-3)
    end do
    dx = sqrt(x)
    y = x
    dy = dx

    write(*,*) 'Po(10**2)  n=',n
    call poi%poistat(x,dx,y,dy)
    cond = abs(poi%t - 1) < 5*epsilon(poi%t)
    write(*,'(a,l2)') 'TEST identity PASS:',cond
    write(*,*)
    deallocate(x,dx,y,dy)

  end subroutine identity


end program testrfactor

!
!  Generate noises with various statistical distributions
!
!
!  Copyright © 2016-7 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!


module noise

  implicit none

  integer, parameter, private :: kind = selected_real_kind(15)

contains

  subroutine randomnoise

    integer :: n,istat
    integer, allocatable :: seed(:)

    ! code by https://gcc.gnu.org/onlinedocs/gcc-6.3.0/gfortran/
    call random_seed(size=n)
    allocate(seed(n))
    open(1, file="/dev/urandom", access="stream", &
         form="unformatted", action="read", status="old", iostat=istat)
    if (istat == 0) then
       read(1) seed
       close(1)
       call random_seed(put=seed)
    end if

  end subroutine randomnoise

  ! Normal distribution
  ! https://en.wikipedia.org/wiki/Normal_distribution

  function gnoise(mean,sig)

    ! Gets noise from N(mean,sig), eg. Normal distribution.

    real(kind), parameter :: sqrt2 = 1.4142135623730951_kind

    real(kind) :: gnoise,x
    real(kind), intent(in) :: mean, sig

    call random_number(x)
    gnoise = mean + sqrt2*sig*inverf(2*x - 1)

  end function gnoise

  subroutine gnoise_fill(t,sig,x)

    real(kind), intent(in) :: t,sig
    real(kind), dimension(:), intent(out) :: x
    integer :: i

    do i = 1, size(x)
       x(i) = gnoise(t,sig)
    end do

  end subroutine gnoise_fill

  ! Laplace distribution
  ! https://en.wikipedia.org/wiki/Laplace_distribution

  function lnoise(median,mad)

    real(kind) :: lnoise, u
    real(kind), intent(in) :: median, mad

    call random_number(u)
    u = u - 0.5_kind
    lnoise = median - mad*sign(1.0_kind,u)*log(1_kind - 2_kind*abs(u))

  end function lnoise

  ! Poisson distribution
  ! https://en.wikipedia.org/wiki/Poisson_distribution

  function pnoise(lambda)

    ! Gets noise from Poisson(lambda) distribution.

    real(kind) :: pnoise
    real(kind), intent(in) :: lambda

    ! The approximation for low lambda uses Knuth's algorithm
    ! which is valid only for exp(-lambda) > epsilon(1.0_kind),
    ! eg. lambda < 740. Normal distribution is used for larger
    ! values. Approximation of N(lambda,sqrt(lambda)) will also
    ! valid with appropriate precision.

    if( lambda  < 500 ) then
       pnoise = pnoise_knuth(lambda)
    else
       pnoise = gnoise(lambda,sqrt(lambda))
    end if

  end function pnoise

  subroutine pnoise_fill(lambda,x)

    real(kind), intent(in) :: lambda
    real(kind), dimension(:), intent(out) :: x
    integer :: i

    do i = 1, size(x)
       x(i) = pnoise(lambda)
    end do

  end subroutine pnoise_fill

  function pnoise_knuth(lam) result(k)

    ! Knuth's algorithm by http://en.wikipedia.org/wiki/Poisson_distribution
    ! This function is valid only for L=exp(-lam) > epsilon(L).

    real(kind), intent(in) :: lam
    real(kind) :: L,p,u
    integer :: k

    L = exp(-lam)
    k = 0
    p = 1
    do
       k = k + 1
       call random_number(u)
       p = p*u
       if( .not. (p > L) ) exit
    enddo
    k = k - 1

  end function pnoise_knuth


  ! The function inverf is adapted Numerical Recipes subroutine
  ! by chapter 6. Error functions. Its precision is better
  ! then 1e-6 on  -5 < x < 5.
  !
  ! Unfortunately, the erf(.) should be supported by compiler.
  ! It requires at least Fortran 2008.

  elemental pure function inverf(p)

    real(kind), intent(in) :: p
    real(kind) :: inverf, pp,x,t,err
    integer :: j

    if( abs(p) < 1 ) then

       pp = 1 - abs(p)
       t = sqrt(-2.0_kind*log(pp/2))
       x = - 0.70711*((2.30753 + t*0.27061)/(1 + t*(0.99229 + t*0.04481)) - t)
       do j = 1,2
          err = 1 - erf(x) - pp
          x = x + err/(1.128379167099551257*exp(-x**2) - x*err)
       end do
       inverf = -sign(x,-p)

    else
       inverf = sign(huge(p),p)
    end if

  end function inverf


!!$  function ierf(x)
!!$
!!$    ! http://en.wikipedia.org/wiki/Error_function
!!$    ! Unfortunatelly, this function has large numerical
!!$    ! error (about 0.2!).
!!$
!!$    real(kind), parameter :: pi = 3.1415926535897931
!!$
!!$    real(kind), intent(in) :: x
!!$    real(kind) :: ierf, u, v, a, y, w
!!$
!!$    a = 0.140012288686666
!!$    u = log(1 - x**2)
!!$    v = 2/(pi*a)
!!$    y = v + u/2
!!$
!!$    w = sqrt(y**2 - u/a)
!!$    ierf = sign(1.0d0,x)*sqrt(w - y)
!!$
!!$  end function ierf


  ! Uniform distribution
  function unoise(a,b)

    ! Noise from uniform distribution U(a,b)

    real(kind) :: unoise, x
    real(kind), intent(in) :: a,b

    call random_number(x)
    unoise = 1.0/(b-a) * x

  end function unoise


end module noise

!
!  QUICKSORT - recursive version of the QuickSort algorithm
!
!  by  Wirth,N: Algorithm + Data Structure = Programs, Prentice-Hall, 1975
!
!  Copyright © 1997-2011, 2017 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.


module quicksorter

  implicit none
  private

  ! precision of real numbers
  integer, parameter, private :: rp = selected_real_kind(15)

  private :: trid
  public :: qsort

contains

  subroutine qsort(a)

    real(rp), dimension(:), intent(in out) :: a
    integer :: n

    n = size(a)
    if( n < 2 ) return

    call trid(1,n,a)

  end subroutine qsort


  recursive subroutine trid(l,r,a)

    integer,intent(in) :: l,r
    real(rp), dimension(:),intent(in out) :: a

    integer :: i,j
    real(rp) :: x,w     ! internal buffers

    i = l
    j = r
    x = a((l+r)/2)

    do
       do while ( a(i) < x )
          i = i + 1
       end do

       do while ( x < a(j) )
          j = j - 1
       end do

       if( i <= j )then
          w = a(i)
          a(i) = a(j)
          a(j) = w
          i = i + 1
          j = j - 1
       endif

       if( i > j ) exit
    end do

    if( l < j ) call trid(l,j,a)
    if( i < r ) call trid(i,r,a)

  end subroutine trid

end module quicksorter

!
!  Robust minimization functions
!
!  Copyright © 2011 - 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!

module rfun

  implicit none

  ! M-estimator functions
  ! Hogg in Launer, Wilkinson: Robustness in Statistics

  ! default precision of real numbers
  integer, parameter, private :: kind = selected_real_kind(15)

  ! parameters of robust functions
  real(kind),parameter,private :: a = 1.349_kind
  real(kind),parameter,private :: a2 = a**2 / 2.0_kind
  real(kind),parameter,private :: c = 6.0_kind
  real(kind),parameter,private :: c2 = c**2 / 2.0_kind

  ! parameters for entropy determination (see test/eparam.f08)
  real(kind),parameter,public :: ehuber = 2.0045
  real(kind),parameter,public :: etukey = 2.1227

  public :: huber, dhuber, ihuber, tukey, dtukey, itukey, tukeys

contains

  !--------------------------------------------------------------
  !
  ! Robust functions
  !

  ! Huber

  elemental pure function huber(x)

    real(kind) :: huber
    real(kind), intent(in) :: x

    huber = max(-a,min(a,x))
!    if( abs(x) < a )then
!       huber = x
!    else
!       huber = sign(a,x)
!    endif

  end function huber


  elemental pure function dhuber(x)

    real(kind) :: dhuber
    real(kind), intent(in) :: x

    if( abs(x) <= a )then
       dhuber = 1.0_kind
    else
       dhuber = 0.0_kind
    endif

  end function dhuber

  elemental pure function ihuber(x)

    real(kind) :: ihuber
    real(kind), intent(in) :: x

    if( abs(x) < a ) then
       ihuber = x**2 / 2.0_kind
    else
       ihuber = a*abs(x) - a2
    end if

  end function ihuber


  ! Tukey

  elemental pure function tukey(x)

    real(kind) :: tukey
    real(kind), intent(in) :: x

    if( abs(x) < c )then
       tukey = x*(1.0_kind - (x/c)**2)**2
    else
       tukey = 0.0_kind
    endif

  end function tukey

  elemental pure function dtukey(x)

    real(kind) :: dTukey
    real(kind), intent(in) :: x
    real(kind) :: t

    if( abs(x) < c )then
       t = (x/c)**2
       dtukey = 1.0_kind + t*(5.0_kind*t - 6.0_kind)
    else
       dtukey = 0.0_kind
    endif

  end function dTukey

  elemental pure function iTukey(x)

    real(kind) :: itukey
    real(kind), intent(in) :: x
    real(kind) :: t

    if( abs(x) < c )then
       t = (x/c)**2
       iTukey = c2*t*(1.0_kind + t*(t/3.0_kind - 1.0_kind))
    else
       iTukey = 0.0_kind
    endif

  end function iTukey

  elemental pure subroutine tukeys(x,tukey,dtukey,itukey)

    real(kind), intent(in) :: x
    real(kind), intent(out) :: tukey,dtukey
    real(kind), intent(out), optional :: itukey
    real(kind) :: t
    logical :: l

    l = present(itukey)

    if( abs(x) < c )then
       t = (x/c)**2
       tukey = x*(1.0_kind - t)**2
       dtukey = 1.0_kind + t*(5.0_kind*t - 6.0_kind)
       if(l) iTukey = c2*t*(1.0_kind + t*(t/3.0_kind - 1.0_kind))
    else
       tukey = 0.0_kind
       dtukey = 0.0_kind
       if(l) iTukey = 0.0_kind
    endif

  end subroutine tukeys

end module rfun

program hampel

  use quantilmean
  use oakleaf

  implicit none
  integer, parameter :: kind = selected_real_kind(15)
  real(kind), dimension(:), allocatable :: x, xcdf, ycdf, fcdf,tcdf
  real(kind), dimension(2,2) :: par
  real(kind), dimension(1) :: eps
  integer :: m, n
  real(kind) :: d,dh,t,dt,s

  eps(1) = 0.0
  par(1,:) = [0.0_kind, 1.0_kind]
  par(2,:) = [1.0_kind, 10.0_kind]

!  eps = 0.1
  do m = 1, 20
     n = 2**m
     x = gsample(n,eps,par)
     allocate(xcdf(n),ycdf(n),fcdf(n))
     call cdf(x,xcdf,ycdf)
     fcdf = gnormal(xcdf,par(1,1),par(1,2))
     d = maxval(abs(fcdf - ycdf))
     call rmean(x,t,dt,s,verbose=.true.)
     tcdf = gnormal(xcdf,t,s)
     dh = maxval(abs(fcdf - tcdf))
     write(*,*) n,d,dh,t,s
     deallocate(x,fcdf,xcdf,ycdf,tcdf)
  end do

  do m = 1, 20
     n = 2**m
     x = lsample(n,eps,par)
     allocate(xcdf(n),ycdf(n),fcdf(n))
     call cdf(x,xcdf,ycdf)
     fcdf = lnormal(xcdf,par(1,1),par(1,2))
     d = maxval(abs(fcdf - ycdf))
     call mmean(x,t,s)
     tcdf = lnormal(xcdf,t,s)
     dh = maxval(abs(fcdf - tcdf))
     write(*,*) n,d,dh,t,s
     deallocate(x,fcdf,xcdf,ycdf,tcdf)
  end do


contains

  function gsample(n,eps,par)

    use noise

    real(kind), dimension(:), allocatable :: gsample
    integer, intent(in) :: n
    real(kind), dimension(:), intent(in) :: eps
    real(kind), dimension(:,:), intent(in) :: par
    real(kind) :: p
    integer :: i,k

    allocate(gsample(n))
    do i = 1, n
       do k = 1, size(eps)
          call random_number(p)
          if( p > eps(k) ) then
             gsample(i) = gnoise(par(1,1),par(1,2))  ! primary
          else
             gsample(i) = gnoise(par(2,1),par(2,2))  ! contamination
          end if
       end do
    end do

  end function gsample


  function lsample(n,eps,par)

    use noise

    real(kind), dimension(:), allocatable :: lsample
    integer, intent(in) :: n
    real(kind), dimension(:), intent(in) :: eps
    real(kind), dimension(:,:), intent(in) :: par
    real(kind) :: p
    integer :: i,k

    allocate(lsample(n))
    do i = 1, n
       do k = 1, size(eps)
          call random_number(p)
          if( p > eps(k) ) then
             lsample(i) = lnoise(par(1,1),par(1,2))
          else
             lsample(i) = lnoise(par(2,1),par(2,2))
          end if
       end do
    end do

  end function lsample

  elemental function gnormal(x,t,s)

    real(kind), parameter :: sqrt2 = sqrt(2.0_kind)

    real(kind), intent(in) :: x,t,s
    real(kind) :: gnormal

    gnormal = (1.0_kind + erf((x-t)/(sqrt2*s)))/2.0_kind

  end function gnormal

  elemental function lnormal(x,t,s)

    real(kind), parameter :: sqrt2 = sqrt(2.0_kind)

    real(kind), intent(in) :: x,t,s
    real(kind) :: lnormal
    real(kind) :: u

    u = (x - t) / s
    if( x < t ) then
       lnormal = exp(u) / 2.0_kind
    else
       lnormal = 1.0_kind - exp(-u) / 2.0_kind
    end if

  end function lnormal

end program hampel

program ismoke

  use oakleaf
  use noise

  implicit none

  integer, parameter :: kind = selected_real_kind(15)
  character(len=80) :: amount,filename
  integer :: n,voltage

  call get_environment_variable("VOLTAGE",status=voltage)
  if( .not. (voltage == 0) ) stop 'Low voltage.'

  call get_command_argument(1,amount)
  call get_command_argument(2,filename)
  read(amount,*) n

  if( .false. ) call run(n,filename)

  call grapher(n,filename)

contains

    subroutine run(n,filename)

    integer, intent(in) :: n
    character(len=*), intent(in) :: filename
    real(kind), dimension(n) :: data
    real(kind) :: t1,t2,total
    character(len=80) :: name
    integer :: m,nn

    total = 0
    nn = 0
    open(77,file=filename)
    do m = 1, 1000000
       call randomnoise
       call gnoise_fill(0.0_kind,0.05_kind,data)
!       call gnoise_fill(2.0_kind,1.0_kind,data(::10))
       call cpu_time(t1)
       write(name,'(2a,i0)') trim(filename),'_',nn
!       call plot(data,name)
       call cpu_time(t2)
       total = total + (t2 - t1)
    end do
    close(77)
    write(*,'(a,f0.3)') 'Total=',total

  end subroutine run


  subroutine grapher(n,filename)

    integer, intent(in) :: n
    character(len=*), intent(in) :: filename
    real(kind), dimension(n) :: data
    character(len=80) :: name

    call randomnoise
    call gnoise_fill(0.0_kind,2.0_kind,data)
!    call gnoise_fill(0.0_kind,5.0_kind,data(::10))
    write(name,'(2a,i0)') trim(filename),'_',n
    call plot(data,name)

  end subroutine grapher


  subroutine plot(data,name)

    character(len=*), intent(in) :: name
    real(kind), dimension(:), intent(in) :: data
    integer :: n,i,j
    real(kind) :: s,t!,w
    real(kind), dimension(size(data)) :: rho, phi,dphi, q
    real(kind), dimension(:,:), allocatable :: data1

    n = size(data)
    open(12,file=name)
!    write(12,*) '# ',data
    do i = 1, 500
       s = i / 100.0
       rho = itukey(data/s)
       phi = tukey(data/s)
       dphi = dtukey(data/s)
!       rho = (data/s)**2/2
!       phi = data/s
!       dphi = 1
!       w =  size(rho) / sum(exp(-rho))
       write(12,*) s,sum(rho*exp(-etukey*rho)), &
            -sum(rho)/n-log(s),&
            sum(phi*data/s)/n - 1,&
!            sum(exp(-(data/s)**2)*(data**2+log(2.5))/(s**2+log(2.5*s))),&
!            -sum(exp(-2*rho)/s*(-2*rho-log(s)+phi/2+0.5*log(phi))),&
!            2*s**2*sum(rho)/size(rho)
!            -sum((rho+log(s))*exp(-rho)),&
!            sum(exp(-2*rho))/n
!            sum(phi**2*exp(-2*rho)), &
            !            sum(phi*data*exp(-2*rho)), &
            sum((phi*data/s - 0.9888)**2*exp(-rho)), &
            sum(phi*data/s - 0.9888)/n,&
            sum(phi**2 - 0.8061)/n
!            sum(((data/s)**2 - 1)**2*exp(-(data/s)**2/2)), &
!            sum((data/s)**2 - 1)/n
    end do
    close(12)

!    open(12,file='/tmp/h')
!    do i = 1, 1000
!       s = i / 1000.0
!       rho = data**2
!       rho = (data/s)**2*exp(-(data/s)**2)
!       write(12,*) s, count(s-0.0005 < abs(rho) .and. abs(rho) < s + 0.0005)
!    end do
!    close(12)

    allocate(data1(n,13))
    do i = 1, size(data1,2)
       call randomnoise
       call gnoise_fill(0.0_kind,1.0_kind,data1(:,i))
    end do
!    call gnoise_fill(0.0_kind,1.0_kind,data2)
!    rho = data**2 + data1**2 + data2**2

!    rho = sum(data1**2)
!    rho = sum(data1(1,:)**2)
!    rho = data1(:,1)**2
    do i = 1, size(data1,1)
       rho(i) = sum(data1(i,:)**2)
    end do
    open(12,file='/tmp/h')
    do i = 1, 1400
       s = i / 100.0
       do j = 1, size(data1,1)
          !       rho(i) = sum(data1(i,:)**2)
!          rho(j) = sum((data1(j,:)/s)**2*exp(-(data1(j,:)/s)**2))
!          rho(j) = sum((data1(j,:)/s)**2*exp(-(data1(j,:)/s)**2))
          q(j) = sum((1 - (data1(j,:)/s)**2)**2*exp(-(data1(j,:)/s)**2/2))
       end do
!       rho = ((data/s)**2 + (data1/s)**2 + (data2/s)**2)  &
!            * exp(-((data/s)**2 + (data1/s)**2 + (data2/s)**2))
       write(12,*) s, count(s-0.0005 < abs(q) .and. abs(q) < s + 0.0005)
    end do
    close(12)

    open(12,file='/tmp/t')
    s = 1
    do i = -100,100
       t = i / 100.0
       rho = ((data-t)/s)**2/2
       phi = (data-t)/s
       dphi = 1
       write(12,*) t,sum((rho-1)**2*exp(-rho)),s**2*sum(phi**2)/sum(dphi)
    end do
    close(12)


  end subroutine plot


end program ismoke

module testsuite

  use oakleaf

  ! testing suite

  integer, parameter, private :: rp = selected_real_kind(15)

  type :: suite
     integer :: n
     real(rp) :: t,dt,s,sig
   contains
     procedure :: stdstat, stdwstat,robstat,robwstat,qtstat,poistat
  end type suite

contains

  subroutine stdstat(this,x)

    class(suite) :: this
    real(rp), dimension(:), intent(in) :: x

    associate( t => this%t, dt => this%dt, s => this%s, sig => this%sig, &
         n => this%n)

      n = size(x)
      t = sum(x) / n
      s = sqrt(sum( (x-t)**2 / (n-1) ))
      sig = s
      dt = s / sqrt(real(n))
      write(*,*) "Amean:",t,dt,sig,s
    end associate

  end subroutine stdstat


  subroutine stdwstat(this,x,dx)

    real(rp), dimension(:), intent(in) :: x,dx
    class(suite) :: this

    associate( t => this%t, dt => this%dt, s => this%s, sig => this%sig, &
         n => this%n)
      n = size(x)
      t = sum(x/dx**2)/sum(1/dx**2)
      s = sqrt(sum((t-x)**2/dx**2)/(n-1))
      sig = sqrt(sum((t-x)**2)/(n-1))
      dt = sqrt(s**2/sum(1/dx**2))
      write(*,*) "AWmean:",t,dt,sig,s
    end associate

  end subroutine stdwstat

  subroutine robstat(this,x)

    real(rp), dimension(:), intent(in) :: x
    class(suite) :: this

    logical :: reli
    real :: t1,t2

    associate( t => this%t, dt => this%dt, s => this%s, sig => this%sig, &
         n => this%n)
      call cpu_time(t1)
      call rmean(x,t,dt,sig,s,reli,verbose=.true.)
      call cpu_time(t2)

      write(*,*) "Rmean:",t,dt,sig,s,reli,nint(1e3*(t2-t1)),"ms"!,&
      !       abs(t - mean) < dt .and. abs(stdsig - s) < 0.1
    end associate

  end subroutine robstat

  subroutine robwstat(this,x,dx)

    real(rp), dimension(:), intent(in) :: x,dx
    class(suite) :: this

    logical :: reli
    real :: t1,t2

    associate( t => this%t, dt => this%dt, s => this%s, sig => this%sig, &
         n => this%n)
      call cpu_time(t1)
      call rmean(x,dx,t,dt,sig,s,reli,verbose=.true.)
      call cpu_time(t2)

      write(*,*) "RWmean:",t,dt,sig,s,reli,nint(1e3*(t2-t1)),"ms"!,&
      !       abs(t - mean) < dt .and. abs(stdsig - s) < 0.1
    end associate

  end subroutine robwstat

  subroutine qtstat(this,x)

    real(rp), dimension(:), intent(in) :: x
    class(suite) :: this

    associate( t => this%t, dt => this%dt, s => this%s, n => this%n)
      call qmean(x,t,s)
      write(*,*) "Qmean:",t,s
    end associate

  end subroutine qtstat

  subroutine poistat(this,x,dx,y,dy)

    real(rp), dimension(:), intent(in) :: x,dx,y,dy
    class(suite) :: this

    logical :: reli
    real :: t1,t2

    associate( t => this%t, dt => this%dt, s => this%s, n => this%n)
      call cpu_time(t1)
      call fmean(x,dx,y,dy,t,dt,s,reliable=reli,verbose=.true.)
      call cpu_time(t2)

      write(*,*) "fmean:",t,dt,s,reli,nint(1e3*(t2-t1)),"ms"
    end associate

  end subroutine poistat

  subroutine tester(proc)

    interface
       subroutine proc
       end subroutine proc
    end interface

    write(*,*) "Starting .."
    call proc
    write(*,*)
    write(*,*)

  end subroutine tester


end module testsuite

program testlscale

  use oakleaf
  use noise
  use toolbox

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  integer, parameter :: ndata = 900000
  real(dbl), dimension(ndata) :: x,y,z
  real(dbl) :: s, t, stderr
  integer :: i
  logical :: reliable

  call gnoise_fill(0.0_dbl,10.0_dbl,x)
!  call gnoise_fill(0.0_dbl,100.1_dbl,y)
!  call gnoise_fill(0.0_dbl,0.01_dbl,z)

  do i = 1, ndata,5
     x(i) = y(i)
  end do

  do i = 5, ndata,5
     x(i) = z(i)
  end do


!  write(*,*) x

!  x = 1
!  x = [-0.936962512663888, 0.982829448493290, -0.045866935829402 ]
!  x = [ 177.0, 0.431, -0.104, 1.451, -1.165, 0.516, 0.0 ]

  t = sum(x) / ndata
  write(*,*) 'arith.mean:',t
  write(*,*) 'median:',median(x)
  t = median(x)
  t = 0

  write(*,*) 'std.dev. ',stddev(x-t)
  s = median(abs(x-t))/0.6745
  write(*,*) 'MAD/0.6745 ',s
!    s = 1
  !s = 2.18
  call iscale(x-t,s,reliable,verbose=.true.)
  stderr = s*sqrt(sum(tukey((x-t)/s)**2)/sum(dtukey((x-t)/s))**2)
  write(*,*) 'scale ',s,reliable, stderr, stderr*sqrt(real(size(x)))


  open(1,file='/tmp/x')
  write(1,*) '# x'
  write(1,'(f20.15)') x-t
  close(1)

  do i = 1, ndata
!     call plots(i,x(i)-t)
  end do

contains

  subroutine plots(i,r)

    use oakleaf

    integer, intent(in) :: i
    real(dbl), intent(in) :: r
    character(len=80) :: filename
    real(dbl) :: s,smin,ds,rho
    integer :: l

    write(filename,'(a,i0)') '/tmp/x',i
    open(1,file=filename)
    smin = tiny(s)
    ds = (5.0 - 0.0) / 66
    do l = 1, 66
       s = smin + l * ds
       rho = itukey(r/s)
       write(1,'(2f20.15)') s,- rho - log(s)
    end do
    close(1)

  end subroutine plots

end program testlscale

program testlaplace

  ! https://en.wikipedia.org/wiki/Laplace_distribution

  use noise
  use toolbox
  use quantilmean

  implicit none

  integer, parameter :: n = 6666
  integer, parameter :: kind = selected_real_kind(15)
  character(len=80) :: histname, cdfname
  real(kind), dimension(:), allocatable :: x
  integer :: i

  call get_command_argument(1,histname)
  call get_command_argument(2,cdfname)

  allocate(x(n))
  do i = 1, n
     x(i) = lnoise(0.0_kind,1.0_kind)
  end do

  call histogram(x,-5.0_kind,5.0_kind,100,histname)

  call cdfun(x,cdfname)

contains

  subroutine cdfun(x,filename)

    use oakleaf

    real(kind), dimension(:), intent(in) :: x
    character(len=*), intent(in) :: filename
    real(kind), dimension(:), allocatable :: xcdf, ycdf
    integer :: i,n

    n = size(x)
    allocate(xcdf(n),ycdf(n))

    call ecdf(x,xcdf,ycdf)

    open(1,file=filename)
    do i = 1, size(xcdf)
       write(1,*) xcdf(i),ycdf(i)
    end do
    write(1,*) xcdf(n)+100,1.0
    close(1)

  end subroutine cdfun


end program testlaplace

program testrfun

  use rfun

  implicit none

  integer, parameter :: rp = selected_real_kind(15)

  integer :: i
  real(rp) :: x, dx = 1e-5_rp

  do i = -100,100
     x = i/10.0
!     write(*,*) x,huber(x),dhuber(x),tukey(x),dtukey(x)
     write(*,*) x,dhuber(x),(huber(x+dx)-huber(x-dx))/(2*dx), &
          dtukey(x),(tukey(x+dx)-tukey(x-dx))/(2*dx), &
          tukey(x),(itukey(x+dx)-itukey(x-dx))/(2*dx)
  end do

end program testrfun

! gfortran -I/usr/include example_rmean.f08 -loakleaf

program example_rmean

   use oakleaf
   use iso_fortran_env

   implicit none

   real(REAL64), dimension(7) :: x = [1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0 ]
   real(REAL64) :: t,dt,sig
   logical :: reli

   call rmean(x,t,dt,sig,reli,verbose=.false.)
   write(*,*) 'Data: ',x
   write(*,*) 'Mean: ',t
   write(*,*) 'Std.err.: ',dt
   write(*,*) 'Std.dev: ',sig
   write(*,*) 'Reliable? ',reli

end program example_rmean

module toolbox

  integer, parameter, private :: kind = selected_real_kind(15)

contains

  function arith(x)

    real(kind) :: arith
    real(kind), dimension(:), intent(in) :: x

    arith = sum(x) / size(x)

  end function arith

  function stddev(r)

    real(kind) :: stddev
    real(kind), dimension(:), intent(in) :: r
    integer :: n

    n = size(r)
    if( n > 1 ) then
       stddev = sqrt(sum(r**2) / (n - 1))
    else
       stddev = 0
    end if

  end function stddev

  subroutine histogram(x, xmin, xmax, nbines, filename)

    real(kind), dimension(:), intent(in) :: x
    real(kind), intent(in) :: xmin, xmax
    integer, intent(in) :: nbines
    character(len=*), intent(in) :: filename
    integer, dimension(:), allocatable :: hist
    real(kind) :: d,t,s
    integer :: n,l,nbins

    if( nbines < 1 ) then
       nbins = int(log(real(size(x)))/0.7) + 1
    else
       nbins = nbines
    end if
    nbins = nbins / 2

    allocate(hist(-nbins:nbins))

    d = (xmax - xmin) / (2*nbins + 1)
    t = (xmax + xmin) / 2
    hist = 0
    do l = 1, size(x)
       n = nint((x(l) - t) / d)
       if( -nbins <= n .and. n <= nbins ) then
          hist(n) = hist(n) + 1
       end if
    end do

    s = sum(hist) * d
    open(1,file=filename)
    do n = -nbins,nbins
       write(1,*) (n*d + t), hist(n)/s
    end do
    close(1)

    deallocate(hist)

  end subroutine histogram

end module toolbox

!
!  Robust estimate of parameters of line
!
!  Copyright © 2014-5, 2017-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!


module robustline

  ! This module provides subroutines for estimation
  ! of parameters (a,b) for a line in the form
  !
  !     y = a + b*x                        (without errors of x,y)
  !
  ! or
  !                a + b*x
  !     y = ------------------------       (with errors)
  !         sqrt(dy**2 + b**2*dx**2)
  !
  !
  ! with optional estimate of theirs statistical errors (da, db).
  !
  ! rline should be called as:
  !
  !  call rline(x,y,a,b,da,db,dx,dy,sigma,reliable,verbose)
  !
  ! on input:
  !   x,y - array of data values to be estimated
  !   dx,dy - array of statistical errors of x,y (optional), dx can be omitted,
  !           if dy is presented.
  !   verbose - verbose output (optional)
  !
  ! on output are estimated:
  !   a,b - parameters of the line
  !   da,db - standard error of the parameters (optional)
  !   sigma - standard deviation (optional)
  !   reliable - indicates reliability of results (optional)

  use rfun

  implicit none
  private

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  ! verbose print?
  logical, private :: xverbose = .false.

  ! print debug messages
  logical, parameter, private :: debug = .false.

  ! estimate jacobian by differences or derivations ?
  logical, parameter, private :: analytic = .true.

  ! weights?
  logical, private :: weights

  integer, private :: ndat
  real(dbl), dimension(:), allocatable, private :: xdata, ydata, xsig, ysig, &
       res, rho, psi, dpsi
  real(dbl), private :: rsig

  private :: absline, absfun, nscale, funder, fundif, difjac, loglikely, &
       residuals, newline, logline

  public :: rline

contains

  subroutine rline(x,y,a,b,da,db,dx,dy,sigma,reliable,verbose)

    use medians

    real(dbl), dimension(:), intent(in) :: x,y
    real(dbl), intent(out) :: a,b
    real(dbl), dimension(:), intent(in), optional :: dx,dy
    real(dbl), intent(out), optional :: da,db
    real(dbl), intent(out), optional :: sigma
    logical, intent(out), optional :: reliable
    logical, intent(in), optional :: verbose

    real(dbl) :: s,d,sig,xcen,ycen,d1,d2

    logical :: abreli, sreli, reli
    integer :: n

    weights = present(dx) .or. present(dy)

    if( present(verbose) ) then
       xverbose = verbose
    else
       xverbose = .false.
    end if

    if( weights .and. .not. present(dy) ) stop 'rline(): dy must be present.'

    if( size(x) /= size(y) ) stop 'rline(): Size of x,y data sets are different.'

    if( present(dx) ) then
       if( size(dx) /= size(x) ) stop 'rline(): Size of x and dx are different.'
       if( .not. all(dx >= 0) ) stop 'rline(): all dx >= 0, it is required.'
    end if

    if( present(dy) ) then
       if( size(dy) /= size(x) ) stop 'rline(): Size of y and dy are different.'
       if( .not. all(dy > 0) ) stop 'rline(): all dy > 0, it is required.'
    end if

    n = size(x)

    if( n < 2 ) then
       a = 0
       b = 0
       if( present(da) ) da = 0
       if( present(db) ) db = 0
       if( present(sigma) ) sigma = 1
       if( present(reliable) ) reliable = .false.
       return

    else if( n == 2 ) then
       d = x(2) - x(1)
       if( abs(d) > 0 ) then
          b = (y(2) - y(1)) / (x(2) - x(1))
          a = (y(1) + y(1)) / 2 + b*(x(1) + x(2)) / 2
       else
          a = 0
          b = 0
       end if
       if( present(da) ) da = 0
       if( present(db) ) db = 0
       if( present(sigma) ) sigma = 1
       if( present(reliable) ) reliable = .false.
       return

    end if

    allocate(xdata(n),ydata(n),xsig(n),ysig(n),res(n),rho(n),psi(n),dpsi(n))
    ndat = n
    xdata = x
    ydata = y

    if( present(dx) ) then
       xsig = dx
    else
       xsig = 0.0_dbl
    end if

    if( present(dy) ) then
       ysig = dy
    else
       ysig = 1.0_dbl
    end if

    ! compute data centroids
    xcen = median(x)
    ycen = median(y)
    if( xverbose ) write(*,*) "Centroids:",real(xcen),real(ycen)

    ! inital estimate by absolute deviations
    call absline(a,b,s,abreli)
    rsig = s
    call nscale(a,b,s,sreli)
    if( xverbose ) write(*,'(a,1p,2g15.5,0pf8.2,1x,2l1)') &
         'Robust line by abs.dev., sig by entropy:',a,b,s,abreli,sreli

    if( sreli ) rsig = s
    reli = abreli .and. sreli
    if( reli ) then

       call logline(a,b,abreli)
       call nscale(a,b,s,sreli)
       if( xverbose ) write(*,'(a,1p,2g15.5,0pf8.2,1x,2l1)') &
            'Robust line by likelihood, sig by entropy:',a,b,s,abreli,sreli

       if( sreli ) rsig = s
       reli = abreli .and. sreli
       if( reli ) then

          ! hight precise solution and statistical errors
          call newline(a,b,d1,d2,sig,reli)
          if( reli ) s = sig

       end if

    end if

    if( .not. reli ) then
       d2 = rsig/sqrt(real(n))
       if( b > 0 ) then
          d1 = d2 / b
       else
          d1 = huge(d1)
       end if
    end if

    if( present(da) ) da = d1
    if( present(db) ) db = d2
    if( present(reliable) ) reliable = reli
    if( present(sigma) ) sigma = s

    deallocate(xdata,ydata,xsig,ysig,res,rho,psi,dpsi)

  end subroutine rline

  subroutine absline(a,b,s,reli)

    use NelderMead
    use medians

    real(dbl), intent(out) :: a,b,s
    real(dbl), dimension(2) :: t, dt
    logical, intent(out) :: reli
    real(dbl) :: ams, mad
    integer :: ifault

    t = 0
    dt = 1
    call nelmin1(absfun,t,dt,ams,ifault)
    reli = ifault == 0

    if( xverbose .and. ifault > 0 ) &
         write(*,*) "No konvergence in rline: absline()."

    call residuals(t(1),t(2),res)

    if( ndat < 50 ) then
       mad = median(abs(res))
    else
       mad = qmedian(abs(res))
    end if

    a = t(1)
    b = t(2)
    s = mad / 0.6745

  end subroutine absline

  function absfun(t) result(s)

    real(dbl), dimension(:), intent(in) :: t
    real(dbl) :: s

    call residuals(t(1),t(2),res)
    s = sum(abs(res))

  end function absfun


  subroutine logline(a,b,reli)

    use NelderMead

    real(dbl), intent(in out) :: a,b
    real(dbl), dimension(2) :: t, dt
    logical, intent(out) :: reli
    real(dbl) :: ams
    integer :: ifault

    t = [ a, b ]
    dt = rsig
    call nelmin1(loglikely,t,dt,ams,ifault)
    reli = ifault == 0

    if( xverbose .and. ifault > 0 ) write(*,*) "No konvergence in rline / logline."

    a = t(1)
    b = t(2)

  end subroutine logline


  subroutine newline(a,b,da,db,sig,reli)

    use minpacks

    real(dbl), intent(in out) :: a,b
    real(dbl), intent(out) :: da,db,sig
    real(dbl), dimension(2) :: t
    logical, intent(out) :: reli
    real(dbl), dimension(2,2) :: cov
    real(dbl) :: df, f2
    integer :: nprint,info

    if( debug ) then
       nprint = 1
    else
       nprint = 0
    end if

    t = [ a, b ]

    ! Try to find the best solution. Our initial estimate is very neary
    ! to the right one.
    if( analytic ) then
       call lmder3(funder,t,cov,nprint=nprint,info=info)
    else
       call lmdif3(fundif,t,cov,nprint=nprint,info=info)
    end if

    reli = info /= 5
    if( reli ) then
       ! the minimum localised successfully, update estimates
       a = t(1)
       b = t(2)

       ! estimate uncerainities
       call residuals(a,b,res)
!       call tukeys(res/rsig,psi)
!       call dtukeys(res/rsig,dpsi)
       call tukeys(res/rsig,psi,dpsi)
!       dpsi = 1
!       psi = res
       df = sum(dpsi)
       f2 = sum(psi**2)

       if( df > 0 .and. f2 > 0 ) then

          cov = cov / rsig**2
          sig = rsig * sqrt(f2/df*ndat/(ndat-2))
          if( cov(1,1) > 0 ) da = sig * sqrt(cov(1,1))
          if( cov(2,2) > 0 ) db = sig * sqrt(cov(2,2))

       else
          reli = .false.
       end if

       if( xverbose ) then
          write(*,*) 'cov:',real(cov(1,:))
          write(*,*) 'cov:',real(cov(2,:))
       end if

    end if

  end subroutine newline


  subroutine residuals(a,b,r)

    real(dbl), intent(in) :: a,b
    real(dbl), dimension(:), intent(out) :: r

    if( weights ) then
       r = (ydata - (a + b*xdata)) / sqrt(ysig**2 + b**2*xsig**2)
    else
       r = ydata - (a + b*xdata)
    end if

  end subroutine residuals

  function loglikely(t)

    use rfun

    real(dbl), dimension(:), intent(in) :: t
    real(dbl) :: loglikely

    call residuals(t(1),t(2),res)
!    call itukeys(res/rsig,rho)
    rho = itukey(res/rsig)

    loglikely = sum(rho)

  end function loglikely

  subroutine funder(m,np,p,fvec,fjac,ldfjac,iflag)

    use rfun

    integer, intent(in) :: m,np,ldfjac
    integer, intent(inout) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(ldfjac,np), intent(out) :: fjac
    real(dbl), dimension(:), allocatable :: r,ds,dra,drb
    real(dbl), dimension(2) :: fv
    real(dbl), dimension(2,2) :: dfjac
    real(dbl) :: a,b,s
    integer :: n

    if( iflag == 0 ) then

       write(*,'(4g15.5)') p,fvec

       if( debug ) then
          write(*,*) 'djac:',fjac(1,:)
          write(*,*) 'djac:',fjac(2,:)

          call difjac(p(1),p(2),dfjac)
          write(*,*) 'djac:',dfjac(1,:)
          write(*,*) 'djac:',dfjac(2,:)
       end if

       return
    end if

    n = size(xdata)
    allocate(r(n),ds(n))

    a = p(1)
    b = p(2)
    s = rsig

    if( weights ) then

       ds = sqrt(ysig**2 + b**2*xsig**2)
       r = (ydata - (a + b*xdata)) / ds
!       call tukeys(r/s,psi)
       psi = tukey(r/s)
!       psi = r/s
       fv(1) = sum(psi/ds)
       fv(2) = sum(psi*(xdata/ds + r*b*xsig**2/ds**2))

    else

       r = ydata - a - b*xdata
!       call tukeys(r/s,psi)
       psi = tukey(r/s)
!       psi = r / s
       fv(1) = sum(psi)
       fv(2) = sum(psi*xdata)

    end if

    if( iflag == 1 ) then

       fvec = - fv / s
!       write(*,*) fvec

    else if( iflag == 2 ) then

       allocate(dra(n),drb(n))
!       call dtukeys(r/s,dpsi)
       dpsi = dtukey(r/s)
!       dpsi = 1

       if( weights ) then

          dra = - 1 / ds
          drb = - (xdata*ds + r*b*xsig**2) / ds**2

          fjac(1,1) = sum(dpsi/ds**2)
          fjac(1,2) = sum(dpsi*dra*drb) - s*sum(psi*b*xsig**2/ds**3)
          fjac(2,1) = fjac(1,2)
          fjac(2,2) = sum(dpsi*drb**2) - &
               s*sum(psi*(r*(1-3*b**2**xsig**2/ds**2)-2*xdata/ds)*xsig**2/ds**2)

       else

          fjac(1,1) = sum(dpsi)
          fjac(1,2) = sum(dpsi*xdata)
          fjac(2,1) = fjac(1,2)
          fjac(2,2) = sum(dpsi*xdata**2)

       end if

       fjac = fjac / s**2

       deallocate(dra,drb)

    end if

    deallocate(r,ds)

  end subroutine funder

  subroutine difjac(t,s,jac)

    real(dbl), intent(in) :: t,s
    real(dbl), dimension(:,:), intent(out) :: jac
    real(dbl), parameter :: d = 1e-4
    real(dbl), dimension(2) :: fv1,fv2
    integer :: iflag

    iflag = 1

    call fundif(2,2,[t+d,s],fv1,iflag)
    call fundif(2,2,[t-d,s],fv2,iflag)
    jac(1,:) = (fv1 - fv2)/(2*d)

    call fundif(2,2,[t,s+d],fv1,iflag)
    call fundif(2,2,[t,s-d],fv2,iflag)
    jac(2,:) = (fv1 - fv2)/(2*d)

  end subroutine difjac

  subroutine fundif(m,np,p,fvec,iflag)

    use rfun

    integer, intent(in) :: m,np
    integer, intent(in out) :: iflag
    real(dbl), dimension(np), intent(in) :: p
    real(dbl), dimension(m), intent(out) :: fvec
    real(dbl), dimension(:), allocatable :: r,f,ds
    real(dbl), dimension(2,2) :: jac
    real(dbl), dimension(2) :: fv
    integer :: n
    real(dbl) :: a,b,s

    if( iflag == 0 ) then

       write(*,'(6g13.5)') p,fvec

       if( debug ) then
          n = 2
          call funder(2,2,p,fv,jac,2,n)
          write(*,*) ' jac:',jac(1,:)
          write(*,*) ' jac:',jac(2,:)
       end if

       return
    end if

    n = size(xdata)
    allocate(r(n),f(n),ds(n))

    a = p(1)
    b = p(2)
    s = rsig

    if( weights ) then

       ds = sqrt(ysig**2 + b**2*xsig**2)
       r = (ydata - (a + b*xdata)) / ds
!       call tukeys(r/s,psi)
       psi = tukey(r/s)
!       psi = r/s

       fvec(1) = sum(psi/ds)
       fvec(2) = sum(psi*(xdata*ds + r*b*xsig**2)/ds**2)

    else

       r = ydata - (a + b*xdata)
!       call tukeys(r/s,psi)
       psi = tukey(r/s)
!       psi = r / s
       fvec(1) = sum(psi)
       fvec(2) = sum(psi*xdata)

    end if

    fvec = - fvec / s

    deallocate(r,f,ds)

  end subroutine fundif

  subroutine nscale(a,b,s,reli)

    use likescale

    real(dbl), intent(in) :: a,b
    real(dbl), intent(in out) :: s
    logical, intent(out) :: reli

    call residuals(a,b,res)
    call iscale(res,s,reli)

  end subroutine nscale


end module robustline

!
! This module is a adopted version of algorithm described below.
!
! Download:    http://people.sc.fsu.edu/~burkardt/f_src/asa047/asa047.html
!
! Thx to J. Burkardt http://people.sc.fsu.edu/~burkardt/index.html
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!


Module NelderMead

  implicit none
  private

  public :: nelmin, nelmin1

contains

  ! a simple wrapper to the original subroutine

  subroutine nelmin1(fn,xmin,step,ynewlo,ifault, &
       reqmin0,konvge0,kcount0,icount0,numres0)

    interface
       function fn(t)
         real(kind=8) :: fn
         real(kind=8), dimension(:), intent(in) :: t
       end function fn
    end interface

    real(kind=8), dimension(:), intent(out) :: xmin
    real(kind=8), dimension(:), intent(in) :: step
    real(kind=8), intent(out) :: ynewlo
    integer, intent(out) :: ifault
    real(kind=8), optional, intent(in) :: reqmin0
    integer, optional, intent(in) :: konvge0, kcount0
    integer, optional, intent(out) :: icount0,numres0

    real(kind=8), dimension(size(xmin)) :: start
    integer :: n,konvge,kcount,icount,numres
    real(kind=8) :: reqmin

    n = size(xmin)
    start = xmin

    if( present(reqmin0) ) then
       reqmin = reqmin0
    else
       reqmin = epsilon(ynewlo)
    end if

    if( present(konvge0) ) then
       konvge = konvge0
    else
       konvge = 1
    end if

    if( present(kcount0) ) then
       kcount = kcount0
    else
       kcount = 1000*n
    end if

    call nelmin(fn,n,start,xmin,ynewlo,reqmin,step,konvge,kcount,icount,numres,ifault)

    if( present(icount0) ) icount0 = icount
    if( present(numres0) ) numres0 = numres

  end subroutine nelmin1


  subroutine nelmin ( fn, n, start, xmin, ynewlo, reqmin, step, konvge, kcount, &
  icount, numres, ifault )

!*****************************************************************************80
!
!! NELMIN minimizes a function using the Nelder-Mead algorithm.
!
!  Discussion:
!
!    This routine seeks the minimum value of a user-specified function.
!
!    Simplex function minimisation procedure due to Nelder and Mead (1965),
!    as implemented by O'Neill(1971, Appl.Statist. 20, 338-45), with
!    subsequent comments by Chambers+Ertel(1974, 23, 250-1), Benyon(1976,
!    25, 97) and Hill(1978, 27, 380-2)
!
!    The function to be minimized must be defined by a function of
!    the form
!
!      function fn ( x, f )
!      real ( kind = 8 ) fn
!      real ( kind = 8 ) x(*)
!
!    and the name of this subroutine must be declared EXTERNAL in the
!    calling routine and passed as the argument FN.
!
!    This routine does not include a termination test using the
!    fitting of a quadratic surface.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    27 February 2008
!
!  Author:
!
!    Original FORTRAN77 version by R ONeill.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    John Nelder, Roger Mead,
!    A simplex method for function minimization,
!    Computer Journal,
!    Volume 7, 1965, pages 308-313.
!
!    R ONeill,
!    Algorithm AS 47:
!    Function Minimization Using a Simplex Procedure,
!    Applied Statistics,
!    Volume 20, Number 3, 1971, pages 338-345.
!
!  Parameters:
!
!    Input, external FN, the name of the function which evaluates
!    the function to be minimized.
!
!    Input, integer ( kind = 4 ) N, the number of variables.
!    0 < N is required.
!
!    Input/output, real ( kind = 8 ) START(N).  On input, a starting point
!    for the iteration.  On output, this data may have been overwritten.
!
!    Output, real ( kind = 8 ) XMIN(N), the coordinates of the point which
!    is estimated to minimize the function.
!
!    Output, real ( kind = 8 ) YNEWLO, the minimum value of the function.
!
!    Input, real ( kind = 8 ) REQMIN, the terminating limit for the variance
!    of the function values.  0 < REQMIN is required.
!
!    Input, real ( kind = 8 ) STEP(N), determines the size and shape of the
!    initial simplex.  The relative magnitudes of its elements should reflect
!    the units of the variables.
!
!    Input, integer ( kind = 4 ) KONVGE, the convergence check is carried out
!    every KONVGE iterations. 0 < KONVGE is required.
!
!    Input, integer ( kind = 4 ) KCOUNT, the maximum number of function
!    evaluations.
!
!    Output, integer ( kind = 4 ) ICOUNT, the number of function evaluations
!    used.
!
!    Output, integer ( kind = 4 ) NUMRES, the number of restarts.
!
!    Output, integer ( kind = 4 ) IFAULT, error indicator.
!    0, no errors detected.
!    1, REQMIN, N, or KONVGE has an illegal value.
!    2, iteration terminated because KCOUNT was exceeded without convergence.
!
  implicit none

  integer ( kind = 4 ) n

  real ( kind = 8 ), parameter :: ccoeff = 0.5D+00
  real ( kind = 8 ) del
  real ( kind = 8 ), parameter :: ecoeff = 2.0D+00
  real ( kind = 8 ), parameter :: eps = 0.001D+00
!  real ( kind = 8 ), external :: fn
  integer ( kind = 4 ) i
  integer ( kind = 4 ) icount
  integer ( kind = 4 ) ifault
  integer ( kind = 4 ) ihi
  integer ( kind = 4 ) ilo
  integer ( kind = 4 ) j
  integer ( kind = 4 ) jcount
  integer ( kind = 4 ) kcount
  integer ( kind = 4 ) konvge
  integer ( kind = 4 ) l
  integer ( kind = 4 ) numres
  real ( kind = 8 ) p(n,n+1)
  real ( kind = 8 ) p2star(n)
  real ( kind = 8 ) pbar(n)
  real ( kind = 8 ) pstar(n)
  real ( kind = 8 ), parameter :: rcoeff = 1.0D+00
  real ( kind = 8 ) reqmin
  real ( kind = 8 ) rq
  real ( kind = 8 ) start(n)
  real ( kind = 8 ) step(n)
  real ( kind = 8 ) x
  real ( kind = 8 ) xmin(n)
  real ( kind = 8 ) y(n+1)
  real ( kind = 8 ) y2star
  real ( kind = 8 ) ylo
  real ( kind = 8 ) ynewlo
  real ( kind = 8 ) ystar
  real ( kind = 8 ) z

  interface
     function fn(t)
       real(kind=8) :: fn
       real(kind=8), dimension(:), intent(in) :: t
     end function fn
  end interface


!
!  Check the input parameters.
!
  if ( reqmin <= 0.0D+00 ) then
    ifault = 1
    return
  end if

  if ( n < 1 ) then
    ifault = 1
    return
  end if

  if ( konvge < 1 ) then
    ifault = 1
    return
  end if
!
!  Initialization.
!
  icount = 0
  numres = 0
  jcount = konvge
  del = 1.0D+00
  rq = reqmin * real ( n, kind = 8 )
!
!  Initial or restarted loop.
!
  do

    p(1:n,n+1) = start(1:n)
    y(n+1) = fn ( start )
    icount = icount + 1
!
!  Define the initial simplex.
!
    do j = 1, n
      x = start(j)
      start(j) = start(j) + step(j) * del
      p(1:n,j) = start(1:n)
      y(j) = fn ( start )
      icount = icount + 1
      start(j) = x
    end do
!
!  Find highest and lowest Y values.  YNEWLO = Y(IHI) indicates
!  the vertex of the simplex to be replaced.
!
    ilo = minloc ( y(1:n+1), 1 )
    ylo = y(ilo)
!
!  Inner loop.
!
    do while ( icount < kcount )
!
!  YNEWLO is, of course, the HIGHEST value???
!
      ihi = maxloc ( y(1:n+1), 1 )
      ynewlo = y(ihi)
!
!  Calculate PBAR, the centroid of the simplex vertices
!  excepting the vertex with Y value YNEWLO.
!
      do i = 1, n
        pbar(i) = ( sum ( p(i,1:n+1) ) - p(i,ihi) ) / real ( n, kind = 8 )
      end do
!
!  Reflection through the centroid.
!
      pstar(1:n) = pbar(1:n) + rcoeff * ( pbar(1:n) - p(1:n,ihi) )
      ystar = fn ( pstar )
      icount = icount + 1
!
!  Successful reflection, so extension.
!
      if ( ystar < ylo ) then

        p2star(1:n) = pbar(1:n) + ecoeff * ( pstar(1:n) - pbar(1:n) )
        y2star = fn ( p2star )
        icount = icount + 1
!
!  Retain extension or contraction.
!
        if ( ystar < y2star ) then
          p(1:n,ihi) = pstar(1:n)
          y(ihi) = ystar
        else
          p(1:n,ihi) = p2star(1:n)
          y(ihi) = y2star
        end if
!
!  No extension.
!
      else

        l = 0
        do i = 1, n + 1
          if ( ystar < y(i) ) then
            l = l + 1
          end if
        end do

        if ( 1 < l ) then

          p(1:n,ihi) = pstar(1:n)
          y(ihi) = ystar
!
!  Contraction on the Y(IHI) side of the centroid.
!
        else if ( l == 0 ) then

          p2star(1:n) = pbar(1:n) + ccoeff * ( p(1:n,ihi) - pbar(1:n) )
          y2star = fn ( p2star )
          icount = icount + 1
!
!  Contract the whole simplex.
!
          if ( y(ihi) < y2star ) then

            do j = 1, n + 1
              p(1:n,j) = ( p(1:n,j) + p(1:n,ilo) ) * 0.5D+00
              xmin(1:n) = p(1:n,j)
              y(j) = fn ( xmin )
              icount = icount + 1
            end do

            ilo = minloc ( y(1:n+1), 1 )
            ylo = y(ilo)

            cycle
!
!  Retain contraction.
!
          else
            p(1:n,ihi) = p2star(1:n)
            y(ihi) = y2star
          end if
!
!  Contraction on the reflection side of the centroid.
!
        else if ( l == 1 ) then

          p2star(1:n) = pbar(1:n) + ccoeff * ( pstar(1:n) - pbar(1:n) )
          y2star = fn ( p2star )
          icount = icount + 1
!
!  Retain reflection?
!
          if ( y2star <= ystar ) then
            p(1:n,ihi) = p2star(1:n)
            y(ihi) = y2star
          else
            p(1:n,ihi) = pstar(1:n)
            y(ihi) = ystar
          end if

        end if

      end if
!
!  Check if YLO improved.
!
      if ( y(ihi) < ylo ) then
        ylo = y(ihi)
        ilo = ihi
      end if

      jcount = jcount - 1

      if ( 0 < jcount ) then
        cycle
      end if
!
!  Check to see if minimum reached.
!
      if ( icount <= kcount ) then

        jcount = konvge

        x = sum ( y(1:n+1) ) / real ( n + 1, kind = 8 )
        z = sum ( ( y(1:n+1) - x )**2 )

        if ( z <= rq ) then
          exit
        end if

      end if

    end do
!
!  Factorial tests to check that YNEWLO is a local minimum.
!
    xmin(1:n) = p(1:n,ilo)
    ynewlo = y(ilo)

    if ( kcount < icount ) then
      ifault = 2
      exit
    end if

    ifault = 0

    do i = 1, n
      del = step(i) * eps
      xmin(i) = xmin(i) + del
      z = fn ( xmin )
      icount = icount + 1
      if ( z < ynewlo ) then
        ifault = 2
        exit
      end if
      xmin(i) = xmin(i) - del - del
      z = fn ( xmin )
      icount = icount + 1
      if ( z < ynewlo ) then
        ifault = 2
        exit
      end if
      xmin(i) = xmin(i) + del
    end do

    if ( ifault == 0 ) then
      exit
    end if
!
!  Restart the procedure.
!
    start(1:n) = xmin(1:n)
    del = eps
    numres = numres + 1

  end do

  return
end subroutine nelmin

end Module NelderMead

!
!  Medians - common methods
!
!  Copyright © 2016-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!

! Medians:
! * qmed - quick-median (very fast ~2n)
! * median -  general median on base of quicksort (fast ~n*log(n))

module medians

  implicit none
  private

  ! numerical precision of real numbers
  integer, parameter, private :: dbl = selected_real_kind(15)

  interface median
     module procedure median_double, median_single
  end interface median

  interface qmedian
     module procedure qmedian_double, qmedian_single
  end interface qmedian

!  private :: qmed
  public :: median, qmedian

contains

  function qmedian_double(b,q)

    real(dbl) :: qmedian_double
    real(dbl),dimension(:),intent(in) :: b
    real(dbl), intent(in), optional :: q
    integer :: n, nmed

    n = size(b)

    if( n == 0 ) then
       qmedian_double = 0
       return
    else if( n == 1 ) then
       qmedian_double = b(1)
       return
    end if

    if( present(q) ) then
       nmed = nint(q*n)
    else ! q = 0.5 (median)
       nmed = n/2 + 1
    end if

    ! this is right just only for odd-th elements of the sequence,
    ! we're ignore the right way, assuming huge dataset, n > 50

    qmedian_double = qmed(b,nmed)

  end function qmedian_double


  function qmedian_single(b,q)

    real :: qmedian_single
    real,dimension(:),intent(in) :: b
    real, intent(in), optional :: q
    integer :: n, nmed

    n = size(b)

    if( n == 0 ) then
       qmedian_single = 0
       return
    else if( n == 1 ) then
       qmedian_single = b(1)
       return
    end if

    if( present(q) ) then
       nmed = nint(q*n)
    else ! q = 0.5 (median)
       nmed = n/2 + 1
    end if

    ! this is right just only for odd-th elements of the sequence,
    ! we're ignore the right way, assuming huge dataset, n > 50

    qmedian_single = real(qmed(real(b,dbl),nmed))

  end function qmedian_single


  ! Quick median by Wirth: Algorith + data structures = programs
  ! fastest known median algorithm ~2*n

  function qmed(b,k) result(x)

    integer, intent(in) :: k
    real(dbl), dimension(:), intent(in) :: b
    real(dbl), dimension(:), allocatable :: a
    real(dbl) :: w,x
    integer :: l,r,i,j

    allocate(a,source=b)

    l = 1
    r = size(a)
    x = a((l+r)/2+1)
    do while( l < r )
       x = a(k)
       i = l
       j = r
       do
          do while( a(i) < x )
             i = i + 1
          enddo
          do while( x < a(j) )
             j = j - 1
          enddo
          if( i <= j ) then
             w = a(i)
             a(i) = a(j)
             a(j) = w
             i = i + 1
             j = j - 1
          endif
          if( i > j ) exit
       enddo
       if( j < k ) l = i
       if( k < i ) r = j
    enddo
    deallocate(a)

  end function qmed


  ! General medians on base of quicksort

  function median_double(x) result(median)

    use quicksorter

    real(dbl), dimension(:), intent(in) :: x
    real(dbl) :: median
    integer :: n, n2
    real(dbl), dimension(:), allocatable :: y

    n = size(x)

    if( n == 0 ) then
       median = 0
       return
    else if( n == 1 ) then
       median = x(1)
       return
    end if

    allocate(y,source=x)
    call qsort(y)

    n2 = n / 2
!    write(*,*) n,n2,mod(n,2)
    if( mod(n,2) == 0 ) then
       ! even
       median = (y(n2+1) + y(n2)) / 2.0_dbl
    else
       ! odd
       median = y(n2+1)
    end if

    deallocate(y)

  end function median_double


  function median_single(x) result(median)

!    use quicksort

    real, dimension(:), intent(in) :: x
    real :: median
    integer :: n!, n2
    real(dbl), dimension(:), allocatable :: y

    n = size(x)
    allocate(y(n))
    y = x
    median = real(median_double(y))

!!$    call qsort(y)
!!$
!!$    n2 = n / 2
!!$    if( mod(n,2) == 0 ) then
!!$       ! even
!!$       median = real((y(n2+1) + y(n2))/2.0)
!!$    else
!!$       ! odd
!!$       median = real(y(n2+1))
!!$    end if
!!$
!!$    deallocate(y)

  end function median_single


end module medians

!
!  Robust estimation of factor in lambda of Poisson distribution
!     which is average number of events per time period.
!
!  Copyright © 2012 - 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with Resthmet.  If not, see <http://www.gnu.org/licenses/>.

module fluxmean

  ! This module implements a robust estimator of a ratio of events
  !
  !     t =  photon / counts
  !
  ! (including estimation of its scatter) appearing as the factor
  ! lambda parameter of Poisson distribution
  !
  !     Po(lambda) = lambda**k/k! * exp(-lambda),   lambda = t * C
  !
  !  which provides zero mean for difference of N1 - N2 events
  !  in Skellam's distribution
  !     https://en.wikipedia.org/wiki/Skellam_distribution
  !
  !  The estimation is valid only for large values of lambda >> 1
  !  in Gaussian regime when transformation
  !
  !      (photon - t*counts) / sqrt(photon_err**2 + t**2*count_err**2)
  !
  !  is valid. The approach usually requires proper estimates errors.
  !
  !  Both photons, counts should be non-integers > 1 as a product of
  !  previous computations.
  !
  !
  ! fmean should be called as:
  !
  !  call fmean(photons,photons_err,counts,counts_err,mean,stderr,stdsig,
  !             scale,reliable,poisson,verbose)
  !
  ! On input:
  !   photons - array of reference photon rates
  !   photons_err - array of statistical errors of photons
  !   counts - array of measured rates
  !   counts_err - array of statistical errors of counts
  !   verbose - print additional info
  !
  ! On output are estimated:
  !   mean - mean
  !   stderr (optional) - its standard error
  !   stdsig (optional) - estimate of standard deviation
  !   scale (optional) - estimate of scale
  !   reliable - indicates reliability of results (optional)
  !   poisson - indicates Poisson (.true.) or Normal (.false.)
  !             distribution used for determine of results (optional)
  !
  ! The given results  means that a true value T of the sample
  ! photons / counts can be, with 70% probability, found in interval
  !
  !         t - dt  <  T  <  t + dt
  !
  ! The estimate is performed as maximum of entropy of Poisson density
  ! for values of photons smaller than 'plimit' (666) or by robust estimate
  ! of parameters of Normal distribution. Both the estimates are robust.
  ! Poisson mean is estimated as the minimum of free energy:
  ! https://en.wikipedia.org/wiki/Helmholtz_free_energy

  use iso_fortran_env

  implicit none
  private

  integer, parameter, private :: kind = REAL64

  ! 50% quantil of N(0,1)
  real(kind), parameter, private :: Q50 = 0.6745

  ! debuging
  logical, private :: debug = .false.

  ! High limit for use of Poisson statistics (Normal otherwise)
  integer, parameter, private :: plimit = 666

  ! working arrays
  real(kind), dimension(:), pointer, private :: cts,dcts,pht,dpht
  real(kind), dimension(:), allocatable, private :: res,dcts2,dpht2,psi,sig
  real(kind), private :: zmean_sigma

  public :: fmean

  interface fmean
     module procedure fmean64, fmean32
  end interface fmean


contains

  subroutine fmean64(photons,photons_err,counts,counts_err, &
       mean,stderr,stdsig,scale,reliable,poisson,flag,verbose)

    use rfun

    real(kind), dimension(:), target, intent(in) :: &
         photons,photons_err,counts,counts_err
    real(kind), intent(out) :: mean
    real(kind), intent(out), optional :: stderr,stdsig,scale
    logical, intent(out), optional :: reliable, poisson
    integer, intent(out), optional :: flag
    logical, intent(in), optional :: verbose

    integer :: n,i,nplus,nsig,nstep,stat,nflag,iflag
    real(kind) :: t,dt,sum0,c,d,r,w,s,t0,s0,tmax,tmin,h11
    logical :: reli, poi
    character(len=80) :: errmsg

    debug = .false.
    if( present(verbose) ) debug = verbose

    ! data check
    if( .not. (all(photons > 0) .and. all(counts > 0) .and. &
         all(photons_err > 0) .and. all(counts > 0) ) ) then
       write(error_unit,*) 'fmean: some data has invalid values (needs all>0).'
       if( present(flag) ) flag = 4
       if( present(reliable) ) reliable = .false.
       return
    end if

    if(  size(counts) /= size(photons) .or. &
         size(counts) /= size(counts_err) .or. &
         size(counts_err) /= size(photons_err) ) then
       write(error_unit,*) 'fmean: input data of inconsistent length.'
       if( present(flag) ) flag = 4
       if( present(reliable) ) reliable = .false.
       return
    end if

    n = size(photons)
    pht => photons
    cts => counts
    dpht => photons_err
    dcts => counts_err

    if( n == 0 ) then ! no data
       mean = 1
       if( present(flag) ) flag = 2
       if( present(reliable) ) reliable = .false.
       if( present(stderr) ) stderr = 0
       if( present(stdsig) ) stdsig = 0
       if( present(scale) )  scale = 0
       return
    endif

    if( n == 1 ) then               ! a single point
       mean = photons(1) / counts(1)
       s = sqrt(photons_err(1)**2 + mean**2*counts_err(1)**2)
       if( present(stderr) ) stderr = s
       if( present(stdsig) ) stdsig = s
       if( present(scale) )  scale = 1
       if( present(poisson) ) poisson = .false.
       if( present(flag) ) flag = 2
       if( present(reliable) ) reliable = .true.
       return
    endif

    allocate(res(n),sig(n),psi(n),dpht2(n),dcts2(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'fmean: ',trim(errmsg)
       if( present(reliable) ) reliable = .false.
       if( present(flag) ) flag = 5
       return
    end if

    dpht2 = dpht**2
    dcts2 = dcts**2

    ! initial estimate of mean,scale.. by quantiles
    call rinit(t,s,sum0,h11,tmin,tmax,iflag)

    ! listing
    if( debug ) then
       i = max(int(log10(real(n))) - 1,0)
       nstep = 10**i
       if( nstep > 1 ) &
         write(*,'(a,i0,a)') 'Info: printing only every ',nstep,'th star.'
       call residuals(t,res,sig)
       write(*,*) 'Data table: pht(i),dpht(i),cts(i),dcts(i), ratio, residuals'
       do i = 1,n,nstep
          write(*,'(i3,1p,2(g15.5,g10.3),0pf11.3,f10.3)') &
               i,pht(i),dpht(i),cts(i),dcts(i),pht(i)/cts(i),res(i)/sig(i)
       end do
       write(*,'(a50,g0.4,1x,es7.1,1x,f0.3)') &
            "Initial mean, stderr, scale by quantiles: ",t,sum0/sqrt(h11*n),s
       write(*,'(a,3g15.5)') 'tmin, tmax:',tmin,tmax
       call graph_ecdf(t,s)
    end if

    if( abs(s) < 10*epsilon(s) )then

       ! Over 75% of the dataset contains identical values,
       ! results can be considered as reliable.

       mean = t
       if( present(stderr) )  stderr = sum0 / sqrt(real(n - 1))
       if( present(stdsig) )  stdsig = s
       if( present(scale) )   scale = s
       if( present(reliable) ) reliable = .true.
       if( present(poisson) ) poisson = .false.
       if( present(flag) ) flag = 3
       deallocate(res,sig,psi,dpht2,dcts2)
       return

    endif

!    if( debug .and. t < plimit ) &
!         write(*,*) 'Low fluxes determination is imprecise.'
!    if( t < plimit ) then
    if( .false. .and. t < plimit ) then

       t0 = t
       t = pmean(sum0/sqrt(h11*n),tmin,tmax,reli)
       if( reli .and. t > 0 ) then
          s = sqrt(t)
       else
          t = t0
       end if
       dt = s / sqrt(real(n - 1))


    else

       t0 = t
       s0 = s
       call rnorm(t,dt,s,sum0,h11,tmin,tmax,reli,nflag)
       if( debug ) write(*,*) 'rnorm: ',t,dt,s,reli,nflag
       if( .not. reli ) then
          t = t0
          s = s0
       end if

    end if

    ! residual sum
    if( debug ) then
       call residuals(t,res,sig)
       write(*,*) '# photons, computed counts, rel.err, expected rel.err, res., huber, dhuber:'
       do i = 1,n,nstep
          c = t*cts(i)
          d = (pht(i) - c)/((pht(i) + c)/2)
          w = sqrt((dpht(i)/t)**2 + dcts(i)**2)/((cts(i) + pht(i)/t)/2.0)
          r = res(i) / (sig(i)*s)
          write(*,'(i3,1p2g13.4,0p2f10.5,3f8.3)') &
               i,pht(i),c,d,w,r,huber(r),dhuber(r)
       enddo
       nsig = count(abs(res/sig) < s)
       nplus = count(res > 0 .and. abs(res/sig) < s)
       write(*,'(a,g0.5,a,1pg0.1,a,1pg0.2,5x,a,g0.3)') &
            'mean = ',t,' +- ',dt,'   stdsig = ',dt*sqrt(real(n)),'scale = ',s
       write(*,'(a,i0,a,i0,a,f0.1,a)') &
            'Points within 1-sigma error interval: ', &
            nsig,'/',n,' (',100.*real(nsig)/real(n),'%)'
       write(*,'(a,i0,"/",f0.1,", ",i0,"+-",f0.1)') &
            'Sign test in 1-sigma interval (total/expected, +): ',&
            nsig,nsig/2.0,nplus,sqrt(nplus*0.25 + 1e-3)
       ! test whatever the errors corresponds to values to prove Poisson origin
       ! it is same kind quantity as
       ! https://en.wikipedia.org/wiki/Index_of_dispersion
       write(*,'(a,2(1x,g0.3,1x,a,:","))') 'Mean Poissonity (best=1): ',&
            sqrt(sum(dpht**2/pht)/n),'(reference)', &
            sqrt(sum(dcts**2/cts)/n),'(data)'
       write(*,*) 'Poissonity:',poi,'   Reliable:',reli,'     Flag:',nflag
    end if

    mean = t
    if( present(stderr) ) stderr = dt
    if( present(stdsig) ) stdsig = dt*sqrt(real(n))
    if( present(scale) )  scale = s
    if( present(reliable) ) reliable = reli
    if( present(poisson) ) poisson = t < plimit
    if( present(flag) ) flag = nflag

    deallocate(res,sig,psi,dpht2,dcts2)

  end subroutine fmean64


  subroutine fmean32(photons,photons_err,counts,counts_err, &
       mean,stderr,stdsig,scale,reliable,poisson,flag,verbose)

    real(REAL32), dimension(:), target, intent(in) :: &
         photons,photons_err,counts,counts_err
    real(REAL32), intent(out) :: mean
    real(REAL32), intent(out), optional :: stderr,stdsig,scale
    logical, intent(in), optional :: verbose
    logical, intent(out), optional :: reliable, poisson
    integer, intent(out), optional :: flag

    real(kind) :: t,dt,s,c
    real(kind), dimension(:), allocatable :: x,dx,y,dy
    integer :: stat, iflag
    logical :: reli, poi
    character(len=80) :: errmsg

    allocate(x(size(photons)),dx(size(photons_err)), &
         y(size(counts)),dy(size(counts_err)),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'fmean32: ',trim(errmsg)
       if( present(reliable) ) reliable = .false.
       if( present(flag) ) flag = 5
       return
    end if

    x = photons
    dx = photons_err
    y = counts
    dy = counts_err

    if( present(verbose) ) then
       call fmean64(x,dx,y,dy,t,dt,s,c,reli,poi,iflag,verbose)
    else
       call fmean64(x,dx,y,dy,t,dt,s,c,reli,poi,iflag)
    end if

    mean = real(t)
    if( present(stderr) ) stderr = real(dt)
    if( present(stdsig) ) stdsig = real(s)
    if( present(scale) )   scale = real(c)
    if( present(reliable) ) reliable = reli
    if( present(poisson) ) poisson = poi
    if( present(flag) )       flag = iflag

  end subroutine fmean32


  ! --------------------------------------------------------

  subroutine rnorm(t,dt,s,sum0,h11,tmin,tmax,reliable,flag)

    use rfun
    use medians
    use likescale
    use quantilmean

    real(kind), intent(in out) :: t,s
    real(kind), intent(out) :: dt
    real(kind), intent(in) :: sum0,h11,tmin,tmax
    logical, intent(out) :: reliable
    integer, intent(out) :: flag

    real(kind) :: s0,t0,t1,dt1,d
    logical :: converge, treli, sreli
    integer :: n

    reliable = .false.
    t0 = t
    s0 = s
    n = size(pht)

    call rnewton(t,dt,s,treli)
    if( .not. treli ) then
       call zmean(s,sum0/sqrt(h11*n),tmin,tmax,t,treli)
       if( .not. treli ) t = t0
       if( debug ) write(*,*) 'zmean:',t,treli,sum0/sqrt(h11*n),dt
    end if

    if( treli ) then
       call residuals(t,res,sig)
       call iscale(res/sig,s,sreli,verbose=debug)
       if( .not. sreli ) s = s0
    else
       sreli = .false.
    end if

    if( debug ) write(*,'(a50,1pg15.5,1x,0pg8.2,1x,2l1)') &
         'Robust mean estimation, scale by information:',t,s,treli,sreli

    if( treli .and. sreli ) then

       t1 = t
       call rnewton(t1,dt1,s,converge)
       if( debug ) write(*,'(a20,1pg20.10,1p2g17.7,2l1)') &
            'Newton:',t1,dt1,converge,tmin < t1 .and. t1 < tmax

       converge = converge .and. (tmin < t1 .and. t1 < tmax)
       if( converge ) then
          t = t1
          dt = dt1
       end if
    else
       converge = .false.
       call residuals(t,res,sig)
       d = median(abs(res/(s*sig))) / Q50
       dt = d / sqrt(h11*n)
    end if

    reliable = treli
    if( treli .and. sreli .and. converge ) then
       flag = 0
    else
       flag = 1
    end if

    if( debug ) then
       call rmean_graph(t - 3*dt,t + 3*dt,s)
       call poisson_graph
    end if

  end subroutine rnorm

  subroutine residuals(t,res,sig)

    real(kind), intent(in) :: t
    real(kind), dimension(:), intent(out) :: res, sig
    real(kind) :: t2

    t2 = t**2
    res = (pht - t*cts)
    sig = sqrt(t2*dcts2 + dpht2)

  end subroutine residuals


  subroutine rnewton(t,dt,s,converge)

    use rfun

    real(kind), intent(in out) :: t
    real(kind), intent(out) :: dt
    real(kind), intent(in) :: s
    logical, intent(out) :: converge

    integer :: n,iter
    real(kind) :: tol,d,f,df,f2,dp,q
    real(kind), dimension(:), allocatable :: r,dpsi,ds,ds2,cs,dd,d1s,d2s

    converge = .false.

    if( .not. (s > 0) ) return

    n = size(pht)
    allocate(r(n),dpsi(n),ds(n),cs(n),ds2(n),dd(n),d1s(n),d2s(n))

    ! tolerance limit will depends on number of elements in sums
    ! because every element can include its rounding error...
    ! ... proportional to absolute value ...
    tol = 10*n*epsilon(t)*(abs(t) + 1)

    ! Number of iterations is limited by numerical precision.
    ! We belives, as optimists, that one order is reached by each iteration.
    ! But, the pesimist, inside us, says that the convergence can be slower.
    do iter = 1, precision(t)

       ! solution of f(t) = 0, where f(t) = sum(psi((n-t*c)/(s*ds))
       call residuals(t,r,ds)
       ds2 = ds**2
       call tukeys(r/(s*ds),psi,dpsi)
       dd = pht - t*cts
       d1s = t*dcts**2/ds
       d2s = dcts**2*(ds - t*d1s)/ds2
       cs = cts*ds + dd*d1s

       f = t*sum((psi*(r/ds)-1.0_kind)*(dcts/ds)**2) + sum(psi*cts/ds)
       df = sum(dpsi*(cts/ds + t*(r/ds)*dcts2/ds2)**2) &
           -sum(psi*(pht - 3*t*cts)*(dcts/ds)**2/ds) &
           +sum(psi*3*(r/ds)*t**2*(dcts/ds)**4) &
           +sum((dcts/ds)**2) - 2*t**2*sum((dcts2/ds2)**2)

       if( .not. (abs(df) > epsilon(df)) ) exit

       ! corrector for mean
       d = s * f / df

       ! update location
       t = t + d

       if( debug ) write(*,'(a,i2,1pg14.5,1p3g12.3)') &
            "mean, incr., f, f': ",iter,t,d,f,df

       f2 = sum(psi**2)  ! mean of psi**2
       dp = sum(dpsi)    ! mean of dpsi
       q = df*dp         ! df is an element of Jacobian
       if( f2 > 0 .and. q > 0 ) then
          dt = s*sqrt(f2/q*n/(n-1))
          converge = abs(d) < 0.001*dt
       else ! f2 == 0 or q == 0, t > |c|
          dt = 0
          if( abs(d) < tol ) exit
       end if

       ! exit of iterations: the absolute errot must be at least |d| < tol
       if( converge ) exit

    enddo

  end subroutine rnewton

  subroutine rinit(t,s,sum0,h11,tmin,tmax,flag)

    ! This is the very first estimation of ratio parameter.
    use medians
    use quantilmean

    real(kind), intent(out) :: t,s,sum0,h11,tmin,tmax
    integer, intent(out) :: flag

    integer, parameter :: medlim = 50 ! quick median limit
    real(kind) :: d,xmin,xmax

    if( size(pht) > medlim ) then
       t = qmedian(pht/cts)
       d = t*qmedian(sqrt(dcts2/cts**2 + dpht2/pht**2))
       h11 = qmedian(pht)
    else
       t = median(pht/cts)
       d = t*median(sqrt(dcts2/cts**2 + dpht2/pht**2))
       h11 = median(pht)
    end if
    h11 = h11 / (t**2*(1 + t)) ! /s**2
    call residuals(t,res,sig)

    ! determine parameters by empirical CDF quantilies
    call qbracket(res/sig,xmin,xmax,flag)
    if( flag /= 0 ) return

    ! Medians of pht/cts and res will differs in general (ignored).
    tmin = t + d*xmin
    tmax = t + d*xmax
    s = (xmax - xmin) / (2*Q50)

    if( s < 10*epsilon(s) ) then
       ! identical data
       sum0 = 0
       flag = 5
       return
    end if

    if( size(pht) > medlim ) then
       sum0 = qmedian(abs(res/(s*sig))) / Q50 ! qbracket?
    else
       sum0 = median(abs(res/(s*sig))) / Q50 ! qbracket?
    end if

  end subroutine rinit

  subroutine zmean(s,d,tmin,tmax,t,reli)

    use fmm

    real(kind), intent(in) :: s,d,tmin,tmax
    real(kind), intent(out) :: t
    logical, intent(out) :: reli
    real(kind) :: tol,h

    zmean_sigma = s
    tol = 0.001 * d
    t = zeroin(tmin,tmax,zfun,tol)

    h = 2*tol
    reli = tmin + h < t .and. t < tmax - h

    ! a realiable result is inside interval tmin .. tmax
    ! and not too close to the interval endpoints
    ! a result near to interval endpoints, it does raise suspicion ...

  end subroutine zmean


  function zfun(t)

    use rfun

    real(kind), intent(in) :: t
    real(kind) :: zfun, sigma

    sigma = zmean_sigma
    call residuals(t,res,sig)
    psi = tukey(res/(sigma*sig))

    zfun = ( t*sum((psi*(res/sig) - 1.0_kind)*(dcts/sig)**2) + &
         sum(psi*cts/sig) ) / sigma

  end function zfun


  function pmean(d,tmin,tmax,reli) result(t)

    use fmm

    real(kind) :: t
    real(kind), intent(in) :: d,tmin, tmax
    logical, intent(out) :: reli
    real(kind) :: h,tol

    tol = 0.001 * d
    t = fmin(tmin,tmax,negfree,tol)

    h = 2*tol
    reli = tmin + h < t .and. t < tmax - h

  end function pmean


  function negfree(t)

    use rfun, A => etukey

    ! negative free energy

    ! the largest argument for which exp() should be computed without
    ! issuing FPE flag
    real(kind), parameter :: emax = log(huge(emax)) / A

    real(kind), intent(in) :: t
    real(kind) :: negfree
    real(kind), dimension(:), allocatable :: f

    allocate(f(size(pht)))

    ! The density for Poisson distribution is computed by numerically reliable
    ! way: https://en.wikipedia.org/wiki/Poisson_distribution#Definition

    f = pht*log(t*cts) - t*cts - log_gamma(pht + 1)
    where( f < emax )
       f = exp(f)
    elsewhere
       f = 0
    end where
    negfree = - sum(f)
    deallocate(f)

  end function negfree


  ! --------------------------------------------------------

  subroutine poisson_graph

    integer, parameter :: nmax = 1000
    integer :: n
    real(kind) :: t,dt,rmin,rmax
    real(kind), dimension(:), allocatable :: f

    allocate(f(size(pht)))

    rmax = maxval(pht/cts)
    rmin = minval(pht/cts)
    dt = (rmax - rmin) / nmax

    open(1,file='/tmp/f')
    do n = 1,nmax,2
       t = rmin + dt*n
       f = pht*log(t*cts) - t*cts - log_gamma(pht+1)
       write(1,*) t,sum(exp(f)),sum(f*exp(f))
    end do
    close(1)

    deallocate(f)

  end subroutine poisson_graph

  subroutine rmean_graph(t1,t2,s)

    use rfun

    real(kind), intent(in) :: t1,t2,s
    real(kind) :: t,dt
    real(kind), dimension(:), allocatable :: r,rho
    integer :: i,n

    if( .not. (s > 0) ) return

    n = size(pht)
    allocate(r(n),rho(n))

    dt = (t2 - t1) / 1000

    open(1,file='/tmp/r')
    do i = 1,1000,10
       t = t1 + dt*i

       call residuals(t,res,sig)
       rho = ihuber(res/(s*sig))

       write(1,*) t,sum(rho)
    end do
    close(1)

    deallocate(r,rho)

  end subroutine rmean_graph



  subroutine graph_ecdf(t,s)

    use quantilmean

    real(kind), intent(in) :: t,s
    real(kind), dimension(:), allocatable :: xcdf,ycdf
    integer :: n,l,u

    if( .not. s > 0 ) return

    n = size(pht)
    allocate(xcdf(n),ycdf(n))
    call residuals(t,res,sig)
    call ecdf(res/(s*sig),xcdf,ycdf)

    open(newunit=u,file='/tmp/cdf1')
    do l = 1, n
       write(u,*) xcdf(l),ycdf(l)
    end do
    close(u)

  end subroutine graph_ecdf

end module fluxmean

!
! gfortran -Wall  -fcheck=all  teststat.f95 -L. -L../minpack -lrstat -lsort -llmin -lminpacks -lminpack -lm
!

program testmean

  use oakleaf
  use noise
  use toolbox
  use testsuite

  implicit none

  integer, parameter :: rp = selected_real_kind(15)
  character(len=15), parameter :: fmt = '(a,l3)'
  integer :: voltage

  call randomnoise

  call get_environment_variable("VOLTAGE",status=voltage)

  if( .not. (voltage == 0) ) then

     call tester(build)

  else

     call tester(identity)
     call tester(widentity)
     call tester(patolog1)
     call tester(patolog2)
     call tester(patolog3)
     call tester(patolog4)
     call tester(patolog5)
     call tester(patolog6)
     call tester(patolog7)
     call tester(dark1)
     call tester(dark2)
     call tester(normal01)
     call tester(mixed09)
     call tester(poisson1)
     call tester(poisson2)

  end if


!  call histogram(t,-5.0_rp,5.0_rp,50,'/tmp/h')

!  stop 0
!50 continue




!!$  ! double Normal
!!$  write(*,*)
!!$  do i = 1, size(t)
!!$     call random_number(u)
!!$     if( u > 0.5 ) then
!!$        t(i) = gnoise(1.0_rp,0.1_rp)
!!$     else
!!$        t(i) = gnoise(0.0_rp,0.1_rp)
!!$     end if
!!$  end do
!!$  u = sum(t)/size(t)
!!$  s = sqrt(sum((t-u)**2)/(size(t)-1.0))
!!$  v = s / sqrt(size(t)-0.0)
!!$  write(*,*) "Amean 0.5: N(0,1) + 0.5: N(0,1): ",u,v,s
!!$  call rmean(t,u,v,s)
!!$  write(*,*) "Rmean 0.5: N(0,1) + 0.5: N(0,1): ",u, v,s
!!$
!!$45 continue
!!$  write(*,*) '--- N(0,1) ---'
!!$  do i = 1, size(t)
!!$     call random_number(u)
!!$     t(i) = gnoise(0.0_rp,1.0_rp)
!!$  end do
!!$  u = sum(t)/size(t)
!!$  s = sqrt(sum((t-u)**2)/(size(t)-1.0))
!!$  v = s / sqrt(size(t)-0.0)
!!$  write(*,*) "Amean: N(0,1): ",u,v,s
!!$  call rmean(t,u,v,s)
!!$  write(*,*) "Rmean: N(0,1): ",u,v,s



contains


  subroutine build

    real(rp), dimension(:), allocatable :: t
    type(suite) ::rob
    logical :: cond

    integer :: n

    n = 10**4
    allocate(t(n))
    call gnoise_fill(0.0_rp,1.0_rp,t)
    write(*,*) 'N(0,1) n=',n
    call rob%robstat(t)
    cond = abs(rob%t - 0) < 3*rob%dt
    write(*,'(a,l2)') 'TEST build PASS:',cond
    write(*,*)

  end subroutine build

  subroutine identity

    real(rp), dimension(100) :: x
    type(suite) :: std, rob, qt
    logical :: cond

    x = 0

    write(*,*) 'Identity..'
    call std%stdstat(x)
    call rob%robstat(x)
    call qt%qtstat(x)
    cond = abs(rob%t-0) < epsilon(x) .and. abs(rob%s) < epsilon(x)
    write(*,fmt) 'TEST identity PASS:',cond

  end subroutine identity

  subroutine widentity

    real(rp), dimension(100) :: x,w
    type(suite) :: std, rob, qt
    logical :: cond

    x = 0
    w = 1

    write(*,*) 'Identity..'
    call std%stdwstat(x,w)
    call rob%robwstat(x,w)
    cond = abs(rob%t-0) < epsilon(x) .and. abs(rob%s) < epsilon(x)
    write(*,fmt) 'TEST widentity PASS:',cond

  end subroutine widentity


  subroutine patolog1

    real(rp), dimension(16) :: w
    type(suite) :: std, rob, qt
    logical :: cond

    w = [ 10109.000000000000 ,  10109.000000000000 ,   10109.000000000000 , &
       10109.000000000000 ,   10109.000000000000  ,      10109.000000000000  , &
       10109.000000000000 ,   10109.000000000000   ,     10109.000000000000  , &
       729415.00000000000 ,   10109.000000000000  ,      10109.000000000000 , &
       10109.000000000000 ,   10109.000000000000  ,      10109.000000000000 , &
       10109.000000000000 ]

    write(*,*) 'Patolog1..'
    call std%stdstat(w)
    call rob%robstat(w)
    call qt%qtstat(w)
    cond = abs(rob%t-10109) < epsilon(w) .and. abs(rob%s) < epsilon(w)
    write(*,fmt) 'TEST patolog1 PASS:',cond

  end subroutine patolog1

  subroutine patolog2

    real(rp), dimension(9) :: w
    type(suite) :: std, rob, qt
    logical :: cond

    w = [ 0.00000000,       0.00000000,       0.00000000,       0.00000000, &
       0.00000000,       0.00000000,       109.288963,       18.7713432, &
       0.00000000 ]

    write(*,*) 'Patolog2 zeros..'
    call std%stdstat(w)
    call rob%robstat(w)
    call qt%qtstat(w)
    cond = abs(rob%t) < 3*rob%dt
    write(*,fmt) 'TEST patolog2 PASS:',cond

  end subroutine patolog2

  subroutine patolog3

    real(rp), dimension(4) :: w
    type(suite) :: std, rob, qt
    logical :: cond

    w = [2.25176118E-05, 4.98100162E-05, 2.31736030E-05,   9.98998730E-05]

    write(*,*) 'Patolog 3'
    call std%stdstat(w)
    call rob%robstat(w)
    call qt%qtstat(w)
    cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2)
    write(*,fmt) 'TEST patolog3 PASS:',cond

  end subroutine patolog3


  subroutine patolog4

    real(rp), dimension(10) :: t,dt
    type(suite) :: std, rob
    logical :: cond

    t = [ 0.998451293, 0.999660850,       1.00406659,       1.00311661, &
         1.00328016, 0.997870922, 0.998634219, 1.00346828, 1.00324047, &
         1.00227821]
    dt = [1.56288221E-03,  1.58239249E-03,   1.71578780E-03,   1.52544561E-03,&
       1.66450685E-03,   1.63013267E-03,   1.79429608E-03,   1.97814801E-03,  &
       1.90186617E-03,   2.12184014E-03 ]

    write(*,*) 'Patolog4 weights'
    call std%stdwstat(t,dt)
    call rob%robwstat(t,dt)
    cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2)
    write(*,fmt) 'TEST patolog4 PASS:',cond

  end subroutine patolog4


  subroutine patolog5

    real(rp), dimension(14) :: t,dt
    type(suite) :: std, rob
    logical :: cond

    t = [1.01148117, 1.00847173, 1.00453901,1.00900149,1.00946915,1.00475299,&
       1.01501632, 1.01952410, 1.02912927, 1.01704729, 1.01167893, 1.00378621,&
       1.00812364,       1.01006317 ]
    dt = [9.00068413E-03,1.02015464E-02,1.14752613E-02,1.28761921E-02, &
       1.43292071E-02,4.06658743E-03, 4.41102358E-03, 4.76694433E-03,  &
       5.16087562E-03, 5.52221620E-03,5.91059681E-03, 6.32086722E-03, &
       6.86141895E-03, 7.88705982E-03 ]

    write(*,*) 'Patolog5 weights'
    call std%stdwstat(t,dt)
    call rob%robwstat(t,dt)
    cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2)
    write(*,fmt) 'TEST patolog5 PASS:',cond

  end subroutine patolog5

  subroutine patolog6

    real(rp), dimension(5) :: t,dt
    type(suite) :: std, rob
    logical :: cond

    t = [1.43887237E-05,   1.31587876E-04,   6.08701703E-05,  &
         8.92234530E-05,   7.58275419E-05 ]
    dt = [ 7.17469447E-06,  2.02281808E-05,  1.49832149E-05, 1.97298232E-05, &
         1.98863454E-05 ]

    write(*,*) 'Patolog6 weights'
    call std%stdwstat(t,dt)
    call rob%robwstat(t,dt)
    cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2)
    write(*,fmt) 'TEST patolog6 PASS:',cond

  end subroutine patolog6

  subroutine patolog7

    real(rp), dimension(14) :: t,dt
    type(suite) :: std, rob, stdw, robw
    logical :: cond

    t = [1.01148117, 1.00847173, 1.00453901,1.00900149,1.00946915,1.00475299,&
       1.01501632, 1.01952410, 1.02912927, 1.01704729, 1.01167893, 1.00378621,&
       1.00812364,       1.01006317 ]
    dt = [9.00068413E-03,1.02015464E-02,1.14752613E-02,1.28761921E-02, &
       1.43292071E-02,4.06658743E-03, 4.41102358E-03, 4.76694433E-03,  &
       5.16087562E-03, 5.52221620E-03,5.91059681E-03, 6.32086722E-03, &
       6.86141895E-03, 7.88705982E-03 ]
    dt = 1

    write(*,*) 'Patolog7 unique weights'
    call std%stdstat(t)
    call rob%robstat(t)
    call stdw%stdwstat(t,dt)
    call robw%robwstat(t,dt)
    cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2) .and. &
         abs(robw%t-stdw%t) < 3*sqrt(stdw%dt**2 + robw%dt**2) .and. &
         abs(robw%t-rob%t) <  3*sqrt(robw%dt**2 + rob%dt**2) .and. &
         abs(robw%s-rob%s) / max(robw%s,rob%s) < 0.1 .and. &
         abs(robw%dt-rob%dt) / max(robw%dt,rob%dt) < 0.1
    write(*,fmt) 'TEST patolog7 PASS:',cond

  end subroutine patolog7


  subroutine dark1

    real(rp), dimension(7) :: t = [16, 12, 99,95,18,87,10 ]
    type(suite) :: std, rob
    logical :: cond

    write(*,*) 'dark1'
    call std%stdstat(t)
    call rob%robstat(t)
    cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2)
    write(*,fmt) 'TEST dark1 PASS:',cond

  end subroutine dark1


  subroutine dark2

    real(rp), dimension(7) :: t = [ 142, 141, 149, 149, 142, 148,149 ]
    type(suite) :: std, rob, qt
    logical :: cond

    write(*,*) 'dark2 favorite'
    call std%stdstat(t)
    call rob%robstat(t)
    call qt%qtstat(t)
    cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2)
    write(*,fmt) 'TEST dark2 PASS:',cond

  end subroutine dark2


  subroutine normal01

    real(rp), dimension(:), allocatable :: t
    type(suite) :: std, rob, qt
    logical :: cond

    integer :: m,n

    do m = 1,6
       n = 10**m
       allocate(t(n))
       call gnoise_fill(0.0_rp,1.0_rp,t)
       write(*,*) 'N(0,1) n=',n
       call std%stdstat(t)
       call rob%robstat(t)
       call qt%qtstat(t)
       cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2) .and. &
            abs(rob%t-0) < 3*rob%dt
       write(*,'(a,i0,a,l2)') 'TEST normal01(',n,') PASS:',cond
       write(*,*)
       deallocate(t)
    end do

  end subroutine normal01

  subroutine mixed09

    real(rp), dimension(:), allocatable :: t
    type(suite) :: std, rob, qt
    logical :: cond

    integer :: m,n,k,l

    do m = 1,6
       n = 10**m
       allocate(t(n))
       call gnoise_fill(0.0_rp,1.0_rp,t)

       k = int(0.9*n)
       do l = 1, k
          t(l) = gnoise(0.0_rp,1.0_rp)
       end do
       do k = k+1, n
          t(l) = gnoise(1.0_rp,10.0_rp)
       end do

       write(*,*) '0.9*N(0,1)+0.1*N(0,10)  n=',n
       call std%stdstat(t)
       call rob%robstat(t)
       call qt%qtstat(t)
       cond = abs(rob%t-std%t) < 3*sqrt(std%dt**2 + rob%dt**2) .and. &
            abs(rob%t-0) < 3*rob%dt
       write(*,'(a,i0,a,l2)') 'TEST mixed09(',n,') PASS:',cond
       write(*,*)
       deallocate(t)
    end do

  end subroutine mixed09

  subroutine poisson1

    real(rp), dimension(:), allocatable :: t,dt
    type(suite) :: std, rob, qt, stdw, robw
    logical :: cond

    integer :: m,n,l
    real(rp) :: mean

    mean = 10**6

    do m = 1,6
       n = 10**m
       allocate(t(n),dt(n))

       do l = 1, n
          t(l) = pnoise(mean)
       end do

       write(*,*) 'Po(10**6)  n=',n
       call std%stdstat(t)
       call rob%robstat(t)
       call qt%qtstat(t)

       dt = sqrt(t)
       call stdw%stdwstat(t,dt)
       call robw%robwstat(t,dt)
       cond = abs(robw%t-mean) < 3*robw%dt
       write(*,'(a,i0,a,l2)') 'TEST poisson1(',n,') PASS:',cond
       write(*,*)
       deallocate(t,dt)
    end do

  end subroutine poisson1

  subroutine poisson2

    real(rp), dimension(:), allocatable :: t,dt
    logical :: cond
    type(suite) :: std, rob, qt, stdw, robw

    integer :: m,n,k,l
    real(rp) :: mean

    mean = 10**6

    do m = 1,6
       n = 10**m
       allocate(t(n),dt(n))

       k = int(0.9*n)
       do l = 1, k
          t(l) = pnoise(mean)
       end do
       do l = k+1, n
          t(l) = pnoise(10*mean)
       end do

       write(*,*) '0.9*Po(10000)+0.1*Po(10**5)  n=',n
       call std%stdstat(t)
       call rob%robstat(t)
       call qt%qtstat(t)

       dt = sqrt(t)
       call stdw%stdwstat(t,dt)
       call robw%robwstat(t,dt)
       cond = abs(robw%t-mean) < 3*robw%dt
       write(*,'(a,i0,a,l2)') 'TEST poisson2(',n,') PASS:',cond

       write(*,*)
       deallocate(t,dt)
    end do

  end subroutine poisson2


end program testmean

!
!  Estimates on median base
!
!  Copyright © 2001 - 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!

module madmean

  implicit none
  private

  ! print additional debuging results
  logical, parameter, private :: debug = .false.

  ! numerical precision of real numbers
  integer, parameter, private :: kind = selected_real_kind(15)

  ! 50% quantil of N(0,1)
  real(kind), parameter, private :: Q50 = 0.6745

  public :: madmed, madwmed

contains

  subroutine madmed(x,t,s)

    ! initial estimate of parameters

    use medians
    use quantilmean

    real(kind), dimension(:),intent(in) :: x
    real(kind), intent(out) :: t,s

    real(kind) :: mad,med
    integer :: n

    n = size(x)

    if( n > 50 ) then

       ! This choice of the threshold, used for median computation method,
       ! assumes that odd and even elements in sequence are the same (within
       ! requested precision). Note that qmed is the fastest known algorithm
       ! (~ 2*n) while median is simpler and slower (~ n*log(n)).

       med = qmedian(x)
       mad = qmedian(abs(x - med))

       ! correction for Normal distribution
       s = mad / q50
       t = med

    else if( n > 13 ) then

       ! correct way to compute median (two middle values)
       med = median(x)
       mad = median(abs(x - med))

       ! correction for Normal distribution
       s = mad / q50
       t = med

    else if( n > 2 ) then

       ! compute parameters by empirical CDF quantilies
       call qmean(x,t,stdsig=s)

    else if( n == 2 ) then

       t = (x(1) + x(2))/2
       s = abs(x(1) - x(2))/2

    else if( n == 1 ) then

       t = x(1)
       s = 0

    else

       t = 0
       s = 0

    end if

  end subroutine madmed

  subroutine madwmed(x,dx,t,s,d)

    ! This routine performs an initial estimate of both mean and scale
    ! using both median and absolute value.

    use medians
    use quantilmean

    real(kind), dimension(:),intent(in) :: x, dx
    real(kind), intent(out) :: t,s,d

    real(kind) :: mad,med
    integer :: n

    n = size(x)

    if( n > 50 ) then

       ! This choice of the threshold used for median computation method
       ! assumes that odd and even elements in sequence are the same (within
       ! requested precision). Note that qmed is the fastest known algorithm
       ! (~2*n) while median is simpler and slower (~n*log(n)).

       d = qmedian(dx)
       med = qmedian(x)
       mad = qmedian(abs(x - med)) / d

       ! correction for Normal distribution
       s = mad / q50
       t = med

    else if( n > 13 ) then

       ! correct way to compute median (two middle values)
       d = median(dx)
       med = median(x)
       mad = median(abs(x - med)) / d

       ! correction for Normal distribution
       s = mad / q50
       t = med

    else if( n > 2 ) then

       ! compute parameters by empirical CDF quantilies
       call qmean(dx,d,stdsig=s)
       call qmean(x,med,stdsig=s)
       call qmean(abs(x - med),mad,stdsig=s)
       mad = mad / d
       s = mad / q50
       t = med

    else if( n == 2 ) then

       d = (dx(1) + dx(2)) / 2
       t = (x(1) + x(2)) / 2
       s = abs(x(1) - x(2)) / d

    else if( n == 1 ) then

       d = dx(1)
       t = x(1)
       s = 1

    else

       d = 1
       t = 0
       s = 1

    end if

  end subroutine madwmed

end module madmean

program plot_rfun

  use oakleaf
  use iso_fortran_env

  implicit none

  real(REAL64) :: x
  integer :: i

  open(1,file='hubers')
  do i = -1000,1000
     x = i / 100.0
     write(1,*) x,huber(x),dhuber(x),ihuber(x)
  end do
  close(1)

  open(1,file='tukeys')
  do i = -1000,1000
     x = i / 100.0
     write(1,*) x,tukey(x),dtukey(x),itukey(x)
  end do
  close(1)

end program plot_rfun

!
!  Scale by entropy, or quantiles
!
!  Copyright © 2017-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!

module entropyscale

  ! This module provides escale subroutine for estimation of scale
  ! by maximalising of relative entropy.
  !
  ! escale should be called as:
  !
  !  call escale(r,s,reliable,flag,verbose)
  !
  ! on input:
  !   r - array of residuals: (data-mean), (data-mean)/errors, ...
  !   verbose (optional) - print additional informations
  !
  ! on output are estimated:
  !   s - scale
  !   reliable (optional) - indicates reliability of result
  !                         if .true., scale has been correctly
  !                         localised. if .false., s is undefined
  !   flag (optional) - indicates reliability of results:
  !          0 == success, results are both reliable and precise
  !          1 == consider rough estimate due convergence fail, try verbose
  !          2 == basic estimates, few datapoints available
  !          3 == data looks nearly identical
  !          5 == failed to allocate memory, initial estimates are returned
  !
  ! Caveats.
  !
  ! The implemented algorithm looks for minimum of negative entropy.
  ! Sometimes, commonly, for strongly non-Normal data, the function
  ! has more minimums. It can be impossible to distinguish between them
  ! (a false and the right minimus). The minimum  is selected with
  ! certain probability of false success.  As a consequence, more
  ! separated groups of results can be given which looks as a bifurcation.
  ! Result can be always verified by a K-S kind test.
  !
  ! Note.
  ! The scale parameter corrects oddly estimated statistical
  ! errors of passed data (dx). For most applications,
  ! the value is expected near number one: escale ~= 1.
  !
  ! https://en.wikipedia.org/wiki/Half-normal_distribution
  !

  use rfun
  use iso_fortran_env

  implicit none
  private

  ! print debug information ?
  logical, private :: debug = .false.

  ! numerical precision of real numbers
  integer, parameter, private :: kind = selected_real_kind(15)

  ! minimal precision of results
  real(kind), parameter, private :: etol = 0.1

  ! scale entropy parameter
  real(kind), parameter, private :: A = etukey

  ! the largest argument for which exp() can be computed without FPE flag issue
  real(kind), parameter, private :: rhomax = log(huge(rhomax)) / A

  ! data buffer
  real(kind), dimension(:), allocatable, private :: rho

  ! data pointer, just pointer
  real(kind), dimension(:), pointer, private :: res

  private :: negentropy, newton, grid, gmin

  public :: escale, escale_graph

contains

  subroutine escale(r,s,reliable,flag,verbose)

    ! An estimator of scale parameter as maximum of entropy
    ! (implemented as minimum of negative entropy).

    use quantilmean

    real(kind), dimension(:), target, intent(in) :: r
    real(kind), intent(out) :: s
    integer, intent(out), optional :: flag
    logical, intent(out), optional :: reliable
    logical, intent(in), optional :: verbose

    real(kind), dimension(:), allocatable :: xcdf, ycdf
    character(len=80) :: errmsg
    real(kind) :: s0,s1,smin,smax,qmin,qmax,qhalf
    integer :: n, stat
    logical :: found,converge

    debug = .false.
    if( present(verbose) ) debug = verbose

    n = size(r)
    res => r

    if( n == 0 ) then
       s = 0
       if( present(flag) ) flag = 2
       if( present(reliable) ) reliable = .false.
       return
    end if

    if( n == 1 ) then
       s = abs(res(1))
       if( present(flag) ) flag = 2
       if( present(reliable) ) reliable = .true.
       return
    end if

    if( debug ) write(*,'(a,2g15.3)') &
         'Maximum and minimum: ',minval(abs(res)),maxval(abs(res))

    allocate(xcdf(n),ycdf(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'escale: ',trim(errmsg)
       if( present(flag) ) flag = 5
       if( present(reliable) ) reliable = .false.
       return
    end if

    ! cummulative distribution function
    call ecdf(abs(res),xcdf,ycdf)

    ! keep eCDF
    block
      integer :: l
      if( debug ) then
         open(7,file='/tmp/c')
         do l = 1, n
            write(7,*) xcdf(l),ycdf(l)
         end do
         close(7)
      end if
    end block

    ! the very first, rought, estimate of scale at Q(0.6745), backup estimate
    qhalf = 0.6745
    s0 = quantile(qhalf,xcdf,ycdf)

    ! the intial interval is determined by qmin and qmax quantiles
    qmin = 0.4    ! = 0.5*s
    qmax = 0.87   ! = 1.5*s

    ! quantile for Q(0.87) for 1.5*x, or 1.5*s0, gives upper bound
    if( qmax < ycdf(n) ) then
       smax = quantile(qmax,xcdf,ycdf)
    else ! if( Q(0.87) is out of CDF values ) then
         ! the interval of q is uncovered for a few points
       smax = 1.5 * s0  ! = Q(4/5) * s0
    end if

    smin = max(quantile(qmin,xcdf,ycdf), epsilon(smin))

    deallocate(xcdf,ycdf)

    if( debug ) write(*,'(a,2g15.3,a,g15.3)') &
         'Quantiles bracketing:',smin,smax,'   Qmean:',s0

    ! check: smax > smin, s > 0, identical or zero value data
    if( (smax - smin) < 10*epsilon(s) .or. abs(smax) < 10*epsilon(s) ) then
       s = s0
       deallocate(rho)
       if( present(flag) ) flag = 3
       if( present(reliable) ) reliable = .true.
       return
    end if

    allocate(rho(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'escale: ',trim(errmsg)
       if( present(flag) ) flag = 5
       if( present(reliable) ) reliable = .false.
       return
    end if

    ! Optimum determination
    ! The extreme is searched by an optimisation method without derivatives.
    ! Determination is reliable but slower than follow-up Newton method.
    if( debug ) open(7,file='/tmp/s')
    if( n < 17 ) then

       ! If there are a few elements only, we will inspect full
       ! interval given by range of |res|. Any mixed distributions
       ! (Normal with some contamination) or plain random number
       ! generator will cause function with more minimums. We will
       ! select the most probable one, but is it the right one? Maybe?
       ! To distinguish the right minimum, any additional information
       ! should be included.

       call grid(smin,smax,s,found)

    else ! if( n is large ) then

       call gmin(smin,smax,s,found)

    end if
    if( debug ) close(7)

    if( found ) then

       ! We are attemping to do 10x more precise estimate of the scale
       ! by fast Newtons's method. The convergence sucess is given
       ! by starting point.
       s1 = s
       call newton(s1,0.1*etol,converge)
       ! Newton method is kind of root-find metod. We are looking for
       ! maximum of a function so we work with derivatives of the function.
       ! By second derivative, we can choice if it is truly maximum
       ! (and no only minimum).
       converge = converge .and. smin < s1 .and. s1 < smax
       if( converge  ) s = s1
    else

       ! if minimum is not found, recovers by backup solution
       ! this is common for a few datapoints with strongly non-Normal
       ! distribution
       converge = .false.
       s = s0
    end if

    if( present(flag) ) then
       if( converge ) then
          flag = 0
       else
          flag = 1
       end if
    end if
    if( present(reliable) ) reliable = .true.

    deallocate(rho)

  end subroutine escale

  function negentropy(s)

    ! negative of entropy per data point

    real(kind) :: negentropy
    real(kind), intent(in) :: s

    rho = itukey(res/s)
    negentropy = - sum(rho*exp(-A*rho), rho < rhomax) / size(rho)
    ! The sum includes only values within range acceptable for exp() function.
    ! Otherwise, FPE flag indicating underflow will be raised, although
    ! validity of results is untouched.

    if( debug ) write(7,*) s,negentropy

  end function negentropy

  subroutine newton(s,tol,converge)

    real(kind), intent(in) :: tol
    real(kind), intent(in out) :: s
    logical, intent(out) :: converge

    real(kind), dimension(:), allocatable :: psi, dpsi, erho
    integer :: n,it,stat
    real(kind) :: d,f,df,sum1,sum2
    character(len=80) :: errmsg

    converge = .false.

    n = size(res)
    allocate(psi(n),dpsi(n),erho(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       if( debug ) write(error_unit,*) 'Netwon scale: ',trim(errmsg)
       return
    end if
    ! Newton needs to allocate additional memory.
    ! If the memory is unavailable, we exiting and fail-back
    ! solution must be used.

    ! Newton's iterations
    do it = 1, precision(s)

       if( .not. (s > epsilon(s)) ) return

       call tukeys(res/s,psi,dpsi,rho)

       where( rho < rhomax )
          erho = exp(-A*rho)
       elsewhere
          erho = 0.0_kind
       end where
       sum1 = sum(psi*(1.0_kind - A*rho)*res*erho)
       sum2 = sum((A*psi**2 + (1.0_kind - A*rho)*(A*psi**2 - dpsi))*res**2*erho)
       f = sum1
       df = (sum2 / s - 2.0_kind*sum1) / s

       if( .not. (abs(df) > epsilon(df) .and. -df < 0) ) exit

       ! corrector for mean
       d = f / df

       ! update location
       s = s - d

       if( debug ) write(*,'(a,i2,1pg20.6,1p3g10.2)') &
            "#, s, inc., f, f': ",it,s,d,-f/s**2,-df/s**2

       ! exit of iterations: the absolute errot must be at least |d| < tol
       converge = abs(d) < tol
       if( converge ) exit

    enddo

    ! second derivation of neg-entropy is positive for a stable local minimum
    converge = converge .and. -df < 0

  end subroutine newton

  subroutine grid(smin,smax,s,found)

    ! Grid search
    !
    ! The search looks for minimum on a grid within an interval
    ! of smin .. smax. Grid search examines all possible minimas
    ! of negentropy(). Every minimum reveals a group of data subset
    ! with similar values. The most probable solutions corresponds
    ! to the most numerous group.

    real(kind), intent(in) :: smin, smax
    real(kind), intent(out) :: s
    logical, intent(out) :: found

    ! grid elements
    real(kind), dimension(:), allocatable :: ord, tab
    real(kind) :: h,p,pmax
    integer :: n,ngrid,cmin,nmin

    ! develop grid
    ! common smin .. smax interval corresponds to 2-3 sigma,
    ! step is at least 1/10 of sigma
    ngrid = 23

    allocate(ord(ngrid+2),tab(ngrid+2))
    h = (smax - smin) / (ngrid+2)

    ! the first point is close to zero (but non-zero!)
    do n = 1, ngrid+2
       s = smin + (n-1)*h
       ord(n) = s
       tab(n) = negentropy(s)
       !          if( debug ) write(7,*) ord(n),tab(n) in negentropy....
    end do

    ! locate minimum
    ! minimal limit of probability, meaning that the maximum
    ! corresponds to group of over 50% of datapoints
    pmax = 0.5
    cmin = 0
    nmin = 0
    do n = 2, ngrid+1
       if( tab(n-1) > tab(n) .and. tab(n) < tab(n+1) ) then
          cmin = cmin + 1

          p = sum(dtukey(res/ord(n))) / size(res)
          if( p > pmax ) then
             nmin = n
             pmax = p
          end if

          if( debug ) write(*,'(a,i3,g15.3,f10.2)') &
               'minloc:',n,ord(n),p
       end if

    end do
    if( nmin > 0 ) then
       s = ord(nmin)
    else
       s = 0
    end if

    deallocate(tab,ord)

    ! found minimum with required data amount
    found = 2 <= nmin .and. nmin <= ngrid+1

    if( debug ) write(*,'(3(a,g10.3),2(a,i0,1x),l1)') &
         'Grid search s: ',smin," < ",s," < ",smax," n:",ngrid,' #',cmin,found

  end subroutine grid

  subroutine gmin(smin,smax,s,found)

    use fmm

    real(kind), intent(in) :: smin, smax
    real(kind), intent(out) :: s
    logical, intent(out) :: found

    real(kind), parameter :: e = 10*epsilon(s)

    ! Routine fmin localises a minimum by using of golden-ratio search,
    ! and parabola fit close to the extreme. Scale s, as a statistical
    ! parameter, can be known with low precision (2 significant digits
    ! are enought for our application), giving ln((smax - smin)/tol) < 7
    ! calls to negentropy().
    !
    ! The fmin has been choiced in precedence of zeroin() (root finding
    ! method), we are not able to distiguish between both maximum or
    ! minimum without derivatives

    s = fmin(smin,smax,negentropy,etol)

    ! Does the found minimum falls inside the interval smin < .. < smax ?
    found = smin+e < s .and. s < smax-e

    if( debug ) write(*,'(a,g20.6,a,f0.1,l2)') &
         'Minimum fmin location:',s," +- ",etol,found

  end subroutine gmin


  ! diagnostic, neg-entropy graph
  subroutine escale_graph(filename,r,smin,smax)

    character(len=*), intent(in) :: filename
    real(kind), dimension(:), target, intent(in) :: r
    real(kind), intent(in) :: smin, smax

    ! local rho overwrites global rho (!)
    real(kind), dimension(:), allocatable :: rho,psi, dpsi, erho
    integer, parameter :: m = 666
    integer :: i,n
    real(kind) :: s,ds,f,df,sum1,sum2

    n = size(res)

    if( n <= 0 ) return

    allocate(rho(n),psi(n),dpsi(n),erho(n))

    ds = (smax - smin) / m

    open(1,file=filename)
    res => r
    do i = 0,m
       s = smin + i * ds

       call tukeys(res/s,psi,dpsi,rho)
       where( rho < rhomax )
          erho = exp(-A*rho)
       elsewhere
          erho = 0.0_kind
       end where
       sum1 = sum(psi*(1.0_kind - A*rho)*res*erho)
       sum2 = sum((A*psi**2 + (1.0_kind - A*rho)*(A*psi**2 - dpsi))*res**2*erho)
       f = sum1
       df = (sum2 / s - 2.0_kind*sum1) / s

       write(1,*) s,negentropy(s),f,df,-sum((r/s)**2*exp(-(r/s)**2))/size(r)
    end do
    close(1)

  end subroutine escale_graph


end module entropyscale

program cdf

  use oakleaf
  use noise
  use toolbox

  implicit none

  integer, parameter :: dbl = selected_real_kind(15)
  integer, parameter :: ndata = 1000
  real(dbl), dimension(ndata) :: x,y,z,xcdf,pcdf
  integer :: i

  call gnoise_fill(0.0_dbl,1.0_dbl,x)
  call gnoise_fill(0.0_dbl,100.1_dbl,y)
  call gnoise_fill(1.0_dbl,0.01_dbl,z)

  do i = 1, ndata,5
     x(i) = y(i)
  end do

  do i = 5, ndata,5
     x(i) = z(i)
  end do


  call ecdf(x,xcdf,pcdf)

  open(1,file='/tmp/cdf')
  do i = 1, size(xcdf)
     write(1,*) xcdf(i),pcdf(i)
  end do
  close(1)

end program cdf

module iromberg

  implicit none
  integer, parameter, private :: kind = selected_real_kind(15)

contains

  function romberg(f,a,b,tol,count,iflag)

    ! Rombergova metoda numerickeho vypoctu intergalu.
    !
    ! Znaceni:
    ! 2**MMAX = maximalni pocet vycisleni integrovane funkce F(X)
    ! Interval: <AINT,BINT>
    ! Absolutni presnost: EPS
    !
    ! iflag = 0 .. dosazena pozadovana presnost
    ! iflag = 1 .. nedosazena pozadovana presnost kvuli zaokrouhlovani
    ! iflag = 2 .. prekrocen maximalni pocet vycisleni funkce
    !

    interface
       function f(x)
         integer, parameter :: kind = selected_real_kind(15)
         real(kind) :: f
         real(kind), intent(in) :: x
       end function f
    end interface

    real(kind) :: romberg
    real(kind), intent(in) :: a,b
    real(kind), intent(in), optional :: tol
    integer, intent(in), optional :: count
    integer, intent(out), optional :: iflag

    integer :: mmax,i,j,k
    real(kind) :: x,s,g,h,err,d,dmin,y,epsmin
    real(kind), dimension(:), allocatable :: t
!    double precision :: f

    if( present(tol) ) then
       err = tol
    else
       err = 10*epsilon(1.0_kind)
    end if
    if( present(count) ) then
       mmax = count
    else
       mmax = 2 * nint(log((b - a) / err) / 0.6931)
    end if
!    write(*,*) err,mmax

    allocate(t(0:mmax))

!    external f

! Integracni meze
!      AINT = 0.0
!      BINT = -1.0
! Zadana chyba
!      EPS = 1E-13
!
    g = (b - a)/2.0
    h = g
    t(0) = g*(f(a) + f(b))
    k = 1
    dmin = 0.0_kind
!    hmin = 0.0_kind
    do j = 1, mmax
       y = t(0)
       x = a + g
       s = 0.0_kind
       do i = 0, k - 1
          s = s + f(x + h*i)
       enddo
       t(j) = t(j - 1)/2.0 + s * g
       s = 1.0_kind
       do i = j, 1, -1
          s = 4.0_kind*s
          t(i - 1) = (s*t(i) - t(i - 1))/(s - 1.0_kind)
       enddo
       d = abs(t(0) - y)
       if( j > 1 ) then
          if( d < tol )then
             ! Pozadovana presnost dosazena
             if( present(iflag) ) iflag = 0
             romberg = t(0)
             return
          endif
          if( d >= epsmin )then
             ! prenosti nedosahnuto kvuly zaokrouhlovani
             if( present(iflag) ) iflag = 1
             romberg = t(0)
             return
          endif
       endif
       k = 2*k
       h = g
       g = g / 2.0_kind
       epsmin = d
    enddo
    if( present(iflag) ) iflag = 2
    romberg = t(0)

  end function romberg

end module iromberg

! gfortran -fcheck=all -g -p  -Wall testrline.f95 -L. -L../minpack -lnoise -lrstat -lsort -llmin -lminpacks -lminpack -lfmm -lm

program testrline

  use oakleaf
  use noise
  use toolbox
  use testsuite

  implicit none
  integer, parameter :: dbl = selected_real_kind(15)

  call randomnoise

  call tester(rektoris)
  call tester(normal)

contains

  subroutine normal

    integer, parameter :: nmax = 100
    real(dbl), dimension(:),allocatable :: x,y,dx,dy
    real(dbl) :: a,b,da,db,sig,t
    integer :: i
    logical :: reliable, cond

    allocate(x(nmax),y(nmax),dx(nmax),dy(nmax))
    do i = 1,size(x)

       call random_number(t)
       x(i) = t
       if( mod(i,10) > 0 ) then
          y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.01_dbl)
       else
          y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.1_dbl)
       end if

    end do
    i = size(x)/3
    !  y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.1_dbl)
    i = size(x)/2
    !  y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.1_dbl)
    i = size(x)/4
    !  y(i) = 1 + 1*x(i) + gnoise(0.0_dbl,0.1_dbl)

    dx = 0.01 !* 0.707
    dy = 0.01 !* 0.707
    dx = 0
    dy = 1

    call rline(x,y,a,b,da,db,dx,dy,sig,reliable,verbose=.true.)

    write(*,*) 'a=',a,'+-',da
    write(*,*) 'b=',b,'+-',db
    write(*,*) 'sig=',sig,' reliable:',reliable
    cond = reliable .and. abs(a-1) < 5*da .and. abs(b-1) < 5*db
    write(*,'(a,l2)') 'TEST normal PASS:',cond

!    open(1,file='/tmp/rline2')
!    do i = 1, size(x)
!       write(1,*) x(i),y(i),y(i) - (a + b*x(i))
!    end do
!    close(1)

    deallocate(x,y,dx,dy)


  end subroutine normal


  subroutine rektoris

    integer, parameter :: ndat = 14
    real(dbl), dimension(ndat) :: x,y
    real(dbl) :: a,b,da,db,sig
    logical :: reliable, cond

    x = [ 3,4,6,6,6,7,8,9,11,11,12,12,14,16 ]
    y = [ 24.82, 23.26, 14.77, 19.06, 14.79, 17.66, 11.83, &
          14.82, 5.16, 11.12, 8.04, 2.72, 0.74, 1.21 ]

    call rline(x,y,a,b,da,db,sigma=sig,reliable=reliable,verbose=.true.)

    write(*,*) "rline:", reliable
    write(*,*) "sig:",sig
    write(*,*) "a:",a,"+-",da
    write(*,*) "b:",b,"+-",db
    cond = reliable .and. abs(a-29.3) < 0.1 .and. abs(b+1.9) < 0.1
    write(*,'(a,l2)') 'TEST rektoris PASS:',cond

  end subroutine rektoris


end program testrline

!
!  Robust mean
!
!  Copyright © 2001 - 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!

module robustmean

  ! This module provides rmean subroutine for estimation of robust mean.
  !
  ! rmean should be called as:
  !
  !  call rmean(data,mean,stderr,stdsig,scale,reliable,flag,verbose)
  !
  ! on input:
  !   data - array of data values to be estimated
  !   verbose (optional) - print additional informations
  !
  ! on output are estimated:
  !   mean - robust mean
  !   stderr (optional) - standard error
  !   stdsig (optional) - standard deviation
  !   scale (optional) - scale of function normalisation
  !   reliable (optional) - realiable results?
  !   flag (optional) - indicates reliability of results:
  !          0 == success, results are both reliable and accurate
  !          1 == consider a rough estimate due convergence fail, try verbose
  !          2 == basic estimates, few datapoints available
  !          3 == data looks nearly identical, MAD is zero
  !          5 == failed to allocate memory, initial estimates are returned
  !
  ! The results gives the robust estimate of the true value X
  ! of the sample x, with 68% probability, into the interval
  !
  !         mean - stderr  <  X  <  mean + stderr
  !
  ! Data distribution is approximated as Normal distribution
  !
  !          N(mean,stdsig).
  !
  ! Robust estimators has been prepared on base of
  !  * Hogg in Launer, Wilkinson: Robustness in Statistics
  !  * Hubber: Robust Statistics
  !  * my experiences

  use iso_fortran_env

  implicit none
  private

  ! print additional debuging results
  logical, private :: debug = .false.

  ! numerical precision of real numbers
  integer, parameter, private :: kind = selected_real_kind(15)

  ! 50% quantil of N(0,1)
  real(kind), parameter, private :: Q50 = 0.6745

  ! private data
  real(kind), dimension(:), pointer, private :: x
  real(kind), dimension(:), allocatable, private :: psi
  real(kind), private :: zmean_scale

  private :: rinit, zero_graph, zmean, zfun, rnewton
  public :: rmean_estimator

contains

  subroutine rmean_estimator(data,mean,stderr,stdsig,scale, &
       reliable,flag,verbose)

    ! This routine finds robust mean by looking for the maximum of likelihood.
    ! The scale is estimated from maximum of information.

    use likescale

    real(kind), dimension(:), target, intent(in) :: data
    real(kind), intent(out) :: mean
    real(kind), intent(out), optional :: stderr, stdsig, scale
    logical, intent(out), optional :: reliable
    integer, intent(out), optional :: flag
    logical, intent(in), optional :: verbose

    real(kind) :: t,dt,s,s0,t0,t1,dt1,tmin,tmax,t1min,t1max
    integer :: n, stat,iflag
    logical :: treli, sreli, converge
    character(len=80) :: errmsg

    debug = .false.
    if( present(reliable) ) reliable = .false.
    if( present(verbose) ) debug = verbose
    x => data
    n = size(x)

    if( n == 0 ) then

       ! results are undefined
       mean = 0
       if( present(reliable) ) reliable = .false.
       if( present(stderr) )   stderr = 0
       if( present(stdsig) )  stdsig = 0
       if( present(scale) )  scale = 0
       if( present(flag) ) flag = 2
       return

    else if( n == 1 ) then

       ! dispersion and std.err. are undefined
       mean = x(1)
       if( present(reliable) ) reliable = .false.
       if( present(stderr) )   stderr = 0
       if( present(stdsig) )   stdsig = 0
       if( present(scale) )    scale = 1
       if( present(flag) )     flag = 2
       return

    end if

    !
    ! ... n >= 2 is below this point ...
    !

    ! values are initialised by median, MAD and quantiles
    call rinit(x,t0,s0,tmin,tmax,iflag)
    if( iflag /= 0 ) then
       if( present(flag) ) flag = 5
       return
    end if

    ! Initial estimation
    t = t0
    s = s0
    dt = s0 / sqrt(real(n))

    if( debug ) then
       write(*,*) "rinit: t, s= ",t0,s0
       write(*,'(a,3g15.5)') 'tmin, tmax:',tmin,tmax
    end if

    if( abs(s0) < 10*epsilon(s0) ) then
       ! If half of data, or more, has identical values,
       ! their MAD is zero. Any application of robust methods is
       ! uselles (and problematic while s == 0).
       !
       ! If all the data are supposed to be identical (but a few points
       ! can deviate), result can be considered as reliable.

       mean = t0
       if( present(stderr) ) stderr = 0
       if( present(stdsig) ) stdsig = 0
       if( present(scale) )  scale = s0
       if( present(flag) )   flag = 3
       if( present(reliable) ) reliable = .true.
       return

    end if

    ! allocate working arrays
    allocate(psi(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'rmean(): ',trim(errmsg)
       if( present(flag) ) flag = 5
       return
    end if

    if( debug ) call zero_graph(t0,s0)

    ! The first step of estimate results by robust functions.
    ! Newton's method (with derivatives) is used to estimate of t.
    ! If it does not converge, Brent's method (without derivatives)
    ! is its failback alternative. The approach is generally much faster
    ! than preferential application of Brent's: non-convergence interval
    ! of Tukey's function domain is short.
    call rnewton(x,t,dt,s0,treli)
    if( .not. treli ) then
       call zmean(x,s0,tmin,tmax,t,treli)
       if( .not. treli ) t = t0
       if( debug ) write(*,*) 'zmean:',t,treli
    end if

    ! Scale estimation, if above determination of location is successfull
    if( treli ) then
       call iscale(x-t,s,sreli,verbose=debug)
       if( .not. sreli ) s = s0
    else
       sreli = .false.
    end if

    if( debug ) write(*,'(a,1pg20.10,1pg12.3,1x,2l1)') &
         'mean, scale:',t,s,treli,sreli

    if( treli .and. sreli ) then

       ! The second step.
       ! Newton's iterations are only used to obtain even precise result
       ! and to estimate of std.err.
       t1 = t
       t1min = t - 3*s
       t1max = t + 3*s
       call rnewton(x,t1,dt1,s,converge)
       if( debug ) write(*,'(a,1pg20.10,1p2g17.7,2l1)') &
            'Newton:',t1,dt1,converge,t1min < t1 .and. t1 < t1max

       converge = converge .and. (t1min < t1 .and. t1 < t1max)
       if( converge ) then
          t = t1
          dt = dt1
       end if
    else
       converge = .false.
       dt = s / sqrt(real(n))
    end if

    if( debug ) write(*,'(a,1g20.10,2g12.3,3l1)') &
         'rmean:',t,dt,s,treli,sreli,converge

    mean = t
    if( present(stderr) ) stderr = dt
    if( present(stdsig) ) stdsig = dt * sqrt(real(n))
    if( present(scale) ) scale = s
    if( present(reliable) ) reliable = .true.
    if( present(flag) ) then
       if( treli .and. sreli .and. converge ) then
          flag = 0
       else !if( treli .and. (.not. sreli .or. .not. converge) ) then
          flag = 1
       end if
    end if

    deallocate(psi)

  end subroutine rmean_estimator


  !-------------------------------------------------------------------
  subroutine rinit(x,t,s,tmin,tmax,flag)

    ! Initial estimate of parameters,
    ! it is extended version of qmean().

    use quantilmean

    real(kind), dimension(:), intent(in) :: x
    real(kind), intent(out) :: t,s,tmin,tmax
    integer, intent(out) :: flag
    real(kind), dimension(5), parameter :: q = [0.2, 0.25, 0.5, 0.75, 0.8]
    real(kind), dimension(size(q)) :: f

    call quantilefun(x,q,f,flag)
    if( flag /= 0 ) return

    t = (f(3) + (f(4) + f(2))/2)/2
    s = (f(4) - f(2)) / (2*Q50)
    tmin = f(1)
    tmax = f(5)

  end subroutine rinit


  !-----------------------------------------------------------------------

  subroutine rnewton(x,t,dt,s,converge)

    ! Newton's method has been the default robust estimator for a long time.
    ! Only the location parameter (t) is estimated (by Newton's iterations).
    ! The scale has its unchanged estimated value during all computations.
    !
    ! The reliability of result randomly depends on an initial estimate of t.
    ! There is no reliability if the estimate is out of convergence region
    ! of Newtons method or the scale s is far from its right value. The region
    ! of convergence depends on robust function in use. Two most frequent
    ! cases are Huber's function which is monotone and converges in full range
    ! and Tukey's (or Hampel's) function which converges only in domain
    ! determined by extremes of the functions.

    use rfun

    real(kind), dimension(:), intent(in) :: x
    real(kind), intent(in out) :: t
    real(kind), intent(out) :: dt
    real(kind), intent(in) :: s
    logical, intent(out) :: converge

    real(kind), dimension(:), allocatable :: dpsi
    character(len=81) :: errmsg
    integer :: n,it,stat
    real(kind) :: d,f,f2,df,tol

    converge = .false.
    if( .not. (s > epsilon(s)) ) return

    n = size(x)

    allocate(dpsi(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'Newton rmean: ',trim(errmsg)
       return
    end if

    ! set-up required precision
    tol = 10*n*epsilon(t)*(abs(t) + 1)

    ! Newton's iterations
    do it = 1, precision(t)
       ! Number of iterations is given by numerical precision.
       ! We belives, two orders are reached by each iteration, at least.

       call tukeys((x-t)/s,psi,dpsi)
       f = sum(psi)
       df = sum(dpsi)

       ! |df| will be vanishing when the important part of data has large
       ! deviations (above 3.4 for Hampel's piecewise or 1.6 for Tukey's
       ! bi-weight), this si "re-descending M-estimate" function problem.
       ! In this case, the computation is immediatelly interrupted and
       ! result should by considered as unreliable.
       ! The test is conservative, tiny() should be fine as well as.
       if( .not. (df > epsilon(df)) ) exit

       ! corrector
       d = s * f / df

       ! update location
       t = t + d

       if( debug ) write(*,'(a,i2,1pg20.10,1p3g10.2)') &
            "mean, inc., f, f': ",it,t,d,-f/s,df/s**2

       ! The exit of iterations is immediately done when updating
       ! takes less than 1/1000 of standard error indicating
       ! no further progress in iterations will give even precise result.
       ! As the fallback, the numerical tolerance is used.
       ! No convergence is indicated otherwise.

       f2 = sum(psi**2)
       if( f2 > 0 ) then  ! condition df > 0 is valid already
          ! estimation of standard error
          dt = s*sqrt(f2/df**2*n/(n-1)) ! the order does matter
          converge = abs(d) < 0.001*dt
       else ! f2 == 0, t is out of interval -c .. c of Tukey's function
          dt = 0
          if( abs(d) < tol ) exit
       end if

       if( converge ) exit
    enddo

  end subroutine rnewton

  subroutine zmean(x,s,tmin,tmax,t,reli)

    ! Zero mean estimates mean of robust function by Brent's method
    ! which is combination of bisection and inverse quadratic interpolation.
    ! It is important that it works without derivatives so there is
    ! no potential risk of divergence due to "re-descending" property
    ! of Tukey's function as in rnewton() with an improper initial.

    use fmm

    real(kind), dimension(:),intent(in) :: x
    real(kind), intent(in) :: s, tmin, tmax
    real(kind), intent(out) :: t
    logical, intent(out) :: reli

    real(kind) :: tol, d
    integer :: n

    n = size(x)
    tol = 0.01 * s / sqrt(real(n))
    zmean_scale = s
    t = zeroin(tmin,tmax,zfun,tol)

    ! tol gives precision of localisation by expected std.err.
    ! Number of calls of zfun will approximately log((tmax-tmin)/d).

    ! result too close to endpoints shows convergence fail
    d = 2*tol
    reli = abs(t - tmin) > d .and. abs(tmax - t) > d

  end subroutine zmean

  function zfun(t)

    use rfun

    real(kind) :: zfun
    real(kind), intent(in) :: t
    real(kind) :: s

    s = zmean_scale
    psi = tukey((x-t)/s)
    zfun = sum(psi) / size(psi)

  end function zfun



  !-------------------------------------
  !
  ! diagnostics routines
  !

  subroutine zero_graph(t0,s)

    real(kind), intent(in) :: t0,s

    integer :: i
    real(kind) :: t

    zmean_scale = s

    open(1,file='/tmp/t')
    do i = -500,500,10
       t = t0 + s * i / 100.0
       write(1,*) t,zfun(t)
    end do
    close(1)

  end subroutine zero_graph


end module robustmean

!
!  Fortran 95+ Minpack module
!
!  Copyright © 2013-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of Munipack.
!
!  Munipack is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  Munipack is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with Munipack.  If not, see <http://www.gnu.org/licenses/>.
!
!
!  This module implements:
!
!    * Fotran 90+ interfaces for original Minpack routines
!    * Simplified wrappers to original functions
!    * Add-ons: a linear equations solver, the inverse matrix routine
!
!  Adaptations:
!
!  * Power of modern Fortran is utilised: Dimensions of arrays are no more
!    required as arguments, working arrays are created transparently.
!
!  * Tolerance limits are set for maximal accuracy (should be slower).
!
!  * Only principal parameters of routines are visible.
!
!  * Added the convenience functions:
!    qrsolve - a solver of linear systems equations
!    qrinv - an inverse matrix routine
!
!    These are implemented via QR factorised matrix, so they will
!    no fail for a singular matrix; the approach is equivalent to SVD.
!
!  Notes:
!
!  * While the original Minpack's function covar.f is not available in all
!    distribution packages (perhaps, due to some mess), I cancel its support.
!

module minpacks

  implicit none

  ! precision for double real
  integer, parameter, private :: dbl = selected_real_kind(15)

contains


  subroutine lmdif2(fcn,x,tol,nprint,info)

    integer, intent(out) :: nprint
    integer, intent(out) :: info
    real(dbl), intent(in) :: tol
    real(dbl), dimension(:), intent(in out) :: x

    interface
       subroutine fcn(m,n,x,fvec,iflag)
         integer, parameter :: dbl = selected_real_kind(15)
         integer, intent(in) :: n, m
         integer, intent(in out) :: iflag
         real(dbl), dimension(m), intent(in) :: x
         real(dbl), dimension(n), intent(out) :: fvec
       end subroutine fcn
    end interface

    real(dbl), dimension(size(x)) :: fvec,qtf,wa1,wa2,wa3,wa4,diag
    real(dbl), dimension(size(x),size(x)) :: fjac
    integer, dimension(size(x)) :: ipvt
    real(dbl) :: xtol,ftol, gtol
    integer :: npar,nfev,maxfev

    npar = size(x)
    ftol = tol
    xtol = tol
    gtol = epsilon(gtol)
    maxfev = 200*(npar+1)

    call lmdif(fcn,npar,npar,x,fvec,ftol,xtol,gtol,maxfev,epsilon(0.0_dbl), &
         diag,1,100.0_dbl,nprint,info,nfev,fjac,npar,ipvt,qtf,wa1,wa2,wa3,wa4)

  end subroutine lmdif2


  subroutine lmdif3(fcn,x,cov,tol,nprint,info)

    real(dbl), dimension(:), intent(in out) :: x
    real(dbl), dimension(:,:), intent(out), optional :: cov
    real(dbl), intent(in), optional :: tol
    integer, intent(in), optional :: nprint
    integer, intent(out), optional :: info

    interface
       subroutine fcn(m,n,x,fvec,iflag)
         integer, parameter :: dbl = selected_real_kind(15)
         integer, intent(in) :: n, m
         integer, intent(in out) :: iflag
         real(dbl), dimension(m), intent(in) :: x
         real(dbl), dimension(n), intent(out) :: fvec
       end subroutine fcn
    end interface

    real(dbl), dimension(size(x)) :: fvec,qtf,wa1,wa2,wa3,wa4,diag
    real(dbl), dimension(size(x),size(x)) :: fjac
    integer, dimension(size(x)) :: ipvt
    real(dbl) :: xtol,ftol, gtol,factor,epsfcn
    integer :: npar,nfev,maxfev,nprints, infos,mode, iflag

    npar = size(x)
    if( present(tol) ) then
       ftol = tol
       xtol = tol
    else
       ftol = epsilon(ftol)
       xtol = ftol
    end if
    gtol = 0.0_dbl
    epsfcn = 0.0_dbl
    maxfev = 200*(npar+1)
    factor = 100
    mode = 1
    if( present(nprint) ) then
       nprints = nprint
    else
       nprints = 0
    end if

    call lmdif(fcn,npar,npar,x,fvec,ftol,xtol,gtol,maxfev,epsfcn, &
         diag,mode,factor,nprints,infos,nfev,fjac,npar,ipvt,qtf,wa1,wa2,wa3,wa4)

    if( present(cov) )then
       iflag = 2
       call fdjac2(fcn,npar,npar,x,fvec,fjac,npar,iflag,epsfcn,wa4)
       call qrinv(fjac,cov)
    end if

    if( present(info) ) info = infos

  end subroutine lmdif3


  subroutine lmder2(fcn,x,tol,nprint,info)

    integer, intent(out) :: nprint
    integer, intent(out) :: info
    real(dbl), intent(in) :: tol
    real(dbl), dimension(:), intent(in out) :: x

    interface
       subroutine fcn(m,n,x,fvec,fjac,ldfjac,iflag)
         integer, parameter :: dbl = selected_real_kind(15)
         integer, intent(in) :: n, m, ldfjac
         integer, intent(in out) :: iflag
         real(dbl), dimension(n), intent(in) :: x
         real(dbl), dimension(m), intent(out) :: fvec
         real(dbl), dimension(ldfjac,n), intent(out) :: fjac
       end subroutine fcn
    end interface

    real(dbl), dimension(size(x)) :: fvec,qtf,wa1,wa2,wa3,wa4,diag
    real(dbl), dimension(size(x),size(x)) :: fjac
    integer, dimension(size(x)) :: ipvt
    real(dbl) :: xtol,ftol, gtol
    integer :: npar,nfev,njev,maxfev

    npar = size(x)
    ftol = tol
    xtol = tol
    gtol = epsilon(gtol)
    maxfev = 200*(npar+1)

    call lmder(fcn,npar,npar,x,fvec,fjac,npar,ftol,xtol,gtol,maxfev, &
         diag,1,100.0_dbl,nprint,info,nfev,njev,ipvt,qtf,wa1,wa2,wa3,wa4)

  end subroutine lmder2

  subroutine lmder3(fcn,x,cov,tol,nprint,info)

    real(dbl), dimension(:), intent(in out) :: x
    real(dbl), dimension(:,:), optional, intent(out) :: cov
    real(dbl), optional, intent(in) :: tol
    integer, optional, intent(in) :: nprint
    integer, optional, intent(out) :: info

    interface
       subroutine fcn(m,n,x,fvec,fjac,ldfjac,iflag)
         integer, parameter :: dbl = selected_real_kind(15)
         integer, intent(in) :: n, m, ldfjac
         integer, intent(in out) :: iflag
         real(dbl), dimension(n), intent(in) :: x
         real(dbl), dimension(m), intent(out) :: fvec
         real(dbl), dimension(ldfjac,n), intent(out) :: fjac
       end subroutine fcn
    end interface

    real(dbl), dimension(size(x)) :: fvec,qtf,wa1,wa2,wa3,wa4,diag
    real(dbl), dimension(size(x),size(x)) :: fjac
    integer, dimension(size(x)) :: ipvt
    real(dbl) :: xtol,ftol, gtol, factor
    integer :: npar,nfev,njev,maxfev,iflag,infos,nprints,mode

    npar = size(x)
    if( present(tol) ) then
       ftol = tol
       xtol = tol
    else
       ftol = epsilon(ftol)
       xtol = ftol
    end if
    gtol = 0.0_dbl
    factor = 100
    maxfev = 100*(npar+1)
    infos = 0
    mode = 1

    if( present(nprint) ) then
       nprints = nprint
    else
       nprints = 0
    end if

    call lmder(fcn,npar,npar,x,fvec,fjac,npar,ftol,xtol,gtol,maxfev, &
         diag,mode,factor,nprints,infos,nfev,njev,ipvt,qtf,wa1,wa2,wa3,wa4)

    if( present(cov) ) then
       iflag = 2
       call fcn(npar,npar,x,fvec,fjac,npar,iflag)
       call qrinv(fjac,cov)
    end if

    if( present(info) ) info = infos

  end subroutine lmder3


  ! Functions hybr[d,j]2 are currently unused,
  ! because Levendberg-Marquart (lm*2) provides the regularised way).
  subroutine hybrd2(fcn,x,info)

    integer, intent(out) :: info
    real(dbl), dimension(:), intent(in out) :: x

    interface
       subroutine fcn(n,x,fvec,iflag)
         integer, parameter :: dbl = selected_real_kind(15)
         integer, intent(in) :: n
         integer, intent(in out) :: iflag
         real(dbl), dimension(n), intent(in) :: x
         real(dbl), dimension(n), intent(out) :: fvec
       end subroutine fcn
    end interface

    real(dbl), dimension(size(x)) :: fvec,qtf,wa1,wa2,wa3,wa4,diag
    real(dbl), dimension(size(x),size(x)) :: fjac
    real(dbl), dimension(size(x)**2) :: xr
    real(dbl) :: xtol
    integer :: npar,nfev,maxfev

    npar = size(x)
    xtol = epsilon(x)
    maxfev = 200*(npar+1)

    call hybrd(fcn,npar,x,fvec,xtol,maxfev,npar-1,npar-1,0.0_dbl, &
         diag,1,100.0_dbl,1,info,nfev,fjac,npar,xr,size(xr),qtf,wa1,wa2,wa3,wa4)

  end subroutine hybrd2


  subroutine hybrj2(fcn,x,info)

    integer, intent(out) :: info
    real(dbl), dimension(:), intent(in out) :: x

    interface
       subroutine fcn(n,x,fvec,fjac,ldfjac,iflag)
         integer, parameter :: dbl = selected_real_kind(15)
         integer, intent(in) :: n, ldfjac
         integer, intent(in out) :: iflag
         real(dbl), dimension(n), intent(in) :: x
         real(dbl), dimension(n), intent(out) :: fvec
         real(dbl), dimension(ldfjac,n), intent(out) :: fjac
       end subroutine fcn
    end interface

    real(dbl), dimension(size(x)) :: fvec,qtf,wa1,wa2,wa3,wa4,diag
    real(dbl), dimension(size(x),size(x)) :: fjac
    real(dbl), dimension((size(x)*(size(x)+1))/2) :: xr
    real(dbl) :: xtol
    integer :: npar,nfev,njev,maxfev

    npar = size(x)
    xtol = epsilon(x)
    maxfev = 200*(npar+1)

    call hybrj(fcn,npar,x,fvec,fjac,npar,xtol,maxfev, &
         diag,1,100.0_dbl,1,info,nfev,njev,xr,size(xr),qtf,wa1,wa2,wa3,wa4)

  end subroutine hybrj2


! ----------------------------------------------------------------------
!
!


  subroutine qrsolve(a,b,x)

    real(dbl), dimension(:,:), intent(in) :: a
    real(dbl), dimension(:), intent(in) :: b
    real(dbl), dimension(:), intent(out) :: x

    integer :: m,n,i
    real(dbl), dimension(size(a,1),size(a,2)) :: r, q
    integer, dimension(size(a,1)) :: ipvt
    real(dbl), dimension(size(a,2)) :: rdiag,wa,qtb,diag

    m = size(a,1)
    n = size(a,2)

    ! form the r matrix, r is upper trinagle (without diagonal)
    ! of the factorized a, diagonal is presented in rdiag
    q = a
    call qrfac(m,n,q,m,.true.,ipvt,n,rdiag,diag,wa)

!    write(*,*) 'qrfac:',q,rdiag,diag,ipvt

    ! form R, upper triangular
    r = q
    forall( i = 1:n ) r(i,i) = rdiag(i)

    ! form Q orthogonal matrix
    call qform(m,n,q,m,wa)
    qtb = matmul(transpose(q),b)

    ! accurate up to machine epsilon
    diag = diag*epsilon(diag)    ! lmpar.f:206,

    call qrsolv(n,r,m,ipvt,diag,qtb,x,rdiag,wa)

  end subroutine qrsolve


  subroutine qrinv(a,ainv)

    ! Compute inverse matrix in least-square sense by the use
    ! of the QR factorization. An efficiency does not matter.
    ! A singular matrix check is implemented.
    !
    ! http://en.wikipedia.org/wiki/QR_decomposition
    !     - see: "Solution of inverse problems"

    implicit none

    real(dbl), dimension(:,:), intent(in) :: a
    real(dbl), dimension(:,:), intent(out) :: ainv

    integer :: m,n,i,j
    real(dbl), dimension(size(a,1),size(a,2)) :: r, q
    integer, dimension(size(a,1)) :: ipvt
    real(dbl), dimension(size(a,1)) :: rdiag,acnorm,wa,x,b

    m = size(a,1)
    n = size(a,2)

    ! form the r matrix, r is upper triangle (without diagonal)
    ! of the factorized a, its diagonal is stored in rdiag
    q = transpose(a)
    call qrfac(m,n,q,m,.false.,ipvt,n,rdiag,acnorm,wa)

!    write(*,*) 'qrfac:',q,rdiag,ipvt

    ! form R, upper triangular
    r = q
    forall( i = 1:n ) r(i,i) = rdiag(i)

    ! form Q orthogonal matrix
    call qform(m,n,q,n,wa)

!    do i = 1,n
!       write(*,'(a,4f15.7)') 'q:',q(i,:)
!    end do
!    do i = 1,n
!       write(*,'(a,4f15.7)') 'r:',r(i,:)
!    end do

    ! determine the inverse matrix by substitution
    do i = 1, n
       b = 0.0_dbl
       b(i) = 1.0_dbl

       ! forward subtitution with checking on singular values
       ! (for overdetermined problem, the inverse matrix has
       ! set elements to zero when no inverse is possible).
       ! We assumes: no element index like x(1:0) is acceptable.
       do j = 1,n
          if( abs(r(j,j)) > epsilon(r) ) then
             x(j) = (b(j) - sum(x(1:j-1)*r(1:j-1,j))) / r(j,j)
          else
             x(j) = 0.0_dbl
          end if
       end do
       ainv(:,i) = matmul(q,x)
    end do

!    write(*,*) 'ainv:',ainv

  end subroutine qrinv


end module minpacks

program smoke

  use oakleaf
  use noise

  implicit none

  integer, parameter :: kind = selected_real_kind(15)
!  integer, dimension(1) :: n
  character(len=80) :: amount,filename
  integer :: n,voltage

  call get_environment_variable("VOLTAGE",status=voltage)
  if( .not. (voltage == 0) ) stop 'Low voltage.'

  call get_command_argument(1,amount)
  call get_command_argument(2,filename)
  read(amount,*) n

  call run(n,filename)

!  n = [ 2,3,4,5,6,7,8,9,10,20,50,10**2,10**3,10**4,10**6 ]
!  n = [ 2,3,4,5,6,7,8,9,10 ]
!  n = [ 7 ]
!  do l = 1, size(n)
!     call run(n(l))
!  end do

contains

  subroutine run(n,filename)

    integer, intent(in) :: n
    character(len=*), intent(in) :: filename
    real(kind), dimension(n) :: data
    real(kind) :: t,s,ds,c,t1,t2,total
    logical :: reliable
    character(len=80) :: name
    integer :: m,nn,flag

!    data = [5.2129640725329870E-002,  0.15293191139569814, &
!         -0.20754828909183076, -0.39700992178364081, 1.3411645446578198]
!    call rmean(data,t,ds,s,verbose=.true.)
!    stop

!    data = [ -0.32366372162119911,      -0.34013885339444594,  &
!         -0.28319988121743622 , -0.15217523163307081, &
!         -0.67745093584468041,      -0.29660261571936658, 1.2883265222850431 ]

!    data = [ -1.3666496394616230, 3.0716410066064586, 4.6510401721685517E-002, !&
!         1.2641804668388122E-002, 6.0265855187624381E-002, &
!         -0.77198678639721452, -0.38235178598268538 ]
!!$    data = [ -1.3666496394616230, 3.0716410066064586, 4.6510401721685517E-002, &
!!$         1.2641804668388122E-002, 6.0265855187624381E-002, &
!!$         -0.77198678639721452, -0.38235178598268538 ]
!    call randomnoise
!    call gnoise_fill(0.0_kind,1.0_kind,data)
!!$    call surface(data)
!    t = sum(data) / size(data)
!    s = sqrt(sum((data - t)**2)/(size(data) - 1))
!    write(*,*) t,s
!    call rmean(data,t,ds,s,verbose=.true.)
!!$    call plot(data,'/tmp/lll',-0.369961183d0)
!   stop
    !    write(name,'(a,i0)') '/tmp/smoke',n
    total = 0
    nn = 0
    open(77,file=filename)
    do m = 1, 1000000
       call randomnoise
       call gnoise_fill(0.0_kind,1.0_kind,data)
       call gnoise_fill(2.0_kind,10.0_kind,data(::11))
       call gnoise_fill(0.0_kind,0.01_kind,data(::13))
       call cpu_time(t1)
       call rmean(data,t,ds,s,c,reliable=reliable,flag=flag)
       call cpu_time(t2)
       total = total + (t2 - t1)
       write(77,*) t,ds,s,c,flag
!       if( .not. reliable .or. (n == 4 .and. s < 0.07) ) then
!       if( .not. reliable ) then
       if( flag /= 0 ) then
          open(22,file='/tmp/fail',position='append')
          write(22,*) data
          close(22)
          nn = nn + 1
          write(name,'(2a,i0)') trim(filename),'_',nn
          call plot(data,name,t)
          call surface(data,trim(name)//'_s')
          t = sum(data) / size(data)
          s = sqrt(sum((data - t)**2)/(size(data) - 1))
          write(*,*) '# ',nn,' Arith:',t,s
          call rmean(data,t,ds,s,verbose=.true.)
!          stop
       end if
    end do
    close(77)
    write(*,'(a,f0.3)') 'Total=',total

  end subroutine run

  subroutine plot(data,name,t)

    character(len=*), intent(in) :: name
    real(kind), dimension(:), intent(in) :: data
    real(kind), intent(in) :: t
    integer :: n,i,j
    real(kind) :: x,s,e,w,q,e0,r,scale

    scale = 1

    n = size(data)
    open(12,file=name)
    write(12,*) '# ',data
    do i = -300, 300
       x = i / 100.0
       s = 0
       w = 0
       do j = 1, n
          s = s + tukey((x - data(j))/scale)
          w = w + dtukey((x - data(j))/scale)
       end do
       e = 0
       e0 = 0
       q = 0
       if( i > 0 ) then
          do j = 1, n
             r = itukey((data(j)-t)/x)
             e = e + r*exp(-2.1227*r)
             r = itukey(data(j)/x)
             e0 = e0 + r*exp(-2.1227*r)
             q = q + dtukey(data(j)/scale)
          end do
       end if
       write(12,*) x, s/n,e/n,e0/n,w/n,q/n
    end do
    close(12)

  end subroutine plot


  subroutine surface(data,name)

    real(kind), dimension(:), intent(in) :: data
    character(len=*), intent(in) :: name

    real(kind), dimension(size(data)) :: r,x
    real(kind) :: t,s,d
    integer :: i,j,n

    n = size(data)

    open(48,file=name)
    do i = -30,30
       t = i / 10.0
       do j = 1,30
          s = j / 10.0
          x = (data-t)/s
          r = itukey(x)
          d = sum(dtukey(x))
          if( abs(d) > 0*n/2.0 ) then
             write(48,*) t,s,sum(itukey(x))/n,sum(r*exp(-2.1227*r))/n, &
                  sum(tukey(x)**2)/sum(dtukey(x))**2
          end if
       end do
    end do
    close(48)

  end subroutine surface

end program smoke

!
!  Fortran 95+ module interface to selected routines from the book
!
!       "Computer Methods for Mathematical Computations",
!           by Forsythe, Malcolm, and Moler (1977)
!
!  known as FMM (http://www.netlib.org/fmm/index.html).
!
!
!  Copyright © 2015-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!

module fmm

  implicit none
  public

  interface

     subroutine spline (n, x, y, b, c, d)

       use iso_fortran_env

       integer, intent(in) ::n
       real(REAL64), dimension(n), intent(in) :: x,y
       real(REAL64), dimension(n), intent(out) :: b,c,d

     end subroutine spline

     real(REAL64) function seval(n, u, x, y, b, c, d)

       use iso_fortran_env

       integer, intent(in) :: n
       real(REAL64), intent(in) :: u
       real(REAL64), dimension(n), intent(in) :: x,y,b,c,d

     end function seval

     real(REAL64) function fmin(ax,bx,f,tol)

       use iso_fortran_env

       real(REAL64), intent(in) :: ax,bx,tol

       interface
          function f(x)
            use iso_fortran_env
            real(REAL64) :: f
            real(REAL64), intent(in) :: x
          end function f
       end interface

     end function fmin

     real(REAL64) function zeroin(ax,bx,f,tol)

       use iso_fortran_env

       real(REAL64), intent(in) :: ax,bx,tol

       interface
          function f(x)
            use iso_fortran_env
            real(REAL64) :: f
            real(REAL64), intent(in) :: x
          end function f
       end interface

     end function zeroin

  end interface

end module fmm

!
!  fmin
!
!  This procedure is adopted version of fmin procedure
!  by FMM library developed by Forsythe, Malcolm, and Moler
!  (http://www.netlib.org/fmm/index.html) for Fortran 95.
!  Some changes to code are introduced by FH:
!   * epsilon by standard function
!   * check for non-convergence
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.



double precision function fmin(ax,bx,f,tol)

  implicit none

  double precision, intent(in) :: ax,bx,tol

  interface
     function f(x)
       double precision :: f
       double precision, intent(in) :: x
     end function f
  end interface

!
!      an approximation  x  to the point where  f  attains a minimum  on
!  the interval  (ax,bx)  is determined.
!
!
!  input..
!
!  ax    left endpoint of initial interval
!  bx    right endpoint of initial interval
!  f     function subprogram which evaluates  f(x)  for any  x
!        in the interval  (ax,bx)
!  tol   desired length of the interval of uncertainty of the final
!        result ( .ge. 0.0d0)
!
!
!  output..
!
!  fmin  abcissa approximating the point where  f  attains a minimum
!
!
!      the method used is a combination of  golden  section  search  and
!  successive parabolic interpolation.  convergence is never much slower
!  than  that  for  a  fibonacci search.  if  f  has a continuous second
!  derivative which is positive at the minimum (which is not  at  ax  or
!  bx),  then  convergence  is  superlinear, and usually of the order of
!  about  1.324....
!      the function  f  is never evaluated at two points closer together
!  than  eps*abs(fmin) + (tol/3), where eps is  approximately the square
!  root  of  the  relative  machine  precision.   if   f   is a unimodal
!  function and the computed values of   f   are  always  unimodal  when
!  separated by at least  eps*abs(x) + (tol/3), then  fmin  approximates
!  the abcissa of the global minimum of  f  on the interval  ax,bx  with
!  an error less than  3*eps*abs(fmin) + tol.  if   f   is not unimodal,
!  then fmin may approximate a local, but perhaps non-global, minimum to
!  the same accuracy.
!      this function subprogram is a slightly modified  version  of  the
!  algol  60 procedure  localmin  given in richard brent, algorithms for
!  minimization without derivatives, prentice - hall, inc. (1973).
!
!
  double precision, parameter :: eps = epsilon(fmin)
  double precision  a,b,c,d,e,xm,p,q,r,tol1,tol2,u,v,w
  double precision  fu,fv,fw,fx,x
  double precision  dabs,dsqrt,dsign

!  FH: to prevent infinity loop, Fibonacci search is O(log(n))
!  see https://en.wikipedia.org/wiki/Fibonacci_search_technique
!  3x (?), precision(fmin) = 16, ... yes, we are realist....
  integer :: ieval, maxeval

  maxeval = max(int(3*log((bx - ax) / tol)), precision(fmin))
  ieval = 0
!
!  c is the squared inverse of the golden ratio
!
  c = 0.5d0*(3. - dsqrt(5.0d0))
!
!  eps is approximately the square root of the relative machine
!  precision.
!
!  FH: the loop is replaced by an internal function (to be faster)
!      eps = 1.0d00
!   10 eps = eps/2.0d00
!      tol1 = 1.0d0 + eps
!      if (tol1 .gt. 1.0d00) go to 10
!  eps = epsilon(1.0d0)
!  eps = dsqrt(eps)
!
!  initialization
!
  a = ax
  b = bx
  v = a + c*(b - a)
  w = v
  x = v
  e = 0.0d0
  d = e
  fx = f(x)
  fv = fx
  fw = fx
!
!  main loop starts here
!
20 xm = 0.5d0*(a + b)
  tol1 = eps*dabs(x) + tol/3.0d0
  tol2 = 2.0d0*tol1
!
! FH: number of evaluations
!
  ieval = ieval + 1
!
!  check stopping criterion
!
  if (dabs(x - xm) .le. (tol2 - 0.5d0*(b - a))) go to 90
!
!  FH: maximum number of evaluations reached
  if( ieval > maxeval ) goto 90
!
! is golden-section necessary
!
  if (dabs(e) .le. tol1) go to 40
!
!  fit parabola
!
  r = (x - w)*(fx - fv)
  q = (x - v)*(fx - fw)
  p = (x - v)*q - (x - w)*r
  q = 2.0d00*(q - r)
  if (q .gt. 0.0d0) p = -p
  q =  dabs(q)
  r = e
  e = d
!
!  is parabola acceptable
!
  if (dabs(p) .ge. dabs(0.5d0*q*r)) go to 40
  if (p .le. q*(a - x)) go to 40
  if (p .ge. q*(b - x)) go to 40
!
!  a parabolic interpolation step
!
  d = p/q
  u = x + d
!
!  f must not be evaluated too close to ax or bx
!
  if ((u - a) .lt. tol2) d = dsign(tol1, xm - x)
  if ((b - u) .lt. tol2) d = dsign(tol1, xm - x)
  go to 50
!
!  a golden-section step
!
40 if (x .ge. xm) e = a - x
  if (x .lt. xm) e = b - x
  d = c*e
!
!  f must not be evaluated too close to x
!
50 if (dabs(d) .ge. tol1) u = x + d
  if (dabs(d) .lt. tol1) u = x + dsign(tol1, d)
  fu = f(u)
!
!  update  a, b, v, w, and x
!
  if (fu .gt. fx) go to 60
  if (u .ge. x) a = x
  if (u .lt. x) b = x
  v = w
  fv = fw
  w = x
  fw = fx
  x = u
  fx = fu
  go to 20
60 if (u .lt. x) a = u
  if (u .ge. x) b = u
  if (fu .le. fw) go to 70
  if (w .eq. x) go to 70
  if (fu .le. fv) go to 80
  if (v .eq. x) go to 80
  if (v .eq. w) go to 80
  go to 20
70 v = w
  fv = fw
  w = u
  fw = fu
  go to 20
80 v = u
  fv = fu
  go to 20
!
!  end of main loop
!
90 fmin = x
  return
end function fmin

!
!  Robust weighted mean
!
!  Copyright © 2016-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!

module weightedmean

  ! This module provides subroutines for estimation of both
  ! robust mean and its deviations.
  !
  ! rwmean should be called as:
  !
  !  call rwmean(data,errors,mean,stderr,stdsig,scale,reliable,flag,verbose)
  !
  ! on input:
  !   data - array of data values to be estimated
  !   errors - array of statistical errors of x, dx > 0
  !   verbose (optional) - print additional informations
  !
  ! on output are estimated by robust way:
  !   mean - robust mean
  !   stderr (optional) - standard error
  !   stdsig (optional) - standard deviation
  !   scale (optional) - scale of function normalisation
  !   reliable (optional) - indicates reliablity of results
  !   flag (optional) - indicates reliability of results:
  !          0 == success, results are both reliable and precise
  !          1 == consider rough estimate due convergence fail, try verbose
  !          2 == basic estimates, few datapoints available
  !          3 == data looks nerly identical, MAD is zero
  !          4 == improper input parameters (sizes of arrays errors, data
  !               are unequal, any element of error <= 0), try verbose
  !          5 == failed to allocate memory
  !
  ! The results gives the robust estimate of the true value X
  ! of the sample x with weights dx, with 68% probability, into the interval
  !
  !         mean - stderr  <  X  <  mean + stderr
  !
  ! Data distribution is approximated as Normal distribution
  !
  !          N(mean,stdsig).
  !
  !
  ! WARNING
  !
  ! This routine gives unexpected results when setup of input errors
  ! is incorrect. It is indicated by significant violation of scale /= 1.
  ! If you encountered it, run plain rmean() instead. If errors holds some
  ! additional property or condition, use it.
  !
  !
  ! Robust estimators has been prepared on base of
  !  * Hogg in Launer, Wilkinson: Robustness in Statistics
  !  * Hubber: Robust Statistics
  !  * my experiences

  use iso_fortran_env

  implicit none
  private

  ! print additional debuging results
  logical, private :: debug = .false.

  ! numerical precision of real numbers
  integer, parameter, private :: kind = selected_real_kind(15)
  ! or use:
  ! integer, parameter, private :: kind = REAL64

  ! 50% quantil of N(0,1)
  real(kind), parameter, private :: Q50 = 0.6745

  ! private working variables
  real(kind), dimension(:), allocatable, private :: psi
  real(kind), dimension(:), pointer, private :: x, dx ! pointers on inputs
  real(kind) :: zmean_scale ! estimated scale for zmean

  ! Allocate of psi can be elimined by replacing of vector
  ! summations in rnewton and zfun by direct summations. It does
  ! slow-down computations (something is computed repeatelly and
  ! no masive parallelization is possible), so this way is prefered.

  private :: rnewton, zmean, zfun, zero_graph
  public :: rwmean_estimator

contains

  subroutine rwmean_estimator(data,errors,mean,stderr,stdsig,scale, &
       reliable,flag,verbose)

    use likescale

    real(kind), dimension(:), target, intent(in) :: data, errors
    real(kind), intent(out) :: mean
    real(kind), intent(out), optional :: stderr,stdsig,scale
    logical, intent(out), optional :: reliable
    integer, intent(out), optional :: flag
    logical, intent(in), optional :: verbose

    real(kind) :: t,dt,s,sig,s0,t0,t1,dt1,tmin,tmax,t1min,t1max
    integer :: n, stat, iflag
    logical :: converge, treli, sreli
    character(len=80) :: errmsg

    debug = .false.
    if( present(reliable) ) reliable = .false.
    if( present(verbose) ) debug = .true.

    x => data
    dx => errors
    n = size(x)

    if( size(x) /= size(dx) .or. .not. all(dx > 0) ) then
       if( debug ) then
          if( size(x) /= size(dx) ) &
               write(error_unit,*) 'rwmean: size(x) /= size(dx)'
          if( .not. all(dx > 0) ) write(error_unit,*) 'rwmean: any dx < 0'
       end if
       mean = 0
       if( present(reliable) ) reliable = .false.
       if( present(flag) ) flag = 4
       return
    end if

    if( n == 0 ) then

       mean = 0
       if( present(reliable) ) reliable = .false.
       if( present(stderr) ) stderr = 0
       if( present(stdsig) ) stdsig = 0
       if( present(scale) )  scale = 0
       if( present(flag) ) flag = 2
       return

    else if( n == 1 ) then

       mean = x(1)
       if( present(reliable) ) reliable = .true.
       if( present(stderr) )   stderr = dx(1)
       if( present(stdsig) )   stdsig = 1
       if( present(scale) )    scale = 1
       if( present(flag) )     flag = 2
       return

    end if

    !
    ! ... n >= 2 is below this point ...
    !

    ! initial estimate of t,s
    call rwinit(x,dx,t0,s0,sig,tmin,tmax,iflag)
    if( iflag /= 0 ) then
       if( present(flag) ) flag = 5
       return
    end if

    ! Init
    t = t0
    s = s0
    dt = (s0*sig) / sqrt(real(n))

    if( debug ) then
       write(*,'(a,1p3g17.7)') 'rwinit:',t0,s0,sig
       write(*,'(a,3g15.5)') 'tmin, tmax:',tmin,tmax
    end if

    if( abs(s0) < 10*epsilon(s0)  )then

       ! If important part of the dataset are identical,
       ! results can be considered as reliable.

       mean = t0
       if( present(stderr) )  stderr = (s0*sig) / sqrt(real(n))
       if( present(stdsig) )  stdsig = s0
       if( present(scale) )   scale = s0
       if( present(flag) )     flag = 3
       if( present(reliable) ) reliable = .true.
       return

    endif

    ! Working arrays allocation: A memory can be allocated on the fly,
    ! but it may slow-down the computations.
    allocate(psi(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'rwmean(): ',trim(errmsg)
       if( present(flag) )     flag = 5
       if( present(reliable) ) reliable = .false.
       return
    end if

    if( debug ) call zero_graph(x,dx,t0,s0)

    ! Newton's method (with derivatives) is used to estimate of t.
    ! If it does not converge, Brent's method (without derivatives)
    ! is its failback alternative. The approach is generally much faster
    ! than direct application of Brent's because an interval of
    ! non-convergence of Tukey's function is short.
    call rnewton(x,dx,s0,t,dt,treli)
    if( .not. treli ) then
       call zmean(s0,sig,tmin,tmax,t,treli)
       if( .not. treli ) t = t0
       if( debug ) write(*,*) 'zmean:',t,treli
    end if

    ! The scale parameter estimates average dispersion of residuals
    ! scaled by theirs, a priory known, statistical errors (dx).
    ! Normally, the value is expected near number one: scale ~= 1.
    if( treli ) then
       call iscale((x-t)/dx,s,sreli,verbose=debug)
       if( .not. sreli ) s = s0
    else
       sreli = .false.
    end if

    if( debug ) &
         write(*,'(a,1p2g17.7,1x,2l1)') 'mean, scale:',t,s,treli,sreli

    if( treli .and. sreli ) then

       ! Newton's iterations are used mainly to get more precise result
       ! and to estimate of std.err. and sig
       t1 = t
       t1min = t - 3*s*sig
       t1max = t + 3*s*sig
       call rnewton(x,dx,s,t1,dt1,converge)
       if( debug ) write(*,'(a,1pg20.10,1p2g17.7,2l1)') &
            'Newton:',t1,dt1,converge,t1min < t1 .and. t1 < t1max

       converge = converge .and. (t1min < t1 .and. t1 < t1max)
       if( converge ) then
          t = t1
          dt = dt1
       end if
    else
       converge = .false.
       dt = (s*sig) / sqrt(real(n))
    end if

    if( debug ) write(*,'(a,1pg20.15,3g10.3,1x,3l1)') &
         'rwmean: ',t,dt,s,sig,treli,sreli,converge

    mean = t
    if( present(stderr) ) stderr = dt
    if( present(stdsig) ) stdsig = dt*sqrt(real(n))
    if( present(scale) ) scale = s
    if( present(reliable) ) reliable = .true.
    if( present(flag) ) then
       if( treli .and. sreli .and. converge ) then
          flag = 0
       else !if( treli .and. (.not. sreli .or. .not. converge) ) then
          flag = 1
       end if
    end if

    deallocate(psi)

  end subroutine rwmean_estimator

  subroutine rnewton(x,dx,s,t,dt,converge)

    ! This routine implements Newton's method for solving of equation
    !
    !  f(t) = 0,  where f(t) = sum( psi((x-t)/(s*dx))/dx )
    !
    ! t   is estimation of mean,
    ! dt  is standard error of t
    ! s   is scale

    use rfun

    real(kind), dimension(:), intent(in) :: x, dx
    real(kind), intent(in out) :: t
    real(kind), intent(in) :: s
    real(kind), intent(out) :: dt
    logical, intent(out) :: converge

    real(kind), dimension(:), allocatable :: dpsi
    character(len=81) :: errmsg
    integer :: n,iter,stat
    real(kind) :: d,f,df,f2,dp,tol

    converge = .false.
    if( .not. (s > 0.0_kind) ) return

    n = size(x)
    allocate(dpsi(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'Newton rwmean: ',trim(errmsg)
       return
    end if

    ! Adjusting of tolerance
    tol = 10*n*epsilon(t)*(abs(t) + 1)

    ! Newton's iterations
    do iter = 1, precision(t)
       ! Number of iterations is limited by numerical precision.
       ! We belives in quadratic convergence of Newton's method;
       ! two orders are reached by each iteration, at least.

       ! derivation of derivatives
       call tukeys((x-t)/(s*dx),psi,dpsi)
       f = sum(psi/dx)
       df = sum(dpsi/dx**2)

       ! derivative (denominator) checkpoint:
       ! * If all values are out of range: |df| < epsilon
       ! * |df| < 0 indicates "re-descending M-estimate" function problem ...
       !   the problem usually appears when distribution strongly deviates
       !   from Normal distribution
       if( .not. (df > epsilon(df)) ) exit

       ! corrector
       d = s * f / df

       ! update location
       t = t + d

       if( debug ) write(*,'(a,i2,1pg20.10,1p3g10.2)') &
            "mean, incr., f, f': ",iter,t,d,-f/s,df/s**2

       ! exit of iterations, see rmean() for explanation
       f2 = sum(psi**2*dx**2)
       dp = sum(dpsi)
       if( f2 > 0 .and. dp > 0 ) then
          dt = s*sqrt(f2/dp**2*n/(n-1))
          converge = abs(d) < 0.001*dt
       else ! f2 == 0
          dt = 0
          if( abs(d) < tol ) exit
       end if

       if( converge ) exit
    enddo

  end subroutine rnewton

  subroutine zmean(s,sig,tmin,tmax,t,reli)

    use fmm

    real(kind), intent(in) :: s,sig,tmin,tmax
    real(kind), intent(out) :: t
    logical, intent(out) :: reli

    real(kind) :: d, tol
    integer :: n

    n = size(x)
    tol = 0.01 * s*sig / sqrt(real(n))
    zmean_scale = s
    t = zeroin(tmin,tmax,zfun,tol)

    ! tol gives precision of localisation by expected std.err.
    ! Number of calls of 0-fun will approximately ln((tmax-tmin)/tol).

    ! if result is too close to interval endpoints, it raises suspicion ...
    d = 2*tol
    reli = abs(t - tmin) > d .and. abs(tmax - t) > d

  end subroutine zmean

  function zfun(t)

    use rfun

    real(kind) :: zfun
    real(kind), intent(in) :: t
    real(kind) :: s

    s = zmean_scale
    psi = tukey((x-t)/(s*dx))
    zfun = sum(psi/dx)

  end function zfun


  subroutine rwinit(x,dx,t,s,sig,tmin,tmax,flag)

    ! This routine performs an initial estimate of both mean and scale
    ! using both median and absolute value.

    use medians
    use quantilmean

    real(kind), dimension(:),intent(in) :: x, dx
    real(kind), intent(out) :: t,s,sig,tmin,tmax
    integer, intent(out) :: flag
    real(kind) :: xmin,xmax

    if( size(x) > 50 ) then

       ! This choice of the threshold used for median computation method
       ! assumes that odd and even elements in sequence are the same (within
       ! requested precision). Note that qmed is the fastest known algorithm
       ! (~2*n) while median is simpler and slower (~n*log(n)).

       t = qmedian(x)
       sig = qmedian(dx)

    else

       t = median(x)
       sig = median(dx)

    end if

    ! determine parameters by empirical CDF quantilies
    call qbracket((x-t)/dx,xmin,xmax,flag)
    if( flag /= 0 ) return

    ! Both mean of x and mean of (x-t0)/dx will different in general (ignored).
    tmin = t + sig*xmin
    tmax = t + sig*xmax
    s = (xmax - xmin) / (2*Q50)

    if( debug ) call graph_ecdf(t,sig)

  end subroutine rwinit



 ! diagnostics routines


  subroutine zero_graph(x,dx,t0,s)

    use rfun
    use medians

    real(kind), dimension(:),intent(in) :: x, dx
    real(kind), intent(in) :: t0,s

    integer :: i,n
    real(kind) :: t,d

    d = median(s*dx) / 0.6745

    n = size(x)
    zmean_scale = s

    open(1,file='/tmp/tw')
    do i = -500,500,10
       t = t0 + d * i / 100.0
       write(1,*) t,zfun(t)
    end do
    close(1)

  end subroutine zero_graph

  subroutine graph_ecdf(t,s)

    use quantilmean

    real(kind), intent(in) :: t,s
    real(kind), dimension(:), allocatable :: xcdf,ycdf
    integer :: n,l,u

    n = size(x)
    allocate(xcdf(n),ycdf(n))
    call ecdf((x-t)/s,xcdf,ycdf)
!    call ecdf(x-t,xcdf,ycdf)

    open(newunit=u,file='/tmp/cdf1')
    do l = 1, n
       write(u,*) xcdf(l),ycdf(l)
    end do
    close(u)

  end subroutine graph_ecdf


end module weightedmean

!
!  Information scale:
!  scale by maximal likelihood, maximum of information, minimum of variance
!
!  Copyright © 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!

module likescale

  ! This module provides the subroutine for estimation of scale
  ! by maximising of information, or minimising of variance (dispersion):
  !    https://en.wikipedia.org/wiki/Fisher_information
  !
  ! iscale should be called as:
  !
  !  call iscale(r,s,reliable,flag,verbose)
  !
  ! on input:
  !   r - array of residuals: (data-mean), (data-mean)/errors, ...
  !   verbose (optional) - verbose prints
  !
  ! on output are estimated:
  !   s - scale
  !   reliable (optional) - indicates reliability of result
  !                         if .true., scale has been correctly
  !                         localised. if .false., s is undefined
  !   flag (optional) - result code:
  !          0 == success, results are both reliable and precise
  !          1 == consider rough estimate due convergence fail, try verbose
  !          2 == basic estimates, few datapoints available
  !          3 == data looks nearly identical
  !          5 == failed to allocate memory, initial estimates are returned
  !
  ! Note.
  ! Scale parameter shouldn't confused with standard deviation.
  ! Their values are identical only in case of Normal distribution.
  !

  use rfun
  use iso_fortran_env

  implicit none
  private

  ! print debug information ?
  logical, private :: debug = .false.

  ! numerical precision of real numbers
  integer, parameter, private :: kind = selected_real_kind(15)

  ! minimal precision of results
  real(kind), parameter, private :: etol = 0.1

  ! data buffer
  real(kind), dimension(:), allocatable, private :: rho

  ! data pointer, just pointer
  real(kind), dimension(:), pointer, private :: res

  ! likelihood computations counter, debug purposes
  integer, private :: countlike

  private :: loglike, newton

  public :: iscale

contains

  subroutine iscale(r,s,reliable,flag,verbose)

    use quantilmean
    use fmm

    real(kind), dimension(:), target, intent(in) :: r
    real(kind), intent(out) :: s
    integer, intent(out), optional :: flag
    logical, intent(out), optional :: reliable
    logical, intent(in), optional :: verbose

    real(kind), parameter :: qhalf = 0.6745, qmin = 0.4, qmax = 0.87
    real(kind), dimension(:), allocatable :: xcdf, ycdf
    character(len=80) :: errmsg
    real(kind) :: s0,s1,tol,smin,smax
    integer :: n, stat
    logical :: found,converge

    debug = .false.
    if( present(verbose) ) debug = verbose

    n = size(r)
    res => r

    if( n == 0 ) then
       s = 0
       if( present(flag) ) flag = 2
       if( present(reliable) ) reliable = .false.
       return
    end if

    if( n == 1 ) then
       s = abs(res(1))
       if( present(flag) ) flag = 2
       if( present(reliable) ) reliable = .true.
       return
    end if

    if( debug ) write(*,'(a,2g13.3)') &
         'Maximum and minimum: ',minval(abs(res)),maxval(abs(res))

    allocate(xcdf(n),ycdf(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'scale: ',trim(errmsg)
       if( present(flag) ) flag = 5
       if( present(reliable) ) reliable = .false.
       return
    end if

    ! cummulative distribution function
    call ecdf(abs(res),xcdf,ycdf)

    ! keep eCDF
    block
      integer :: l
      if( debug ) then
         open(7,file='/tmp/c')
         do l = 1, n
            write(7,*) xcdf(l),ycdf(l)
         end do
         close(7)
      end if
    end block

    ! the very first, rought, estimate of scale at Q(0.6745)
    ! qhalf = 0.6745
    s0 = quantile(qhalf,xcdf,ycdf)

    ! the intial interval is determined by qmin and qmax quantiles
    ! qmin = 0.4    ! = 0.5*s
    ! qmax = 0.87   ! = 1.5*s

    ! quantile for Q(0.87) for 1.5*s0, gives upper bound
    if( qmax < ycdf(n) ) then
       smax = quantile(qmax,xcdf,ycdf)
    else ! if( Q(0.87) is out of CDF values ) then
       smax = 1.5 * s0  ! = Q(4/5) * s0
    end if

    ! quantile for Q(0.4), ycdf(1) = 1/n
    if( qmin > ycdf(1) ) then
       smin = quantile(qmin,xcdf,ycdf)
    else ! if( Q(0.4) < 1/n, interpolation undefined ) then
       smin = 0.5 * s0  ! = Q(2/5) * s0
    end if

    deallocate(xcdf,ycdf)

    if( debug ) write(*,'(a,2g13.3,a,g13.3)') &
         'Quantiles bracketing:',smin,smax,'   Initial scale:',s0

    ! check: smax > smin, s,s0 > 0, identical or zero value data
    if( (smax - smin) < 10*epsilon(s) .or. abs(smax) < 10*epsilon(s) .or. &
         abs(s0) < 10*epsilon(s) ) then
       s = s0
       if( present(flag) ) flag = 3
       if( present(reliable) ) reliable = s > epsilon(s)
       return
    end if

    allocate(rho(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'scale: ',trim(errmsg)
       if( present(flag) ) flag = 5
       if( present(reliable) ) reliable = .false.
       return
    end if

    ! Optimum determination
    ! The extreme is searched by an optimisation method without derivatives,
    ! it is reliable but slower than follow-up Newton method.
    if( debug ) then
       countlike = 0
       open(7,file='/tmp/s')
    end if
    tol = s0*etol
    s = fmin(smin,smax,loglike,tol)
    if( debug ) close(7)

    ! Does the minimum falls inside the interval smin < .. < smax ?
    found = smin + tol < s .and. s < smax - tol

    if( debug ) write(*,'(a,g20.6,a,g0.2,l2,i5)') &
         'Minimum fmin location:',s," +- ",tol,found,countlike

    if( found ) then
       ! We are attemping to do 10x more precise estimate of the scale
       ! by fast Newtons's method. The convergence success is mostly given
       ! by the proper starting point.
       s1 = s
       tol = 0.1*tol
       call newton(s1,tol,converge)
       ! Newton method is kind of root-finding metod. We are looking for
       ! maximum of a function so we work with derivatives of the function.
       ! By second derivative, we can choice if it is truly maximum
       ! (and no only minimum).
       converge = converge .and. smin + tol < s1 .and. s1 < smax - tol
       if( converge  ) s = s1
    else

       ! if minimum is not found, backup solution is used instead,
       ! it's common for few datapoints and strongly non-Normal distribution
       converge = .false.
       s = s0
    end if

    if( present(flag) ) then
       if( converge ) then
          flag = 0
       else
          flag = 1
       end if
    end if
    if( present(reliable) ) reliable = .true.

    deallocate(rho)

  end subroutine iscale

  function loglike(s)

    ! negative of likelihood per data point

    real(kind) :: loglike
    real(kind), intent(in) :: s

    if( .not. s > epsilon(s) ) then
       loglike = min(1e3*maxval(abs(res))**2,0.1*huge(loglike))
       return
    end if

    rho = itukey(res/s)
    loglike = sum(rho)/size(rho) + log(s)

    if( debug ) then
       countlike = countlike + 1
       write(7,*) s,loglike
    end if

  end function loglike


  subroutine newton(s,tol,converge)

    real(kind), intent(in) :: tol
    real(kind), intent(in out) :: s
    logical, intent(out) :: converge

    real(kind), dimension(:), allocatable :: psi, dpsi, rs
    integer :: n,it,stat
    real(kind) :: d,f,df
    character(len=80) :: errmsg

    converge = .false.

    n = size(res)
    allocate(psi(n),dpsi(n),rs(n),stat=stat,errmsg=errmsg)
    ! Computations needs a lot of additional memory,
    ! a fail-back way should be used if it is unavailable.
    if( stat /= 0 ) then
       if( debug ) write(error_unit,*) 'Newton scale: ',trim(errmsg)
       return
    end if

    ! Newton's iterations
    do it = 1, precision(s)

       if( .not. (s > epsilon(s)) ) return

       rs = res / s
       call tukeys(rs,psi,dpsi)

       f = sum(psi*rs)/n - 1
       df = - f - sum((dpsi*rs + psi)*rs)/(n*s)

       if( .not. (df < -epsilon(df)) ) exit

       ! update scale
       d = f / df
       s = s - d

       if( debug ) write(*,'(a,i2,1pg20.6,1p3g10.2)') &
            "#, s, inc., f, f': ",it,s,d,-f/s,-df/s

       ! exit of iterations: the absolute error must be at least |d| < tol
       converge = abs(d) < tol
       if( converge ) exit

    enddo

    ! second derivation of likelog is negative for a stable local minimum
    converge = converge .and. df < 0

  end subroutine newton

end module likescale

!
!  Quantile mean
!
!  Copyright © 2016-8 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!

module quantilmean

  ! Subroutine qmean() determines statistical parameters by quantiles.
  !
  ! qmean should be called as:
  !
  !  call qmean(data,mean,stderr,stdsig,flag)
  !
  ! on input:
  !   data - array of data values to be estimated
  !
  ! on output are estimated:
  !   mean - robust mean
  !   stderr (optional) - standard error
  !   stdsig (optional) - standard deviation
  !   reliable (optional) - realiable results?
  !   flag (optional) - indicates reliability of results:
  !          0 == success, results are both reliable
  !          2 == basic estimates, few datapoints available
  !          5 == failed to allocate memory, results are undefined
  !
  ! The results gives the robust estimate of the true value X
  ! of the sample x, with 68% probability, into the interval
  !
  !         mean - stderr  <  X  <  mean + stderr
  !
  ! Data distribution is approximated as Normal distribution
  !
  !          N(mean,stdsig).
  !
  ! Robust estimators has been prepared on base of
  !  * Hogg in Launer, Wilkinson: Robustness in Statistics
  !  * Hubber: Robust Statistics
  !  * my experiences

  use iso_fortran_env

  implicit none
  private

  ! numerical precision of real numbers
  integer, parameter, private :: kind = selected_real_kind(15)

  ! 50% quantil of N(0,1)
  real(kind), parameter, private :: Q50 = 0.6745

  public :: qmean, ecdf, quantile, qbracket, quantilefun

contains

  subroutine qmean(data,mean,stderr,stdsig,reliable,flag)

    ! this function computes mean, etc. by using of quantiles

    real(kind), dimension(:), intent(in) :: data
    real(kind), intent(out) :: mean
    real(kind), intent(out), optional :: stderr,stdsig
    logical, intent(out), optional :: reliable
    integer, intent(out), optional :: flag

    real(kind), dimension(3), parameter :: q = [0.25, 0.5, 0.75]
    real(kind), dimension(size(q)) :: x
    real(kind) :: sig
    integer :: n,iflag

    if( present(flag) ) flag = 6
    n = size(data)

    if( n == 0 ) then
       mean = 0
       if( present(stderr) )   stderr = 0
       if( present(stdsig) )  stdsig = 0
       if( present(reliable) ) reliable = .false.
       if( present(flag) ) flag = 2
       return

    else if( n == 1 ) then

       ! dispersion and std.err. are undefined
       mean = data(1)
       if( present(stderr) )   stderr = 0
       if( present(stdsig) )   stdsig = 0
       if( present(reliable) ) reliable = .false.
       if( present(flag) )     flag = 2
       return
    end if

    call quantilefun(data,q,x,iflag)

    if( iflag == 0 ) then

       ! mean is estimated as mean of median Q(1/2) and Q(1/4) and Q(3/4)
       mean = (x(2) + (x(1) + x(3))/2)/2

       ! standard deviation is being quantile deviation
       sig = (x(3) - x(1)) / (2*Q50)

       if( present(stdsig) ) stdsig = sig
       if( present(stderr) ) stderr = sig / sqrt(real(n))
    end if

    if( present(flag) ) flag = iflag
    if( present(reliable) ) reliable = iflag == 0 .or. iflag == 2

  end subroutine qmean


  subroutine ecdf(data,x,p)

    ! cumulative distribution function constructed from data

    use quicksorter

    real(kind),dimension(:),intent(in) :: data
    real(kind),dimension(:),intent(out) :: x,p
    integer :: i,n
    real(kind) :: h

    n = size(data)
    h = real(1,kind) / real(n + 1,kind)

    x = data
    call qsort(x)
    p = [ (i*h, i=1,n) ]

  end subroutine ecdf

  function quantile(q,x,y) result(t)

    ! estimates q-quantile, this is inverse of CDF from data

    real(kind), intent(in) :: q
    real(kind), dimension(:), intent(in) :: x,y
    real(kind) :: t,dy,h,r
    integer :: n,m,low,high

    n = size(x)

    if( n == 0 ) then
       t = 0
       return
    else if( n == 1 ) then
       t = x(1)
       return
    end if

    if( q <= y(1) ) then
       t = x(1)
    else if( q >= y(n) ) then
       t = x(n)
    else

       ! we're assuming, the input CDF has equidistant steps in y-axis
       h = real(1,kind) / real(n + 1,kind)
       r = q / h
       m = nint(r)
       if( abs(m - r) < 10*epsilon(r) ) then
          t = x(m)
       else
          low = int(r)
          high = low + 1

          dy = y(high) - y(low)
          if( abs(dy) > 10*epsilon(dy) ) then
             ! inverse by linear interpolation
             t = (x(high) - x(low))/dy*(q - y(low)) + x(low)
          else
             ! nearly singular
             t = (x(high) + x(low)) / 2
          end if
       end if
    end if
!    write(*,*) high,low,x(high),x(low),y(high),y(low)

  end function quantile

  subroutine quantilefun(data,q,x,flag)

    real(kind), dimension(:), intent(in) :: data, q
    real(kind), dimension(:), intent(out) :: x
    integer, intent(out) :: flag

    real(kind), dimension(:), allocatable :: xcdf,ycdf
    integer :: i,n,stat
    character(len=80) :: errmsg

    n = size(data)

    allocate(xcdf(n),ycdf(n),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'quantilefun: ',trim(errmsg)
       flag = 5
       return
    end if

    ! empirical cummulative distribution function of data
    call ecdf(data,xcdf,ycdf)

    ! quantiles as inverse of ecdf
    do i = 1, size(q)
       x(i) = quantile(q(i),xcdf,ycdf)
    end do

    deallocate(xcdf,ycdf)
    flag = 0

  end subroutine quantilefun

  subroutine qbracket(data,xmin,xmax,flag)

    real(kind), dimension(:), intent(in) :: data
    real(kind), intent(out) :: xmin, xmax
    integer, intent(out), optional :: flag

    real(kind), dimension(2), parameter :: q = [0.25, 0.75]
    real(kind), dimension(size(q)) :: x
    integer :: iflag

    call quantilefun(data,q,x,iflag)
    xmin = x(1)
    xmax = x(2)
    if( present(flag) ) flag = iflag

  end subroutine qbracket

end module quantilmean

!
!  Oak Leaf
!
!  Copyright © 2001 - 2018 F.Hroch (hroch@physics.muni.cz)
!
!  This file is part of OakLeaf.
!
!  OakLeaf is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Lesser General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  OakLeaf is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Lesser General Public License for more details.
!
!  You should have received a copy of the GNU Lesser General Public License
!  along with OakLeaf.  If not, see <http://www.gnu.org/licenses/>.
!
!

module oakleaf

  use iso_fortran_env
  use rfun
  use likescale
  use medians
  use madmean
  use quantilmean
  use fluxmean
  use robustline

  implicit none
  public

  interface rmean
     module procedure rmean_real64, rmean_real32, rwmean_real32, rwmean_real64
  end interface rmean

  private :: rmean_real32, rmean_real64, rwmean_real32, rwmean_real64

contains


  subroutine rmean_real32(data,mean,stderr,stdsig,scale,reliable,flag,verbose)

    ! this single precision interface, via double precision,
    ! is a little bit slower, than genuine single one,
    ! although no code is doubled.

    use robustmean

    real, dimension(:),intent(in) :: data
    real, intent(out) :: mean
    real, intent(out), optional :: stderr,stdsig,scale
    logical, intent(out), optional :: reliable
    integer, intent(out), optional :: flag
    logical, intent(in), optional :: verbose

    real(REAL64), dimension(:), allocatable :: x
    real(REAL64) :: t,s,dt,c
    integer :: iflag
    logical :: reli

    allocate(x(size(data)))
    x = data
    if( present(verbose) ) then
       call rmean_estimator(x,t,dt,s,c,reli,iflag,verbose)
    else
       call rmean_estimator(x,t,dt,s,c,reli,iflag)
    end if
    deallocate(x)
    mean = real(t)
    if( present(stderr) ) stderr = real(dt)
    if( present(stdsig) ) stdsig = real(s)
    if( present(scale) )  scale =  real(c)
    if( present(reliable) ) reliable = reli
    if( present(flag) ) flag = iflag

  end subroutine rmean_real32

  subroutine rmean_real64(data,mean,stderr,stdsig,scale,reliable,flag,verbose)

    use robustmean

    real(REAL64), dimension(:),intent(in) :: data
    real(REAL64), intent(out) :: mean
    real(REAL64), intent(out), optional :: stderr,stdsig,scale
    logical, intent(out), optional :: reliable
    integer, intent(out), optional :: flag
    logical, intent(in), optional :: verbose

    real(REAL64) :: t,s,dt,c
    integer :: iflag
    logical :: reli

    if( present(verbose) ) then
       call rmean_estimator(data,t,dt,s,c,reli,iflag,verbose)
    else
       call rmean_estimator(data,t,dt,s,c,reli,iflag)
    end if
    mean = t
    if( present(stderr) ) stderr = dt
    if( present(stdsig) ) stdsig = s
    if( present(scale) )  scale = c
    if( present(reliable) ) reliable = reli
    if( present(flag) ) flag = iflag

  end subroutine rmean_real64

  subroutine rwmean_real32(data,errors,mean,stderr,stdsig,scale, &
       reliable,flag,verbose)

    ! single precision version

    use weightedmean

    real, dimension(:),intent(in) :: data, errors
    real, intent(out) :: mean
    real, intent(out), optional :: stderr, stdsig, scale
    logical, intent(out), optional :: reliable
    integer, intent(out), optional :: flag
    logical, intent(in), optional :: verbose

    real(REAL64) :: t,dt,s,c
    real(REAL64), dimension(:), allocatable :: x,dx
    integer :: iflag, stat
    logical :: reli
    character(len=80) :: errmsg

    allocate(x(size(data)),dx(size(errors)),stat=stat,errmsg=errmsg)
    if( stat /= 0 ) then
       write(error_unit,*) 'rwmean_real32: ',trim(errmsg)
       if( present(reliable) ) reliable = .false.
       return
    end if

    x = data
    dx = errors

    if( present(verbose) ) then
       call rwmean_estimator(x,dx,t,dt,s,c,reli,iflag,verbose)
    else
       call rwmean_estimator(x,dx,t,dt,s,c,reli,iflag)
    end if

    mean = real(t)
    if( present(stderr) ) stderr = real(dt)
    if( present(stdsig) ) stdsig = real(s)
    if( present(scale) )  scale =  real(c)
    if( present(reliable) ) reliable = reli
    if( present(flag) )     flag = iflag

  end subroutine rwmean_real32

  subroutine rwmean_real64(data,errors,mean,stderr,stdsig,scale, &
       reliable,flag,verbose)

    use weightedmean

    real(REAL64), dimension(:),intent(in) :: data, errors
    real(REAL64), intent(out) :: mean
    real(REAL64), intent(out), optional :: stderr, stdsig, scale
    logical, intent(out), optional :: reliable
    integer, intent(out), optional :: flag
    logical, intent(in), optional :: verbose

    real(REAL64) :: t,dt,s,c
    integer :: iflag
    logical :: reli

    if( present(verbose) ) then
       call rwmean_estimator(data,errors,t,dt,s,c,reli,iflag,verbose)
    else
       call rwmean_estimator(data,errors,t,dt,s,c,reli,iflag)
    end if

    mean = t
    if( present(stderr) )     stderr = dt
    if( present(stdsig) )     stdsig = s
    if( present(scale) )       scale =  c
    if( present(reliable) ) reliable = reli
    if( present(flag) )         flag = iflag

  end subroutine rwmean_real64

end module oakleaf

! gfortran -I/usr/include example_fmean.f08 -loakleaf

program example_fmean

   use oakleaf
   use iso_fortran_env

   implicit none

   real(REAL64), dimension(7) :: x = [ 1.0, 2.0, 3.0, 4.0,  5.0,  6.0,  7.0 ]
   real(REAL64), dimension(7) :: y = [ 2.1, 4.0, 5.9, 7.9, 10.2, 12.0, 13.7 ]
   real(REAL64) :: t,dt,sig
   logical :: reli

   call fmean(x,sqrt(x),y,sqrt(y),t,dt,sig,reli)
   write(*,*) 'Data: ',x
   write(*,*) 'Mean: ',t
   write(*,*) 'Std.err.: ',dt
   write(*,*) 'Std.dev: ',sig
   write(*,*) 'Reliable? ',reli

 end program example_fmean

program rwsmoke

  use oakleaf
  use noise

  implicit none

  integer, parameter :: kind = selected_real_kind(15)
  character(len=80) :: amount,filename
  integer :: n,voltage

  call get_environment_variable("VOLTAGE",status=voltage)
  if( .not. (voltage == 0) ) stop 'Low voltage.'

  call get_command_argument(1,amount)
  call get_command_argument(2,filename)
  read(amount,*) n

  call run(n,filename)

contains

    subroutine run(n,filename)

    integer, intent(in) :: n
    character(len=*), intent(in) :: filename
    real(kind), dimension(n) :: data, errors
    real(kind) :: t,s,ds,c,t1,t2,total
    logical :: reliable
    character(len=80) :: name
    integer :: m,nn,flag

    total = 0
    nn = 0
    open(77,file=filename)
    do m = 1, 1000000
       call randomnoise
       call gnoise_fill(10000.0_kind,100.0_kind,data)
       call gnoise_fill(10000.0_kind,100.0_kind,errors)
       errors = sqrt(errors)
!       call random_number(errors)
!       errors = sqrt(2.0)*100*inverf(errors)
       where( errors < epsilon(errors) )
          errors = 100
       end where
!       errors = 1
!       call gnoise_fill(2.0_kind,1.0_kind,data(::10))
       call cpu_time(t1)
       call rmean(data,errors,t,ds,s,c,reliable=reliable,flag=flag)
       call cpu_time(t2)
       total = total + (t2 - t1)
       write(77,*) t,ds,s,c,flag
       if( flag /= 0 ) then
          open(22,file='/tmp/fail',position='append')
          write(22,*) data
          close(22)
          nn = nn + 1
          write(name,'(2a,i0)') trim(filename),'_',nn
          call plot(data,errors,name,t)
          call surface(data,errors,trim(name)//'_s')
          t = sum(data/errors**2)/sum(1/errors**2)
          s = sqrt(sum((t-data)**2/errors**2)/(n-1))
          c = sqrt(sum((t-data)**2)/(n-1))
          ds = sqrt(s**2/sum(1/errors**2))
          write(*,*) '# ',nn,' Arith:',t,s,ds,c
          call rmean(data,errors,t,ds,s,verbose=.true.)
!          stop
       end if
    end do
    close(77)
    write(*,'(a,f0.3)') 'Total=',total

  end subroutine run

  subroutine plot(data,errors,name,t)

    character(len=*), intent(in) :: name
    real(kind), dimension(:), intent(in) :: data, errors
    real(kind), intent(in) :: t
    integer :: n,i,j
    real(kind) :: x,s,e,w,q,e0,r,scale

    scale = 1

    n = size(data)
    open(12,file=name)
    write(12,*) '# ',data
    do i = -300, 300
       x = i / 100.0
       s = 0
       w = 0
       do j = 1, n
          s = s + tukey((x - data(j))/(errors(j)*scale))
          w = w + dtukey((x - data(j))/(errors(j)*scale))
       end do
       e = 0
       e0 = 0
       q = 0
       if( i > 0 ) then
          do j = 1, n
             r = itukey((data(j)-t)/(errors(j)*x))
             e = e + r*exp(-2.1227*r)
             r = itukey(data(j)/(errors(j)*x))
             e0 = e0 + r*exp(-2.1227*r)
             q = q + dtukey(data(j)/(errors(j)*scale))
          end do
       end if
       write(12,*) x, s/n,e/n,e0/n,w/n,q/n
    end do
    close(12)

  end subroutine plot


  subroutine surface(data,errors,name)

    real(kind), dimension(:), intent(in) :: data,errors
    character(len=*), intent(in) :: name

    real(kind), dimension(size(data)) :: r,x
    real(kind) :: t,s,d
    integer :: i,j,n

    n = size(data)

    open(48,file=name)
    do i = -30,30
       t = i / 10.0
       do j = 1,30
          s = j / 10.0
          x = (data-t)/(errors*s)
          r = itukey(x)
          d = sum(dtukey(x))
          if( abs(d) > 0*n/2.0 ) then
             write(48,*) t,s,sum(itukey(x))/n,sum(r*exp(-2.1227*r))/n, &
                  sum(tukey(x)**2)/sum(dtukey(x))**2
          end if
       end do
    end do
    close(48)

  end subroutine surface

end program rwsmoke

echo "Laplace distribution:"

NAME='/tmp/laplace'
HISTNAME=${NAME}_hist.dat
PNGNAME=${NAME}_hist.png
CDFDAT=${NAME}_cdf.dat
CDFPNG=${NAME}_cdf.png

laplace $HISTNAME $CDFDAT

# histogram
gnuplot <<EOF
set term png
set output '${PNGNAME}'
set style line 1 lt rgb "salmon3" lw 1
set style line 2 lt rgb "black" lw 1
set style fill solid 0.25 border
set key
set xrange[-5.5:5.5]
#set yrange[0:0.405]
#set xtics nomirror out ("\$-3\$" -3, "\$-2\$" -2, "\$-1\$" -1, "\$0\$" 0,"\$1\$" 1, "\$2\$" 2, "\$3\$" 3)
#set x2tics -3,1,3 format ""
#set ytics ("\$0\$" 0, "\$\\\\sfrac{1}{10}\$" 0.1, "\$\\\\sfrac{2}{10}\$" 0.2, "\$\\\\sfrac{3}{10}\$" 0.3, "\$\\\\sfrac{4}{10}\$" 0.4 )
set ylabel "Frequency"
#plot '${HISTNAME}' with boxes ls 1 t '\$\\epsilon = \\sfrac{1}{10}\$', exp(-x**2/2)/sqrt(2*pi) ls 2 t '\$\\mathcal{L}(0,1)\$
f(x,t,s) = exp(-abs(x-t)/s)/(2*s)
plot '${HISTNAME}' with boxes ls 1, f(x,0,1) ls 2 t 'L(0,1)'
EOF


echo " * histogram saved to $PNGNAME"

# CDF
gnuplot <<EOF
#set term epslatex size 4.5in,2.7in solid color
set term png
set output '$CDFPNG'
set style line 1 lt rgb "black" lw 1
set style line 2 lt rgb "red" lw 2
set key bottom
set xrange[-5.5:5.5]
#set xtics format "\$%.0f\$"
#set xtics -3,1,3
#set ytics ("\$0\$" 0, "\$\\\\sfrac{1}{4}\$" 0.25, "\$\\\\sfrac{1}{2}\$" 0.5, "\$\\\\sfrac{3}{4}\$" 0.75, "\$1\$" 1)
#set xlabel "\$x\$"
set ylabel "Probability"
p(x,t,s) = (1 + sgn(x-t)*(1 - exp(-abs(x-t)/s)))/2
plot '${CDFDAT}' w histeps lc "#52b8ff" lw 2, p(x,0,1) ls 1
EOF

echo " * CDF saved to $CDFPNG"

export VOLTAGE=high

hist()
{
    N=$1
    NAME=$2
    R --vanilla <<EOF
data <- read.table('${NAME}',header=FALSE)
png('${NAME}_mean.png')
hist(data[,1],300)
x <- seq(-3, 3, length.out=100)
sig = sqrt($N)
y <- dnorm(x,0,1/sig)*sig*sqrt(2*pi)
lines(x,y,col='blue')
dev.off()
png('${NAME}_stderr.png')
hist(data[,2],300)
dev.off()
png('${NAME}_stdsig.png')
hist(data[,3],300)
dev.off()
png('${NAME}_scale.png')
hist(data[,4],300)
# half-Normal distribution, mean is sqrt(2/pi) = 0.8
# for N=2
sig = 1/sqrt(2)
y <- sqrt(2/pi)/sig*exp(-x**2/2/sig**2)
lines(x,y,col='blue')
dev.off()
EOF
}

echo "fsmoke:" > /tmp/fsmoke.log
echo "N  T[s] dT[s]" >> /tmp/fsmoke.log
for N in 2 5 10 20 100; do
#for N in 2 3 4 5 6 7 8 9 10 20 50 100; do
#for N in 100; do
    NAME="/tmp/fsmoke$N"
    T1=$(date +'%s')
    fsmoke $N $NAME > /tmp/fsmoke${N}.log
    T=$(tail /tmp/fsmoke${N}.log | awk -F'=' '{if($0~/^Total/) { print $2; }}')
    T2=$(date +'%s')
    hist $N $NAME
    DT=$(echo "$T2 - $T1" | bc)
    echo $N $T $DT >> /tmp/fsmoke.log
done

BEGIN {
    while(getline < "head.shtml")
	print;
}
{
    # Removes lines with <html>, <body>, or DOCTYPE tags
    if( /<\/?html.*>/ || /<\/?body.*>/ || /DOCTYPE/) {
	gsub("<","[");
	gsub(">","]");
	#print "<!-- " $0 "-->";
    }
    # all others content
    else {
	print;
    }
}
END {
    while(getline < "foot.shtml")
	print;
}

./plotrfun

gnuplot <<EOF
set term png
set output 'hubers.png'
plot 'hubers', 'hubers' u 1:3, 'hubers' u 1:4
EOF

gnuplot <<EOF
set term png
set output 'tukeys.png'
plot 'tukeys', 'tukeys' u 1:3, 'tukeys' u 1:4
EOF
